#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 12
#define STATE_COUNT 204
#define LARGE_STATE_COUNT 21
#define SYMBOL_COUNT 153
#define ALIAS_COUNT 0
#define TOKEN_COUNT 95
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 0
#define MAX_ALIAS_SEQUENCE_LENGTH 6

enum {
  sym_identifier = 1,
  anon_sym_LPAREN = 2,
  anon_sym_RPAREN = 3,
  anon_sym_LBRACK_RBRACK = 4,
  anon_sym_LBRACK = 5,
  anon_sym_RBRACK = 6,
  anon_sym_DOT = 7,
  anon_sym_COMMA = 8,
  anon_sym_PLUS = 9,
  anon_sym_DASH = 10,
  anon_sym_TILDE = 11,
  anon_sym_BANG = 12,
  anon_sym_STAR = 13,
  anon_sym_SLASH = 14,
  anon_sym_PERCENT = 15,
  anon_sym_LT = 16,
  anon_sym_GT = 17,
  anon_sym_AMP = 18,
  anon_sym_CARET = 19,
  anon_sym_PIPE = 20,
  anon_sym_QMARK = 21,
  anon_sym_COLON = 22,
  sym_comment = 23,
  anon_sym_const = 24,
  anon_sym_command = 25,
  anon_sym_effect = 26,
  anon_sym_event = 27,
  anon_sym_float = 28,
  anon_sym_int = 29,
  anon_sym_itemproperty = 30,
  anon_sym_location = 31,
  anon_sym_object = 32,
  anon_sym_sqlquery = 33,
  anon_sym_string = 34,
  anon_sym_talent = 35,
  anon_sym_vector = 36,
  anon_sym_void = 37,
  anon_sym_struct = 38,
  anon_sym_SEMI = 39,
  anon_sym_case = 40,
  anon_sym_default = 41,
  anon_sym_LBRACE = 42,
  anon_sym_RBRACE = 43,
  anon_sym_else = 44,
  anon_sym_if = 45,
  anon_sym_switch = 46,
  anon_sym_while = 47,
  anon_sym_for = 48,
  sym_do_start = 49,
  anon_sym_continue = 50,
  anon_sym_break = 51,
  anon_sym_EQ = 52,
  sym_hex = 53,
  sym_integer = 54,
  sym_float = 55,
  sym_string_const = 56,
  sym_return = 57,
  sym_addeq = 58,
  sym_plusplus = 59,
  sym_subeq = 60,
  sym_minusminus = 61,
  sym_muleq = 62,
  sym_modeq = 63,
  sym_xoreq = 64,
  sym_andeq = 65,
  sym_andand = 66,
  sym_oreq = 67,
  sym_oror = 68,
  sym_noteq = 69,
  sym_eq = 70,
  sym_lteq = 71,
  sym_sleq = 72,
  sym_sl = 73,
  sym_gteq = 74,
  sym_sr = 75,
  sym_sreq = 76,
  sym_usreq = 77,
  sym_usr = 78,
  sym_pre_if = 79,
  sym_pre_else = 80,
  sym_pre_endif = 81,
  sym_pre_elif = 82,
  sym_pre_include = 83,
  sym_pre_define = 84,
  sym_pre_undef = 85,
  sym_pre_pragma = 86,
  sym_pre_ifdef = 87,
  sym_pre_ifndef = 88,
  sym_pre_warning = 89,
  sym_pre_error = 90,
  sym_object_self_const = 91,
  sym_object_invalid_const = 92,
  sym_true_const = 93,
  sym_false_const = 94,
  sym_source_file = 95,
  sym__external_declaration = 96,
  sym__primary_expression = 97,
  sym__postfix_expression = 98,
  sym_argument_expression_list = 99,
  sym__unary_expression = 100,
  sym__multiplicative_expression = 101,
  sym__additive_expression = 102,
  sym__shift_expression = 103,
  sym__relational_expression = 104,
  sym__equality_expression = 105,
  sym__and_expression = 106,
  sym__exclusive_or_expression = 107,
  sym__inclusive_or_expression = 108,
  sym__logical_and_expression = 109,
  sym__logical_or_expression = 110,
  sym__conditional_expression = 111,
  sym__assignment_expression = 112,
  sym_expression = 113,
  sym_constant_expression = 114,
  sym__qualified_type_specifier = 115,
  sym_type_specifier = 116,
  sym_statement = 117,
  sym_statement_blank_error = 118,
  sym__non_blank_statement = 119,
  sym_labelled_statement = 120,
  sym_case_statement = 121,
  sym_compound_statement = 122,
  sym_statement_list = 123,
  sym_expression_statement = 124,
  sym_selection_statement = 125,
  sym_if_else_start = 126,
  sym_if_start = 127,
  sym_switch_start = 128,
  sym_iteration_statement = 129,
  sym_for_start = 130,
  sym_for_start_start = 131,
  sym_while_start = 132,
  sym__jump_statement = 133,
  sym_return_start = 134,
  sym_declaration = 135,
  sym__init_declarator_list = 136,
  sym__init_declarator = 137,
  sym__init_declarator_identifier = 138,
  sym_function_definition = 139,
  sym_function_declarator = 140,
  sym_function_parameter_list = 141,
  sym__function_parameter_declaration = 142,
  sym_struct_definition = 143,
  sym_struct_declaration_list = 144,
  sym_struct_declaration = 145,
  sym_struct_declarator_list = 146,
  sym_assignment_operator = 147,
  sym_preprocessor_directive = 148,
  sym__preprocessor_include = 149,
  aux_sym_source_file_repeat1 = 150,
  aux_sym_statement_list_repeat1 = 151,
  aux_sym_function_parameter_list_repeat1 = 152,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_LBRACK_RBRACK] = "[]",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_DOT] = ".",
  [anon_sym_COMMA] = ",",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_TILDE] = "~",
  [anon_sym_BANG] = "!",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_PIPE] = "|",
  [anon_sym_QMARK] = "\?",
  [anon_sym_COLON] = ":",
  [sym_comment] = "comment",
  [anon_sym_const] = "const",
  [anon_sym_command] = "command",
  [anon_sym_effect] = "effect",
  [anon_sym_event] = "event",
  [anon_sym_float] = "float",
  [anon_sym_int] = "int",
  [anon_sym_itemproperty] = "itemproperty",
  [anon_sym_location] = "location",
  [anon_sym_object] = "object",
  [anon_sym_sqlquery] = "sqlquery",
  [anon_sym_string] = "string",
  [anon_sym_talent] = "talent",
  [anon_sym_vector] = "vector",
  [anon_sym_void] = "void",
  [anon_sym_struct] = "struct",
  [anon_sym_SEMI] = ";",
  [anon_sym_case] = "case",
  [anon_sym_default] = "default",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_else] = "else",
  [anon_sym_if] = "if",
  [anon_sym_switch] = "switch",
  [anon_sym_while] = "while",
  [anon_sym_for] = "for",
  [sym_do_start] = "do_start",
  [anon_sym_continue] = "continue",
  [anon_sym_break] = "break",
  [anon_sym_EQ] = "=",
  [sym_hex] = "hex",
  [sym_integer] = "integer",
  [sym_float] = "float",
  [sym_string_const] = "string_const",
  [sym_return] = "return",
  [sym_addeq] = "addeq",
  [sym_plusplus] = "plusplus",
  [sym_subeq] = "subeq",
  [sym_minusminus] = "minusminus",
  [sym_muleq] = "muleq",
  [sym_modeq] = "modeq",
  [sym_xoreq] = "xoreq",
  [sym_andeq] = "andeq",
  [sym_andand] = "andand",
  [sym_oreq] = "oreq",
  [sym_oror] = "oror",
  [sym_noteq] = "noteq",
  [sym_eq] = "eq",
  [sym_lteq] = "lteq",
  [sym_sleq] = "sleq",
  [sym_sl] = "sl",
  [sym_gteq] = "gteq",
  [sym_sr] = "sr",
  [sym_sreq] = "sreq",
  [sym_usreq] = "usreq",
  [sym_usr] = "usr",
  [sym_pre_if] = "pre_if",
  [sym_pre_else] = "pre_else",
  [sym_pre_endif] = "pre_endif",
  [sym_pre_elif] = "pre_elif",
  [sym_pre_include] = "pre_include",
  [sym_pre_define] = "pre_define",
  [sym_pre_undef] = "pre_undef",
  [sym_pre_pragma] = "pre_pragma",
  [sym_pre_ifdef] = "pre_ifdef",
  [sym_pre_ifndef] = "pre_ifndef",
  [sym_pre_warning] = "pre_warning",
  [sym_pre_error] = "pre_error",
  [sym_object_self_const] = "object_self_const",
  [sym_object_invalid_const] = "object_invalid_const",
  [sym_true_const] = "true_const",
  [sym_false_const] = "false_const",
  [sym_source_file] = "source_file",
  [sym__external_declaration] = "_external_declaration",
  [sym__primary_expression] = "_primary_expression",
  [sym__postfix_expression] = "_postfix_expression",
  [sym_argument_expression_list] = "argument_expression_list",
  [sym__unary_expression] = "_unary_expression",
  [sym__multiplicative_expression] = "_multiplicative_expression",
  [sym__additive_expression] = "_additive_expression",
  [sym__shift_expression] = "_shift_expression",
  [sym__relational_expression] = "_relational_expression",
  [sym__equality_expression] = "_equality_expression",
  [sym__and_expression] = "_and_expression",
  [sym__exclusive_or_expression] = "_exclusive_or_expression",
  [sym__inclusive_or_expression] = "_inclusive_or_expression",
  [sym__logical_and_expression] = "_logical_and_expression",
  [sym__logical_or_expression] = "_logical_or_expression",
  [sym__conditional_expression] = "_conditional_expression",
  [sym__assignment_expression] = "_assignment_expression",
  [sym_expression] = "expression",
  [sym_constant_expression] = "constant_expression",
  [sym__qualified_type_specifier] = "_qualified_type_specifier",
  [sym_type_specifier] = "type_specifier",
  [sym_statement] = "statement",
  [sym_statement_blank_error] = "statement_blank_error",
  [sym__non_blank_statement] = "_non_blank_statement",
  [sym_labelled_statement] = "labelled_statement",
  [sym_case_statement] = "case_statement",
  [sym_compound_statement] = "compound_statement",
  [sym_statement_list] = "statement_list",
  [sym_expression_statement] = "expression_statement",
  [sym_selection_statement] = "selection_statement",
  [sym_if_else_start] = "if_else_start",
  [sym_if_start] = "if_start",
  [sym_switch_start] = "switch_start",
  [sym_iteration_statement] = "iteration_statement",
  [sym_for_start] = "for_start",
  [sym_for_start_start] = "for_start_start",
  [sym_while_start] = "while_start",
  [sym__jump_statement] = "_jump_statement",
  [sym_return_start] = "return_start",
  [sym_declaration] = "declaration",
  [sym__init_declarator_list] = "_init_declarator_list",
  [sym__init_declarator] = "_init_declarator",
  [sym__init_declarator_identifier] = "_init_declarator_identifier",
  [sym_function_definition] = "function_definition",
  [sym_function_declarator] = "function_declarator",
  [sym_function_parameter_list] = "function_parameter_list",
  [sym__function_parameter_declaration] = "_function_parameter_declaration",
  [sym_struct_definition] = "struct_definition",
  [sym_struct_declaration_list] = "struct_declaration_list",
  [sym_struct_declaration] = "struct_declaration",
  [sym_struct_declarator_list] = "struct_declarator_list",
  [sym_assignment_operator] = "assignment_operator",
  [sym_preprocessor_directive] = "preprocessor_directive",
  [sym__preprocessor_include] = "_preprocessor_include",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym_statement_list_repeat1] = "statement_list_repeat1",
  [aux_sym_function_parameter_list_repeat1] = "function_parameter_list_repeat1",
};

static TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_LBRACK_RBRACK] = anon_sym_LBRACK_RBRACK,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_COLON] = anon_sym_COLON,
  [sym_comment] = sym_comment,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_command] = anon_sym_command,
  [anon_sym_effect] = anon_sym_effect,
  [anon_sym_event] = anon_sym_event,
  [anon_sym_float] = anon_sym_float,
  [anon_sym_int] = anon_sym_int,
  [anon_sym_itemproperty] = anon_sym_itemproperty,
  [anon_sym_location] = anon_sym_location,
  [anon_sym_object] = anon_sym_object,
  [anon_sym_sqlquery] = anon_sym_sqlquery,
  [anon_sym_string] = anon_sym_string,
  [anon_sym_talent] = anon_sym_talent,
  [anon_sym_vector] = anon_sym_vector,
  [anon_sym_void] = anon_sym_void,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_for] = anon_sym_for,
  [sym_do_start] = sym_do_start,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_EQ] = anon_sym_EQ,
  [sym_hex] = sym_hex,
  [sym_integer] = sym_integer,
  [sym_float] = sym_float,
  [sym_string_const] = sym_string_const,
  [sym_return] = sym_return,
  [sym_addeq] = sym_addeq,
  [sym_plusplus] = sym_plusplus,
  [sym_subeq] = sym_subeq,
  [sym_minusminus] = sym_minusminus,
  [sym_muleq] = sym_muleq,
  [sym_modeq] = sym_modeq,
  [sym_xoreq] = sym_xoreq,
  [sym_andeq] = sym_andeq,
  [sym_andand] = sym_andand,
  [sym_oreq] = sym_oreq,
  [sym_oror] = sym_oror,
  [sym_noteq] = sym_noteq,
  [sym_eq] = sym_eq,
  [sym_lteq] = sym_lteq,
  [sym_sleq] = sym_sleq,
  [sym_sl] = sym_sl,
  [sym_gteq] = sym_gteq,
  [sym_sr] = sym_sr,
  [sym_sreq] = sym_sreq,
  [sym_usreq] = sym_usreq,
  [sym_usr] = sym_usr,
  [sym_pre_if] = sym_pre_if,
  [sym_pre_else] = sym_pre_else,
  [sym_pre_endif] = sym_pre_endif,
  [sym_pre_elif] = sym_pre_elif,
  [sym_pre_include] = sym_pre_include,
  [sym_pre_define] = sym_pre_define,
  [sym_pre_undef] = sym_pre_undef,
  [sym_pre_pragma] = sym_pre_pragma,
  [sym_pre_ifdef] = sym_pre_ifdef,
  [sym_pre_ifndef] = sym_pre_ifndef,
  [sym_pre_warning] = sym_pre_warning,
  [sym_pre_error] = sym_pre_error,
  [sym_object_self_const] = sym_object_self_const,
  [sym_object_invalid_const] = sym_object_invalid_const,
  [sym_true_const] = sym_true_const,
  [sym_false_const] = sym_false_const,
  [sym_source_file] = sym_source_file,
  [sym__external_declaration] = sym__external_declaration,
  [sym__primary_expression] = sym__primary_expression,
  [sym__postfix_expression] = sym__postfix_expression,
  [sym_argument_expression_list] = sym_argument_expression_list,
  [sym__unary_expression] = sym__unary_expression,
  [sym__multiplicative_expression] = sym__multiplicative_expression,
  [sym__additive_expression] = sym__additive_expression,
  [sym__shift_expression] = sym__shift_expression,
  [sym__relational_expression] = sym__relational_expression,
  [sym__equality_expression] = sym__equality_expression,
  [sym__and_expression] = sym__and_expression,
  [sym__exclusive_or_expression] = sym__exclusive_or_expression,
  [sym__inclusive_or_expression] = sym__inclusive_or_expression,
  [sym__logical_and_expression] = sym__logical_and_expression,
  [sym__logical_or_expression] = sym__logical_or_expression,
  [sym__conditional_expression] = sym__conditional_expression,
  [sym__assignment_expression] = sym__assignment_expression,
  [sym_expression] = sym_expression,
  [sym_constant_expression] = sym_constant_expression,
  [sym__qualified_type_specifier] = sym__qualified_type_specifier,
  [sym_type_specifier] = sym_type_specifier,
  [sym_statement] = sym_statement,
  [sym_statement_blank_error] = sym_statement_blank_error,
  [sym__non_blank_statement] = sym__non_blank_statement,
  [sym_labelled_statement] = sym_labelled_statement,
  [sym_case_statement] = sym_case_statement,
  [sym_compound_statement] = sym_compound_statement,
  [sym_statement_list] = sym_statement_list,
  [sym_expression_statement] = sym_expression_statement,
  [sym_selection_statement] = sym_selection_statement,
  [sym_if_else_start] = sym_if_else_start,
  [sym_if_start] = sym_if_start,
  [sym_switch_start] = sym_switch_start,
  [sym_iteration_statement] = sym_iteration_statement,
  [sym_for_start] = sym_for_start,
  [sym_for_start_start] = sym_for_start_start,
  [sym_while_start] = sym_while_start,
  [sym__jump_statement] = sym__jump_statement,
  [sym_return_start] = sym_return_start,
  [sym_declaration] = sym_declaration,
  [sym__init_declarator_list] = sym__init_declarator_list,
  [sym__init_declarator] = sym__init_declarator,
  [sym__init_declarator_identifier] = sym__init_declarator_identifier,
  [sym_function_definition] = sym_function_definition,
  [sym_function_declarator] = sym_function_declarator,
  [sym_function_parameter_list] = sym_function_parameter_list,
  [sym__function_parameter_declaration] = sym__function_parameter_declaration,
  [sym_struct_definition] = sym_struct_definition,
  [sym_struct_declaration_list] = sym_struct_declaration_list,
  [sym_struct_declaration] = sym_struct_declaration,
  [sym_struct_declarator_list] = sym_struct_declarator_list,
  [sym_assignment_operator] = sym_assignment_operator,
  [sym_preprocessor_directive] = sym_preprocessor_directive,
  [sym__preprocessor_include] = sym__preprocessor_include,
  [aux_sym_source_file_repeat1] = aux_sym_source_file_repeat1,
  [aux_sym_statement_list_repeat1] = aux_sym_statement_list_repeat1,
  [aux_sym_function_parameter_list_repeat1] = aux_sym_function_parameter_list_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_command] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_effect] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_event] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_float] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_itemproperty] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_location] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_object] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sqlquery] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_talent] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_vector] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_void] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [sym_do_start] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [sym_hex] = {
    .visible = true,
    .named = true,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [sym_string_const] = {
    .visible = true,
    .named = true,
  },
  [sym_return] = {
    .visible = true,
    .named = true,
  },
  [sym_addeq] = {
    .visible = true,
    .named = true,
  },
  [sym_plusplus] = {
    .visible = true,
    .named = true,
  },
  [sym_subeq] = {
    .visible = true,
    .named = true,
  },
  [sym_minusminus] = {
    .visible = true,
    .named = true,
  },
  [sym_muleq] = {
    .visible = true,
    .named = true,
  },
  [sym_modeq] = {
    .visible = true,
    .named = true,
  },
  [sym_xoreq] = {
    .visible = true,
    .named = true,
  },
  [sym_andeq] = {
    .visible = true,
    .named = true,
  },
  [sym_andand] = {
    .visible = true,
    .named = true,
  },
  [sym_oreq] = {
    .visible = true,
    .named = true,
  },
  [sym_oror] = {
    .visible = true,
    .named = true,
  },
  [sym_noteq] = {
    .visible = true,
    .named = true,
  },
  [sym_eq] = {
    .visible = true,
    .named = true,
  },
  [sym_lteq] = {
    .visible = true,
    .named = true,
  },
  [sym_sleq] = {
    .visible = true,
    .named = true,
  },
  [sym_sl] = {
    .visible = true,
    .named = true,
  },
  [sym_gteq] = {
    .visible = true,
    .named = true,
  },
  [sym_sr] = {
    .visible = true,
    .named = true,
  },
  [sym_sreq] = {
    .visible = true,
    .named = true,
  },
  [sym_usreq] = {
    .visible = true,
    .named = true,
  },
  [sym_usr] = {
    .visible = true,
    .named = true,
  },
  [sym_pre_if] = {
    .visible = true,
    .named = true,
  },
  [sym_pre_else] = {
    .visible = true,
    .named = true,
  },
  [sym_pre_endif] = {
    .visible = true,
    .named = true,
  },
  [sym_pre_elif] = {
    .visible = true,
    .named = true,
  },
  [sym_pre_include] = {
    .visible = true,
    .named = true,
  },
  [sym_pre_define] = {
    .visible = true,
    .named = true,
  },
  [sym_pre_undef] = {
    .visible = true,
    .named = true,
  },
  [sym_pre_pragma] = {
    .visible = true,
    .named = true,
  },
  [sym_pre_ifdef] = {
    .visible = true,
    .named = true,
  },
  [sym_pre_ifndef] = {
    .visible = true,
    .named = true,
  },
  [sym_pre_warning] = {
    .visible = true,
    .named = true,
  },
  [sym_pre_error] = {
    .visible = true,
    .named = true,
  },
  [sym_object_self_const] = {
    .visible = true,
    .named = true,
  },
  [sym_object_invalid_const] = {
    .visible = true,
    .named = true,
  },
  [sym_true_const] = {
    .visible = true,
    .named = true,
  },
  [sym_false_const] = {
    .visible = true,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym__external_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym__primary_expression] = {
    .visible = false,
    .named = true,
  },
  [sym__postfix_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_argument_expression_list] = {
    .visible = true,
    .named = true,
  },
  [sym__unary_expression] = {
    .visible = false,
    .named = true,
  },
  [sym__multiplicative_expression] = {
    .visible = false,
    .named = true,
  },
  [sym__additive_expression] = {
    .visible = false,
    .named = true,
  },
  [sym__shift_expression] = {
    .visible = false,
    .named = true,
  },
  [sym__relational_expression] = {
    .visible = false,
    .named = true,
  },
  [sym__equality_expression] = {
    .visible = false,
    .named = true,
  },
  [sym__and_expression] = {
    .visible = false,
    .named = true,
  },
  [sym__exclusive_or_expression] = {
    .visible = false,
    .named = true,
  },
  [sym__inclusive_or_expression] = {
    .visible = false,
    .named = true,
  },
  [sym__logical_and_expression] = {
    .visible = false,
    .named = true,
  },
  [sym__logical_or_expression] = {
    .visible = false,
    .named = true,
  },
  [sym__conditional_expression] = {
    .visible = false,
    .named = true,
  },
  [sym__assignment_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__qualified_type_specifier] = {
    .visible = false,
    .named = true,
  },
  [sym_type_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_statement_blank_error] = {
    .visible = true,
    .named = true,
  },
  [sym__non_blank_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_labelled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_statement_list] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_selection_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_else_start] = {
    .visible = true,
    .named = true,
  },
  [sym_if_start] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_start] = {
    .visible = true,
    .named = true,
  },
  [sym_iteration_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_start] = {
    .visible = true,
    .named = true,
  },
  [sym_for_start_start] = {
    .visible = true,
    .named = true,
  },
  [sym_while_start] = {
    .visible = true,
    .named = true,
  },
  [sym__jump_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_return_start] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__init_declarator_list] = {
    .visible = false,
    .named = true,
  },
  [sym__init_declarator] = {
    .visible = false,
    .named = true,
  },
  [sym__init_declarator_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym__function_parameter_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_struct_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_declarator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_preprocessor_directive] = {
    .visible = true,
    .named = true,
  },
  [sym__preprocessor_include] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_statement_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
};

static TSSymbol ts_alias_sequences[1][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
};

static uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(51);
      if (lookahead == '!') ADVANCE(64);
      if (lookahead == '"') ADVANCE(3);
      if (lookahead == '#') ADVANCE(11);
      if (lookahead == '%') ADVANCE(68);
      if (lookahead == '&') ADVANCE(72);
      if (lookahead == '(') ADVANCE(52);
      if (lookahead == ')') ADVANCE(53);
      if (lookahead == '*') ADVANCE(65);
      if (lookahead == '+') ADVANCE(59);
      if (lookahead == ',') ADVANCE(58);
      if (lookahead == '-') ADVANCE(61);
      if (lookahead == '.') ADVANCE(57);
      if (lookahead == '/') ADVANCE(67);
      if (lookahead == '0') ADVANCE(85);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == ';') ADVANCE(79);
      if (lookahead == '<') ADVANCE(69);
      if (lookahead == '=') ADVANCE(82);
      if (lookahead == '>') ADVANCE(70);
      if (lookahead == '?') ADVANCE(75);
      if (lookahead == '[') ADVANCE(55);
      if (lookahead == ']') ADVANCE(56);
      if (lookahead == '^') ADVANCE(73);
      if (lookahead == '{') ADVANCE(80);
      if (lookahead == '|') ADVANCE(74);
      if (lookahead == '}') ADVANCE(81);
      if (lookahead == '~') ADVANCE(63);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(86);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(83);
      END_STATE();
    case 1:
      if (lookahead == '!') ADVANCE(64);
      if (lookahead == '"') ADVANCE(3);
      if (lookahead == '%') ADVANCE(68);
      if (lookahead == '&') ADVANCE(71);
      if (lookahead == '(') ADVANCE(52);
      if (lookahead == ')') ADVANCE(53);
      if (lookahead == '*') ADVANCE(65);
      if (lookahead == '+') ADVANCE(59);
      if (lookahead == ',') ADVANCE(58);
      if (lookahead == '-') ADVANCE(61);
      if (lookahead == '.') ADVANCE(57);
      if (lookahead == '/') ADVANCE(67);
      if (lookahead == '0') ADVANCE(85);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == ';') ADVANCE(79);
      if (lookahead == '<') ADVANCE(69);
      if (lookahead == '=') ADVANCE(82);
      if (lookahead == '>') ADVANCE(70);
      if (lookahead == '?') ADVANCE(75);
      if (lookahead == '[') ADVANCE(55);
      if (lookahead == ']') ADVANCE(56);
      if (lookahead == '^') ADVANCE(73);
      if (lookahead == '{') ADVANCE(80);
      if (lookahead == '|') ADVANCE(74);
      if (lookahead == '~') ADVANCE(63);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(1)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(86);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(83);
      END_STATE();
    case 2:
      if (lookahead == '!') ADVANCE(6);
      if (lookahead == '%') ADVANCE(68);
      if (lookahead == '&') ADVANCE(71);
      if (lookahead == ')') ADVANCE(53);
      if (lookahead == '*') ADVANCE(65);
      if (lookahead == '+') ADVANCE(60);
      if (lookahead == ',') ADVANCE(58);
      if (lookahead == '-') ADVANCE(62);
      if (lookahead == '/') ADVANCE(66);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == ';') ADVANCE(79);
      if (lookahead == '<') ADVANCE(69);
      if (lookahead == '=') ADVANCE(82);
      if (lookahead == '>') ADVANCE(70);
      if (lookahead == '?') ADVANCE(75);
      if (lookahead == '^') ADVANCE(73);
      if (lookahead == '|') ADVANCE(74);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(2)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(83);
      END_STATE();
    case 3:
      if (lookahead == '"') ADVANCE(89);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(3);
      END_STATE();
    case 4:
      if (lookahead == '*') ADVANCE(5);
      if (lookahead != 0) ADVANCE(4);
      END_STATE();
    case 5:
      if (lookahead == '/') ADVANCE(77);
      if (lookahead != 0) ADVANCE(4);
      END_STATE();
    case 6:
      if (lookahead == '=') ADVANCE(101);
      END_STATE();
    case 7:
      if (lookahead == 'a') ADVANCE(30);
      END_STATE();
    case 8:
      if (lookahead == 'a') ADVANCE(118);
      END_STATE();
    case 9:
      if (lookahead == 'a') ADVANCE(46);
      END_STATE();
    case 10:
      if (lookahead == 'c') ADVANCE(37);
      END_STATE();
    case 11:
      if (lookahead == 'd') ADVANCE(16);
      if (lookahead == 'e') ADVANCE(36);
      if (lookahead == 'i') ADVANCE(23);
      if (lookahead == 'p') ADVANCE(47);
      if (lookahead == 'u') ADVANCE(39);
      if (lookahead == 'w') ADVANCE(9);
      END_STATE();
    case 12:
      if (lookahead == 'd') ADVANCE(34);
      END_STATE();
    case 13:
      if (lookahead == 'd') ADVANCE(19);
      END_STATE();
    case 14:
      if (lookahead == 'd') ADVANCE(21);
      END_STATE();
    case 15:
      if (lookahead == 'd') ADVANCE(22);
      END_STATE();
    case 16:
      if (lookahead == 'e') ADVANCE(24);
      END_STATE();
    case 17:
      if (lookahead == 'e') ADVANCE(112);
      END_STATE();
    case 18:
      if (lookahead == 'e') ADVANCE(116);
      END_STATE();
    case 19:
      if (lookahead == 'e') ADVANCE(115);
      END_STATE();
    case 20:
      if (lookahead == 'e') ADVANCE(27);
      END_STATE();
    case 21:
      if (lookahead == 'e') ADVANCE(28);
      END_STATE();
    case 22:
      if (lookahead == 'e') ADVANCE(29);
      END_STATE();
    case 23:
      if (lookahead == 'f') ADVANCE(111);
      if (lookahead == 'n') ADVANCE(10);
      END_STATE();
    case 24:
      if (lookahead == 'f') ADVANCE(33);
      END_STATE();
    case 25:
      if (lookahead == 'f') ADVANCE(114);
      END_STATE();
    case 26:
      if (lookahead == 'f') ADVANCE(113);
      END_STATE();
    case 27:
      if (lookahead == 'f') ADVANCE(119);
      END_STATE();
    case 28:
      if (lookahead == 'f') ADVANCE(117);
      END_STATE();
    case 29:
      if (lookahead == 'f') ADVANCE(120);
      END_STATE();
    case 30:
      if (lookahead == 'g') ADVANCE(38);
      END_STATE();
    case 31:
      if (lookahead == 'g') ADVANCE(121);
      END_STATE();
    case 32:
      if (lookahead == 'i') ADVANCE(25);
      if (lookahead == 's') ADVANCE(17);
      END_STATE();
    case 33:
      if (lookahead == 'i') ADVANCE(41);
      END_STATE();
    case 34:
      if (lookahead == 'i') ADVANCE(26);
      END_STATE();
    case 35:
      if (lookahead == 'i') ADVANCE(40);
      END_STATE();
    case 36:
      if (lookahead == 'l') ADVANCE(32);
      if (lookahead == 'n') ADVANCE(12);
      if (lookahead == 'r') ADVANCE(44);
      END_STATE();
    case 37:
      if (lookahead == 'l') ADVANCE(48);
      END_STATE();
    case 38:
      if (lookahead == 'm') ADVANCE(8);
      END_STATE();
    case 39:
      if (lookahead == 'n') ADVANCE(14);
      END_STATE();
    case 40:
      if (lookahead == 'n') ADVANCE(31);
      END_STATE();
    case 41:
      if (lookahead == 'n') ADVANCE(18);
      END_STATE();
    case 42:
      if (lookahead == 'n') ADVANCE(35);
      END_STATE();
    case 43:
      if (lookahead == 'o') ADVANCE(45);
      END_STATE();
    case 44:
      if (lookahead == 'r') ADVANCE(43);
      END_STATE();
    case 45:
      if (lookahead == 'r') ADVANCE(122);
      END_STATE();
    case 46:
      if (lookahead == 'r') ADVANCE(42);
      END_STATE();
    case 47:
      if (lookahead == 'r') ADVANCE(7);
      END_STATE();
    case 48:
      if (lookahead == 'u') ADVANCE(13);
      END_STATE();
    case 49:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(88);
      END_STATE();
    case 50:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(84);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_LBRACK_RBRACK);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == ']') ADVANCE(54);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(91);
      if (lookahead == '=') ADVANCE(90);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(90);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(93);
      if (lookahead == '=') ADVANCE(92);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(92);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(101);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(94);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(4);
      if (lookahead == '/') ADVANCE(78);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(95);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(105);
      if (lookahead == '=') ADVANCE(103);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(106);
      if (lookahead == '>') ADVANCE(107);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(98);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(98);
      if (lookahead == '=') ADVANCE(97);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(96);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(99);
      if (lookahead == '|') ADVANCE(100);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(78);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(102);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(83);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(sym_hex);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(84);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(49);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(50);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(86);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(49);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(86);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(sym_float);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(87);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(88);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(sym_string_const);
      if (lookahead == '"') ADVANCE(89);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(3);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym_addeq);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(sym_plusplus);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(sym_subeq);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(sym_minusminus);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(sym_muleq);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(sym_modeq);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(sym_xoreq);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(sym_andeq);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(sym_andand);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(sym_oreq);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(sym_oror);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(sym_noteq);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(sym_eq);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(sym_lteq);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(sym_sleq);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(sym_sl);
      if (lookahead == '=') ADVANCE(104);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(sym_gteq);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(sym_sr);
      if (lookahead == '=') ADVANCE(108);
      if (lookahead == '>') ADVANCE(110);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(sym_sreq);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(sym_usreq);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(sym_usr);
      if (lookahead == '=') ADVANCE(109);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(sym_pre_if);
      if (lookahead == 'd') ADVANCE(20);
      if (lookahead == 'n') ADVANCE(15);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(sym_pre_else);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(sym_pre_endif);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(sym_pre_elif);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(sym_pre_include);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(sym_pre_define);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(sym_pre_undef);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(sym_pre_pragma);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(sym_pre_ifdef);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(sym_pre_ifndef);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(sym_pre_warning);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(sym_pre_error);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'F') ADVANCE(1);
      if (lookahead == 'O') ADVANCE(2);
      if (lookahead == 'T') ADVANCE(3);
      if (lookahead == 'b') ADVANCE(4);
      if (lookahead == 'c') ADVANCE(5);
      if (lookahead == 'd') ADVANCE(6);
      if (lookahead == 'e') ADVANCE(7);
      if (lookahead == 'f') ADVANCE(8);
      if (lookahead == 'i') ADVANCE(9);
      if (lookahead == 'l') ADVANCE(10);
      if (lookahead == 'o') ADVANCE(11);
      if (lookahead == 'r') ADVANCE(12);
      if (lookahead == 's') ADVANCE(13);
      if (lookahead == 't') ADVANCE(14);
      if (lookahead == 'v') ADVANCE(15);
      if (lookahead == 'w') ADVANCE(16);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'A') ADVANCE(17);
      END_STATE();
    case 2:
      if (lookahead == 'B') ADVANCE(18);
      END_STATE();
    case 3:
      if (lookahead == 'R') ADVANCE(19);
      END_STATE();
    case 4:
      if (lookahead == 'r') ADVANCE(20);
      END_STATE();
    case 5:
      if (lookahead == 'a') ADVANCE(21);
      if (lookahead == 'o') ADVANCE(22);
      END_STATE();
    case 6:
      if (lookahead == 'e') ADVANCE(23);
      if (lookahead == 'o') ADVANCE(24);
      END_STATE();
    case 7:
      if (lookahead == 'f') ADVANCE(25);
      if (lookahead == 'l') ADVANCE(26);
      if (lookahead == 'v') ADVANCE(27);
      END_STATE();
    case 8:
      if (lookahead == 'l') ADVANCE(28);
      if (lookahead == 'o') ADVANCE(29);
      END_STATE();
    case 9:
      if (lookahead == 'f') ADVANCE(30);
      if (lookahead == 'n') ADVANCE(31);
      if (lookahead == 't') ADVANCE(32);
      END_STATE();
    case 10:
      if (lookahead == 'o') ADVANCE(33);
      END_STATE();
    case 11:
      if (lookahead == 'b') ADVANCE(34);
      END_STATE();
    case 12:
      if (lookahead == 'e') ADVANCE(35);
      END_STATE();
    case 13:
      if (lookahead == 'q') ADVANCE(36);
      if (lookahead == 't') ADVANCE(37);
      if (lookahead == 'w') ADVANCE(38);
      END_STATE();
    case 14:
      if (lookahead == 'a') ADVANCE(39);
      END_STATE();
    case 15:
      if (lookahead == 'e') ADVANCE(40);
      if (lookahead == 'o') ADVANCE(41);
      END_STATE();
    case 16:
      if (lookahead == 'h') ADVANCE(42);
      END_STATE();
    case 17:
      if (lookahead == 'L') ADVANCE(43);
      END_STATE();
    case 18:
      if (lookahead == 'J') ADVANCE(44);
      END_STATE();
    case 19:
      if (lookahead == 'U') ADVANCE(45);
      END_STATE();
    case 20:
      if (lookahead == 'e') ADVANCE(46);
      END_STATE();
    case 21:
      if (lookahead == 's') ADVANCE(47);
      END_STATE();
    case 22:
      if (lookahead == 'm') ADVANCE(48);
      if (lookahead == 'n') ADVANCE(49);
      END_STATE();
    case 23:
      if (lookahead == 'f') ADVANCE(50);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(sym_do_start);
      END_STATE();
    case 25:
      if (lookahead == 'f') ADVANCE(51);
      END_STATE();
    case 26:
      if (lookahead == 's') ADVANCE(52);
      END_STATE();
    case 27:
      if (lookahead == 'e') ADVANCE(53);
      END_STATE();
    case 28:
      if (lookahead == 'o') ADVANCE(54);
      END_STATE();
    case 29:
      if (lookahead == 'r') ADVANCE(55);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 31:
      if (lookahead == 't') ADVANCE(56);
      END_STATE();
    case 32:
      if (lookahead == 'e') ADVANCE(57);
      END_STATE();
    case 33:
      if (lookahead == 'c') ADVANCE(58);
      END_STATE();
    case 34:
      if (lookahead == 'j') ADVANCE(59);
      END_STATE();
    case 35:
      if (lookahead == 't') ADVANCE(60);
      END_STATE();
    case 36:
      if (lookahead == 'l') ADVANCE(61);
      END_STATE();
    case 37:
      if (lookahead == 'r') ADVANCE(62);
      END_STATE();
    case 38:
      if (lookahead == 'i') ADVANCE(63);
      END_STATE();
    case 39:
      if (lookahead == 'l') ADVANCE(64);
      END_STATE();
    case 40:
      if (lookahead == 'c') ADVANCE(65);
      END_STATE();
    case 41:
      if (lookahead == 'i') ADVANCE(66);
      END_STATE();
    case 42:
      if (lookahead == 'i') ADVANCE(67);
      END_STATE();
    case 43:
      if (lookahead == 'S') ADVANCE(68);
      END_STATE();
    case 44:
      if (lookahead == 'E') ADVANCE(69);
      END_STATE();
    case 45:
      if (lookahead == 'E') ADVANCE(70);
      END_STATE();
    case 46:
      if (lookahead == 'a') ADVANCE(71);
      END_STATE();
    case 47:
      if (lookahead == 'e') ADVANCE(72);
      END_STATE();
    case 48:
      if (lookahead == 'm') ADVANCE(73);
      END_STATE();
    case 49:
      if (lookahead == 's') ADVANCE(74);
      if (lookahead == 't') ADVANCE(75);
      END_STATE();
    case 50:
      if (lookahead == 'a') ADVANCE(76);
      END_STATE();
    case 51:
      if (lookahead == 'e') ADVANCE(77);
      END_STATE();
    case 52:
      if (lookahead == 'e') ADVANCE(78);
      END_STATE();
    case 53:
      if (lookahead == 'n') ADVANCE(79);
      END_STATE();
    case 54:
      if (lookahead == 'a') ADVANCE(80);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_int);
      END_STATE();
    case 57:
      if (lookahead == 'm') ADVANCE(81);
      END_STATE();
    case 58:
      if (lookahead == 'a') ADVANCE(82);
      END_STATE();
    case 59:
      if (lookahead == 'e') ADVANCE(83);
      END_STATE();
    case 60:
      if (lookahead == 'u') ADVANCE(84);
      END_STATE();
    case 61:
      if (lookahead == 'q') ADVANCE(85);
      END_STATE();
    case 62:
      if (lookahead == 'i') ADVANCE(86);
      if (lookahead == 'u') ADVANCE(87);
      END_STATE();
    case 63:
      if (lookahead == 't') ADVANCE(88);
      END_STATE();
    case 64:
      if (lookahead == 'e') ADVANCE(89);
      END_STATE();
    case 65:
      if (lookahead == 't') ADVANCE(90);
      END_STATE();
    case 66:
      if (lookahead == 'd') ADVANCE(91);
      END_STATE();
    case 67:
      if (lookahead == 'l') ADVANCE(92);
      END_STATE();
    case 68:
      if (lookahead == 'E') ADVANCE(93);
      END_STATE();
    case 69:
      if (lookahead == 'C') ADVANCE(94);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(sym_true_const);
      END_STATE();
    case 71:
      if (lookahead == 'k') ADVANCE(95);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 73:
      if (lookahead == 'a') ADVANCE(96);
      END_STATE();
    case 74:
      if (lookahead == 't') ADVANCE(97);
      END_STATE();
    case 75:
      if (lookahead == 'i') ADVANCE(98);
      END_STATE();
    case 76:
      if (lookahead == 'u') ADVANCE(99);
      END_STATE();
    case 77:
      if (lookahead == 'c') ADVANCE(100);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 79:
      if (lookahead == 't') ADVANCE(101);
      END_STATE();
    case 80:
      if (lookahead == 't') ADVANCE(102);
      END_STATE();
    case 81:
      if (lookahead == 'p') ADVANCE(103);
      END_STATE();
    case 82:
      if (lookahead == 't') ADVANCE(104);
      END_STATE();
    case 83:
      if (lookahead == 'c') ADVANCE(105);
      END_STATE();
    case 84:
      if (lookahead == 'r') ADVANCE(106);
      END_STATE();
    case 85:
      if (lookahead == 'u') ADVANCE(107);
      END_STATE();
    case 86:
      if (lookahead == 'n') ADVANCE(108);
      END_STATE();
    case 87:
      if (lookahead == 'c') ADVANCE(109);
      END_STATE();
    case 88:
      if (lookahead == 'c') ADVANCE(110);
      END_STATE();
    case 89:
      if (lookahead == 'n') ADVANCE(111);
      END_STATE();
    case 90:
      if (lookahead == 'o') ADVANCE(112);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_void);
      END_STATE();
    case 92:
      if (lookahead == 'e') ADVANCE(113);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(sym_false_const);
      END_STATE();
    case 94:
      if (lookahead == 'T') ADVANCE(114);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 96:
      if (lookahead == 'n') ADVANCE(115);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 98:
      if (lookahead == 'n') ADVANCE(116);
      END_STATE();
    case 99:
      if (lookahead == 'l') ADVANCE(117);
      END_STATE();
    case 100:
      if (lookahead == 't') ADVANCE(118);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_event);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_float);
      END_STATE();
    case 103:
      if (lookahead == 'r') ADVANCE(119);
      END_STATE();
    case 104:
      if (lookahead == 'i') ADVANCE(120);
      END_STATE();
    case 105:
      if (lookahead == 't') ADVANCE(121);
      END_STATE();
    case 106:
      if (lookahead == 'n') ADVANCE(122);
      END_STATE();
    case 107:
      if (lookahead == 'e') ADVANCE(123);
      END_STATE();
    case 108:
      if (lookahead == 'g') ADVANCE(124);
      END_STATE();
    case 109:
      if (lookahead == 't') ADVANCE(125);
      END_STATE();
    case 110:
      if (lookahead == 'h') ADVANCE(126);
      END_STATE();
    case 111:
      if (lookahead == 't') ADVANCE(127);
      END_STATE();
    case 112:
      if (lookahead == 'r') ADVANCE(128);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 114:
      if (lookahead == '_') ADVANCE(129);
      END_STATE();
    case 115:
      if (lookahead == 'd') ADVANCE(130);
      END_STATE();
    case 116:
      if (lookahead == 'u') ADVANCE(131);
      END_STATE();
    case 117:
      if (lookahead == 't') ADVANCE(132);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_effect);
      END_STATE();
    case 119:
      if (lookahead == 'o') ADVANCE(133);
      END_STATE();
    case 120:
      if (lookahead == 'o') ADVANCE(134);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_object);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(sym_return);
      END_STATE();
    case 123:
      if (lookahead == 'r') ADVANCE(135);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_talent);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_vector);
      END_STATE();
    case 129:
      if (lookahead == 'I') ADVANCE(136);
      if (lookahead == 'S') ADVANCE(137);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_command);
      END_STATE();
    case 131:
      if (lookahead == 'e') ADVANCE(138);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 133:
      if (lookahead == 'p') ADVANCE(139);
      END_STATE();
    case 134:
      if (lookahead == 'n') ADVANCE(140);
      END_STATE();
    case 135:
      if (lookahead == 'y') ADVANCE(141);
      END_STATE();
    case 136:
      if (lookahead == 'N') ADVANCE(142);
      END_STATE();
    case 137:
      if (lookahead == 'E') ADVANCE(143);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 139:
      if (lookahead == 'e') ADVANCE(144);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_location);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_sqlquery);
      END_STATE();
    case 142:
      if (lookahead == 'V') ADVANCE(145);
      END_STATE();
    case 143:
      if (lookahead == 'L') ADVANCE(146);
      END_STATE();
    case 144:
      if (lookahead == 'r') ADVANCE(147);
      END_STATE();
    case 145:
      if (lookahead == 'A') ADVANCE(148);
      END_STATE();
    case 146:
      if (lookahead == 'F') ADVANCE(149);
      END_STATE();
    case 147:
      if (lookahead == 't') ADVANCE(150);
      END_STATE();
    case 148:
      if (lookahead == 'L') ADVANCE(151);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(sym_object_self_const);
      END_STATE();
    case 150:
      if (lookahead == 'y') ADVANCE(152);
      END_STATE();
    case 151:
      if (lookahead == 'I') ADVANCE(153);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_itemproperty);
      END_STATE();
    case 153:
      if (lookahead == 'D') ADVANCE(154);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(sym_object_invalid_const);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 0},
  [2] = {.lex_state = 0},
  [3] = {.lex_state = 0},
  [4] = {.lex_state = 0},
  [5] = {.lex_state = 0},
  [6] = {.lex_state = 0},
  [7] = {.lex_state = 0},
  [8] = {.lex_state = 0},
  [9] = {.lex_state = 0},
  [10] = {.lex_state = 1},
  [11] = {.lex_state = 1},
  [12] = {.lex_state = 1},
  [13] = {.lex_state = 1},
  [14] = {.lex_state = 1},
  [15] = {.lex_state = 1},
  [16] = {.lex_state = 1},
  [17] = {.lex_state = 1},
  [18] = {.lex_state = 1},
  [19] = {.lex_state = 1},
  [20] = {.lex_state = 1},
  [21] = {.lex_state = 0},
  [22] = {.lex_state = 0},
  [23] = {.lex_state = 1},
  [24] = {.lex_state = 1},
  [25] = {.lex_state = 1},
  [26] = {.lex_state = 1},
  [27] = {.lex_state = 1},
  [28] = {.lex_state = 1},
  [29] = {.lex_state = 1},
  [30] = {.lex_state = 1},
  [31] = {.lex_state = 1},
  [32] = {.lex_state = 0},
  [33] = {.lex_state = 0},
  [34] = {.lex_state = 0},
  [35] = {.lex_state = 0},
  [36] = {.lex_state = 0},
  [37] = {.lex_state = 0},
  [38] = {.lex_state = 0},
  [39] = {.lex_state = 0},
  [40] = {.lex_state = 0},
  [41] = {.lex_state = 2},
  [42] = {.lex_state = 0},
  [43] = {.lex_state = 0},
  [44] = {.lex_state = 0},
  [45] = {.lex_state = 0},
  [46] = {.lex_state = 0},
  [47] = {.lex_state = 0},
  [48] = {.lex_state = 0},
  [49] = {.lex_state = 0},
  [50] = {.lex_state = 0},
  [51] = {.lex_state = 0},
  [52] = {.lex_state = 0},
  [53] = {.lex_state = 0},
  [54] = {.lex_state = 2},
  [55] = {.lex_state = 0},
  [56] = {.lex_state = 0},
  [57] = {.lex_state = 0},
  [58] = {.lex_state = 0},
  [59] = {.lex_state = 0},
  [60] = {.lex_state = 0},
  [61] = {.lex_state = 0},
  [62] = {.lex_state = 0},
  [63] = {.lex_state = 0},
  [64] = {.lex_state = 0},
  [65] = {.lex_state = 0},
  [66] = {.lex_state = 2},
  [67] = {.lex_state = 2},
  [68] = {.lex_state = 2},
  [69] = {.lex_state = 0},
  [70] = {.lex_state = 0},
  [71] = {.lex_state = 2},
  [72] = {.lex_state = 0},
  [73] = {.lex_state = 0},
  [74] = {.lex_state = 0},
  [75] = {.lex_state = 0},
  [76] = {.lex_state = 2},
  [77] = {.lex_state = 0},
  [78] = {.lex_state = 0},
  [79] = {.lex_state = 0},
  [80] = {.lex_state = 0},
  [81] = {.lex_state = 0},
  [82] = {.lex_state = 0},
  [83] = {.lex_state = 0},
  [84] = {.lex_state = 0},
  [85] = {.lex_state = 0},
  [86] = {.lex_state = 0},
  [87] = {.lex_state = 1},
  [88] = {.lex_state = 0},
  [89] = {.lex_state = 0},
  [90] = {.lex_state = 0},
  [91] = {.lex_state = 1},
  [92] = {.lex_state = 0},
  [93] = {.lex_state = 0},
  [94] = {.lex_state = 1},
  [95] = {.lex_state = 0},
  [96] = {.lex_state = 0},
  [97] = {.lex_state = 1},
  [98] = {.lex_state = 0},
  [99] = {.lex_state = 0},
  [100] = {.lex_state = 0},
  [101] = {.lex_state = 0},
  [102] = {.lex_state = 0},
  [103] = {.lex_state = 0},
  [104] = {.lex_state = 0},
  [105] = {.lex_state = 0},
  [106] = {.lex_state = 1},
  [107] = {.lex_state = 0},
  [108] = {.lex_state = 0},
  [109] = {.lex_state = 1},
  [110] = {.lex_state = 0},
  [111] = {.lex_state = 0},
  [112] = {.lex_state = 1},
  [113] = {.lex_state = 1},
  [114] = {.lex_state = 0},
  [115] = {.lex_state = 0},
  [116] = {.lex_state = 0},
  [117] = {.lex_state = 0},
  [118] = {.lex_state = 0},
  [119] = {.lex_state = 0},
  [120] = {.lex_state = 0},
  [121] = {.lex_state = 0},
  [122] = {.lex_state = 0},
  [123] = {.lex_state = 0},
  [124] = {.lex_state = 0},
  [125] = {.lex_state = 0},
  [126] = {.lex_state = 0},
  [127] = {.lex_state = 0},
  [128] = {.lex_state = 0},
  [129] = {.lex_state = 0},
  [130] = {.lex_state = 0},
  [131] = {.lex_state = 0},
  [132] = {.lex_state = 0},
  [133] = {.lex_state = 0},
  [134] = {.lex_state = 0},
  [135] = {.lex_state = 0},
  [136] = {.lex_state = 0},
  [137] = {.lex_state = 0},
  [138] = {.lex_state = 0},
  [139] = {.lex_state = 0},
  [140] = {.lex_state = 0},
  [141] = {.lex_state = 0},
  [142] = {.lex_state = 0},
  [143] = {.lex_state = 0},
  [144] = {.lex_state = 0},
  [145] = {.lex_state = 0},
  [146] = {.lex_state = 0},
  [147] = {.lex_state = 0},
  [148] = {.lex_state = 0},
  [149] = {.lex_state = 0},
  [150] = {.lex_state = 0},
  [151] = {.lex_state = 0},
  [152] = {.lex_state = 0},
  [153] = {.lex_state = 0},
  [154] = {.lex_state = 0},
  [155] = {.lex_state = 0},
  [156] = {.lex_state = 0},
  [157] = {.lex_state = 0},
  [158] = {.lex_state = 0},
  [159] = {.lex_state = 0},
  [160] = {.lex_state = 0},
  [161] = {.lex_state = 0},
  [162] = {.lex_state = 0},
  [163] = {.lex_state = 0},
  [164] = {.lex_state = 0},
  [165] = {.lex_state = 0},
  [166] = {.lex_state = 0},
  [167] = {.lex_state = 0},
  [168] = {.lex_state = 0},
  [169] = {.lex_state = 0},
  [170] = {.lex_state = 0},
  [171] = {.lex_state = 0},
  [172] = {.lex_state = 0},
  [173] = {.lex_state = 0},
  [174] = {.lex_state = 0},
  [175] = {.lex_state = 0},
  [176] = {.lex_state = 0},
  [177] = {.lex_state = 0},
  [178] = {.lex_state = 0},
  [179] = {.lex_state = 0},
  [180] = {.lex_state = 0},
  [181] = {.lex_state = 0},
  [182] = {.lex_state = 0},
  [183] = {.lex_state = 0},
  [184] = {.lex_state = 0},
  [185] = {.lex_state = 0},
  [186] = {.lex_state = 0},
  [187] = {.lex_state = 0},
  [188] = {.lex_state = 0},
  [189] = {.lex_state = 0},
  [190] = {.lex_state = 0},
  [191] = {.lex_state = 0},
  [192] = {.lex_state = 0},
  [193] = {.lex_state = 0},
  [194] = {.lex_state = 0},
  [195] = {.lex_state = 0},
  [196] = {.lex_state = 0},
  [197] = {.lex_state = 0},
  [198] = {.lex_state = 0},
  [199] = {.lex_state = 0},
  [200] = {.lex_state = 0},
  [201] = {.lex_state = 0},
  [202] = {.lex_state = 0},
  [203] = {.lex_state = 0},
};

static uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [sym_comment] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_command] = ACTIONS(1),
    [anon_sym_effect] = ACTIONS(1),
    [anon_sym_event] = ACTIONS(1),
    [anon_sym_float] = ACTIONS(1),
    [anon_sym_int] = ACTIONS(1),
    [anon_sym_itemproperty] = ACTIONS(1),
    [anon_sym_location] = ACTIONS(1),
    [anon_sym_object] = ACTIONS(1),
    [anon_sym_sqlquery] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_talent] = ACTIONS(1),
    [anon_sym_vector] = ACTIONS(1),
    [anon_sym_void] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [sym_do_start] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [sym_hex] = ACTIONS(1),
    [sym_integer] = ACTIONS(1),
    [sym_float] = ACTIONS(1),
    [sym_string_const] = ACTIONS(1),
    [sym_return] = ACTIONS(1),
    [sym_addeq] = ACTIONS(1),
    [sym_plusplus] = ACTIONS(1),
    [sym_subeq] = ACTIONS(1),
    [sym_minusminus] = ACTIONS(1),
    [sym_muleq] = ACTIONS(1),
    [sym_modeq] = ACTIONS(1),
    [sym_xoreq] = ACTIONS(1),
    [sym_andeq] = ACTIONS(1),
    [sym_andand] = ACTIONS(1),
    [sym_oreq] = ACTIONS(1),
    [sym_oror] = ACTIONS(1),
    [sym_noteq] = ACTIONS(1),
    [sym_eq] = ACTIONS(1),
    [sym_lteq] = ACTIONS(1),
    [sym_sleq] = ACTIONS(1),
    [sym_sl] = ACTIONS(1),
    [sym_gteq] = ACTIONS(1),
    [sym_sr] = ACTIONS(1),
    [sym_sreq] = ACTIONS(1),
    [sym_usreq] = ACTIONS(1),
    [sym_usr] = ACTIONS(1),
    [sym_pre_if] = ACTIONS(1),
    [sym_pre_else] = ACTIONS(1),
    [sym_pre_endif] = ACTIONS(1),
    [sym_pre_elif] = ACTIONS(1),
    [sym_pre_include] = ACTIONS(1),
    [sym_pre_define] = ACTIONS(1),
    [sym_pre_undef] = ACTIONS(1),
    [sym_pre_pragma] = ACTIONS(1),
    [sym_pre_ifdef] = ACTIONS(1),
    [sym_pre_ifndef] = ACTIONS(1),
    [sym_pre_warning] = ACTIONS(1),
    [sym_pre_error] = ACTIONS(1),
    [sym_object_self_const] = ACTIONS(1),
    [sym_object_invalid_const] = ACTIONS(1),
    [sym_true_const] = ACTIONS(1),
    [sym_false_const] = ACTIONS(1),
  },
  [1] = {
    [sym_source_file] = STATE(198),
    [sym__external_declaration] = STATE(102),
    [sym__qualified_type_specifier] = STATE(151),
    [sym_type_specifier] = STATE(151),
    [sym_declaration] = STATE(102),
    [sym_function_definition] = STATE(102),
    [sym_function_declarator] = STATE(158),
    [sym_struct_definition] = STATE(102),
    [sym_preprocessor_directive] = STATE(102),
    [sym__preprocessor_include] = STATE(138),
    [aux_sym_source_file_repeat1] = STATE(102),
    [ts_builtin_sym_end] = ACTIONS(3),
    [sym_comment] = ACTIONS(5),
    [anon_sym_const] = ACTIONS(7),
    [anon_sym_command] = ACTIONS(9),
    [anon_sym_effect] = ACTIONS(9),
    [anon_sym_event] = ACTIONS(9),
    [anon_sym_float] = ACTIONS(9),
    [anon_sym_int] = ACTIONS(9),
    [anon_sym_itemproperty] = ACTIONS(9),
    [anon_sym_location] = ACTIONS(9),
    [anon_sym_object] = ACTIONS(9),
    [anon_sym_sqlquery] = ACTIONS(9),
    [anon_sym_string] = ACTIONS(9),
    [anon_sym_talent] = ACTIONS(9),
    [anon_sym_vector] = ACTIONS(9),
    [anon_sym_void] = ACTIONS(9),
    [anon_sym_struct] = ACTIONS(11),
    [sym_pre_include] = ACTIONS(13),
  },
  [2] = {
    [sym__primary_expression] = STATE(10),
    [sym__postfix_expression] = STATE(10),
    [sym__unary_expression] = STATE(41),
    [sym__multiplicative_expression] = STATE(66),
    [sym__additive_expression] = STATE(71),
    [sym__shift_expression] = STATE(87),
    [sym__relational_expression] = STATE(97),
    [sym__equality_expression] = STATE(109),
    [sym__and_expression] = STATE(113),
    [sym__exclusive_or_expression] = STATE(116),
    [sym__inclusive_or_expression] = STATE(121),
    [sym__logical_and_expression] = STATE(125),
    [sym__logical_or_expression] = STATE(129),
    [sym__conditional_expression] = STATE(55),
    [sym__assignment_expression] = STATE(55),
    [sym_expression] = STATE(169),
    [sym__qualified_type_specifier] = STATE(150),
    [sym_type_specifier] = STATE(150),
    [sym_statement] = STATE(3),
    [sym__non_blank_statement] = STATE(52),
    [sym_labelled_statement] = STATE(52),
    [sym_case_statement] = STATE(57),
    [sym_compound_statement] = STATE(52),
    [sym_statement_list] = STATE(185),
    [sym_expression_statement] = STATE(52),
    [sym_selection_statement] = STATE(52),
    [sym_if_else_start] = STATE(9),
    [sym_if_start] = STATE(8),
    [sym_switch_start] = STATE(6),
    [sym_iteration_statement] = STATE(52),
    [sym_for_start] = STATE(7),
    [sym_for_start_start] = STATE(72),
    [sym_while_start] = STATE(7),
    [sym__jump_statement] = STATE(52),
    [sym_return_start] = STATE(73),
    [sym_declaration] = STATE(52),
    [aux_sym_statement_list_repeat1] = STATE(3),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(19),
    [anon_sym_LBRACK] = ACTIONS(21),
    [anon_sym_RBRACK] = ACTIONS(19),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(25),
    [sym_comment] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_command] = ACTIONS(31),
    [anon_sym_effect] = ACTIONS(31),
    [anon_sym_event] = ACTIONS(31),
    [anon_sym_float] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_itemproperty] = ACTIONS(31),
    [anon_sym_location] = ACTIONS(31),
    [anon_sym_object] = ACTIONS(31),
    [anon_sym_sqlquery] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_talent] = ACTIONS(31),
    [anon_sym_vector] = ACTIONS(31),
    [anon_sym_void] = ACTIONS(31),
    [anon_sym_struct] = ACTIONS(33),
    [anon_sym_SEMI] = ACTIONS(27),
    [anon_sym_case] = ACTIONS(35),
    [anon_sym_default] = ACTIONS(37),
    [anon_sym_LBRACE] = ACTIONS(39),
    [anon_sym_RBRACE] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_while] = ACTIONS(47),
    [anon_sym_for] = ACTIONS(49),
    [sym_do_start] = ACTIONS(51),
    [anon_sym_continue] = ACTIONS(53),
    [anon_sym_break] = ACTIONS(53),
    [sym_hex] = ACTIONS(19),
    [sym_integer] = ACTIONS(21),
    [sym_float] = ACTIONS(19),
    [sym_string_const] = ACTIONS(19),
    [sym_return] = ACTIONS(55),
    [sym_plusplus] = ACTIONS(25),
    [sym_minusminus] = ACTIONS(25),
    [sym_object_self_const] = ACTIONS(21),
    [sym_object_invalid_const] = ACTIONS(21),
    [sym_true_const] = ACTIONS(21),
    [sym_false_const] = ACTIONS(21),
  },
  [3] = {
    [sym__primary_expression] = STATE(10),
    [sym__postfix_expression] = STATE(10),
    [sym__unary_expression] = STATE(41),
    [sym__multiplicative_expression] = STATE(66),
    [sym__additive_expression] = STATE(71),
    [sym__shift_expression] = STATE(87),
    [sym__relational_expression] = STATE(97),
    [sym__equality_expression] = STATE(109),
    [sym__and_expression] = STATE(113),
    [sym__exclusive_or_expression] = STATE(116),
    [sym__inclusive_or_expression] = STATE(121),
    [sym__logical_and_expression] = STATE(125),
    [sym__logical_or_expression] = STATE(129),
    [sym__conditional_expression] = STATE(55),
    [sym__assignment_expression] = STATE(55),
    [sym_expression] = STATE(169),
    [sym__qualified_type_specifier] = STATE(150),
    [sym_type_specifier] = STATE(150),
    [sym_statement] = STATE(4),
    [sym__non_blank_statement] = STATE(52),
    [sym_labelled_statement] = STATE(52),
    [sym_case_statement] = STATE(57),
    [sym_compound_statement] = STATE(52),
    [sym_expression_statement] = STATE(52),
    [sym_selection_statement] = STATE(52),
    [sym_if_else_start] = STATE(9),
    [sym_if_start] = STATE(8),
    [sym_switch_start] = STATE(6),
    [sym_iteration_statement] = STATE(52),
    [sym_for_start] = STATE(7),
    [sym_for_start_start] = STATE(72),
    [sym_while_start] = STATE(7),
    [sym__jump_statement] = STATE(52),
    [sym_return_start] = STATE(73),
    [sym_declaration] = STATE(52),
    [aux_sym_statement_list_repeat1] = STATE(4),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(19),
    [anon_sym_LBRACK] = ACTIONS(21),
    [anon_sym_RBRACK] = ACTIONS(19),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(25),
    [sym_comment] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_command] = ACTIONS(31),
    [anon_sym_effect] = ACTIONS(31),
    [anon_sym_event] = ACTIONS(31),
    [anon_sym_float] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_itemproperty] = ACTIONS(31),
    [anon_sym_location] = ACTIONS(31),
    [anon_sym_object] = ACTIONS(31),
    [anon_sym_sqlquery] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_talent] = ACTIONS(31),
    [anon_sym_vector] = ACTIONS(31),
    [anon_sym_void] = ACTIONS(31),
    [anon_sym_struct] = ACTIONS(33),
    [anon_sym_SEMI] = ACTIONS(27),
    [anon_sym_case] = ACTIONS(35),
    [anon_sym_default] = ACTIONS(37),
    [anon_sym_LBRACE] = ACTIONS(39),
    [anon_sym_RBRACE] = ACTIONS(57),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_while] = ACTIONS(47),
    [anon_sym_for] = ACTIONS(49),
    [sym_do_start] = ACTIONS(51),
    [anon_sym_continue] = ACTIONS(53),
    [anon_sym_break] = ACTIONS(53),
    [sym_hex] = ACTIONS(19),
    [sym_integer] = ACTIONS(21),
    [sym_float] = ACTIONS(19),
    [sym_string_const] = ACTIONS(19),
    [sym_return] = ACTIONS(55),
    [sym_plusplus] = ACTIONS(25),
    [sym_minusminus] = ACTIONS(25),
    [sym_object_self_const] = ACTIONS(21),
    [sym_object_invalid_const] = ACTIONS(21),
    [sym_true_const] = ACTIONS(21),
    [sym_false_const] = ACTIONS(21),
  },
  [4] = {
    [sym__primary_expression] = STATE(10),
    [sym__postfix_expression] = STATE(10),
    [sym__unary_expression] = STATE(41),
    [sym__multiplicative_expression] = STATE(66),
    [sym__additive_expression] = STATE(71),
    [sym__shift_expression] = STATE(87),
    [sym__relational_expression] = STATE(97),
    [sym__equality_expression] = STATE(109),
    [sym__and_expression] = STATE(113),
    [sym__exclusive_or_expression] = STATE(116),
    [sym__inclusive_or_expression] = STATE(121),
    [sym__logical_and_expression] = STATE(125),
    [sym__logical_or_expression] = STATE(129),
    [sym__conditional_expression] = STATE(55),
    [sym__assignment_expression] = STATE(55),
    [sym_expression] = STATE(169),
    [sym__qualified_type_specifier] = STATE(150),
    [sym_type_specifier] = STATE(150),
    [sym_statement] = STATE(4),
    [sym__non_blank_statement] = STATE(52),
    [sym_labelled_statement] = STATE(52),
    [sym_case_statement] = STATE(57),
    [sym_compound_statement] = STATE(52),
    [sym_expression_statement] = STATE(52),
    [sym_selection_statement] = STATE(52),
    [sym_if_else_start] = STATE(9),
    [sym_if_start] = STATE(8),
    [sym_switch_start] = STATE(6),
    [sym_iteration_statement] = STATE(52),
    [sym_for_start] = STATE(7),
    [sym_for_start_start] = STATE(72),
    [sym_while_start] = STATE(7),
    [sym__jump_statement] = STATE(52),
    [sym_return_start] = STATE(73),
    [sym_declaration] = STATE(52),
    [aux_sym_statement_list_repeat1] = STATE(4),
    [sym_identifier] = ACTIONS(59),
    [anon_sym_LPAREN] = ACTIONS(62),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(65),
    [anon_sym_LBRACK] = ACTIONS(68),
    [anon_sym_RBRACK] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_TILDE] = ACTIONS(74),
    [anon_sym_BANG] = ACTIONS(74),
    [sym_comment] = ACTIONS(77),
    [anon_sym_const] = ACTIONS(80),
    [anon_sym_command] = ACTIONS(83),
    [anon_sym_effect] = ACTIONS(83),
    [anon_sym_event] = ACTIONS(83),
    [anon_sym_float] = ACTIONS(83),
    [anon_sym_int] = ACTIONS(83),
    [anon_sym_itemproperty] = ACTIONS(83),
    [anon_sym_location] = ACTIONS(83),
    [anon_sym_object] = ACTIONS(83),
    [anon_sym_sqlquery] = ACTIONS(83),
    [anon_sym_string] = ACTIONS(83),
    [anon_sym_talent] = ACTIONS(83),
    [anon_sym_vector] = ACTIONS(83),
    [anon_sym_void] = ACTIONS(83),
    [anon_sym_struct] = ACTIONS(86),
    [anon_sym_SEMI] = ACTIONS(77),
    [anon_sym_case] = ACTIONS(89),
    [anon_sym_default] = ACTIONS(92),
    [anon_sym_LBRACE] = ACTIONS(95),
    [anon_sym_RBRACE] = ACTIONS(98),
    [anon_sym_if] = ACTIONS(100),
    [anon_sym_switch] = ACTIONS(103),
    [anon_sym_while] = ACTIONS(106),
    [anon_sym_for] = ACTIONS(109),
    [sym_do_start] = ACTIONS(112),
    [anon_sym_continue] = ACTIONS(115),
    [anon_sym_break] = ACTIONS(115),
    [sym_hex] = ACTIONS(65),
    [sym_integer] = ACTIONS(68),
    [sym_float] = ACTIONS(65),
    [sym_string_const] = ACTIONS(65),
    [sym_return] = ACTIONS(118),
    [sym_plusplus] = ACTIONS(74),
    [sym_minusminus] = ACTIONS(74),
    [sym_object_self_const] = ACTIONS(68),
    [sym_object_invalid_const] = ACTIONS(68),
    [sym_true_const] = ACTIONS(68),
    [sym_false_const] = ACTIONS(68),
  },
  [5] = {
    [sym__primary_expression] = STATE(10),
    [sym__postfix_expression] = STATE(10),
    [sym__unary_expression] = STATE(41),
    [sym__multiplicative_expression] = STATE(66),
    [sym__additive_expression] = STATE(71),
    [sym__shift_expression] = STATE(87),
    [sym__relational_expression] = STATE(97),
    [sym__equality_expression] = STATE(109),
    [sym__and_expression] = STATE(113),
    [sym__exclusive_or_expression] = STATE(116),
    [sym__inclusive_or_expression] = STATE(121),
    [sym__logical_and_expression] = STATE(125),
    [sym__logical_or_expression] = STATE(129),
    [sym__conditional_expression] = STATE(55),
    [sym__assignment_expression] = STATE(55),
    [sym_expression] = STATE(169),
    [sym__qualified_type_specifier] = STATE(150),
    [sym_type_specifier] = STATE(150),
    [sym_statement] = STATE(193),
    [sym__non_blank_statement] = STATE(52),
    [sym_labelled_statement] = STATE(52),
    [sym_case_statement] = STATE(57),
    [sym_compound_statement] = STATE(52),
    [sym_expression_statement] = STATE(52),
    [sym_selection_statement] = STATE(52),
    [sym_if_else_start] = STATE(9),
    [sym_if_start] = STATE(8),
    [sym_switch_start] = STATE(6),
    [sym_iteration_statement] = STATE(52),
    [sym_for_start] = STATE(7),
    [sym_for_start_start] = STATE(72),
    [sym_while_start] = STATE(7),
    [sym__jump_statement] = STATE(52),
    [sym_return_start] = STATE(73),
    [sym_declaration] = STATE(52),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(19),
    [anon_sym_LBRACK] = ACTIONS(21),
    [anon_sym_RBRACK] = ACTIONS(19),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(25),
    [sym_comment] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_command] = ACTIONS(31),
    [anon_sym_effect] = ACTIONS(31),
    [anon_sym_event] = ACTIONS(31),
    [anon_sym_float] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_itemproperty] = ACTIONS(31),
    [anon_sym_location] = ACTIONS(31),
    [anon_sym_object] = ACTIONS(31),
    [anon_sym_sqlquery] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_talent] = ACTIONS(31),
    [anon_sym_vector] = ACTIONS(31),
    [anon_sym_void] = ACTIONS(31),
    [anon_sym_struct] = ACTIONS(33),
    [anon_sym_SEMI] = ACTIONS(27),
    [anon_sym_case] = ACTIONS(35),
    [anon_sym_default] = ACTIONS(37),
    [anon_sym_LBRACE] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_while] = ACTIONS(47),
    [anon_sym_for] = ACTIONS(49),
    [sym_do_start] = ACTIONS(51),
    [anon_sym_continue] = ACTIONS(53),
    [anon_sym_break] = ACTIONS(53),
    [sym_hex] = ACTIONS(19),
    [sym_integer] = ACTIONS(21),
    [sym_float] = ACTIONS(19),
    [sym_string_const] = ACTIONS(19),
    [sym_return] = ACTIONS(55),
    [sym_plusplus] = ACTIONS(25),
    [sym_minusminus] = ACTIONS(25),
    [sym_object_self_const] = ACTIONS(21),
    [sym_object_invalid_const] = ACTIONS(21),
    [sym_true_const] = ACTIONS(21),
    [sym_false_const] = ACTIONS(21),
  },
  [6] = {
    [sym__primary_expression] = STATE(10),
    [sym__postfix_expression] = STATE(10),
    [sym__unary_expression] = STATE(41),
    [sym__multiplicative_expression] = STATE(66),
    [sym__additive_expression] = STATE(71),
    [sym__shift_expression] = STATE(87),
    [sym__relational_expression] = STATE(97),
    [sym__equality_expression] = STATE(109),
    [sym__and_expression] = STATE(113),
    [sym__exclusive_or_expression] = STATE(116),
    [sym__inclusive_or_expression] = STATE(121),
    [sym__logical_and_expression] = STATE(125),
    [sym__logical_or_expression] = STATE(129),
    [sym__conditional_expression] = STATE(55),
    [sym__assignment_expression] = STATE(55),
    [sym_expression] = STATE(169),
    [sym__qualified_type_specifier] = STATE(150),
    [sym_type_specifier] = STATE(150),
    [sym_statement] = STATE(47),
    [sym__non_blank_statement] = STATE(52),
    [sym_labelled_statement] = STATE(52),
    [sym_case_statement] = STATE(57),
    [sym_compound_statement] = STATE(52),
    [sym_expression_statement] = STATE(52),
    [sym_selection_statement] = STATE(52),
    [sym_if_else_start] = STATE(9),
    [sym_if_start] = STATE(8),
    [sym_switch_start] = STATE(6),
    [sym_iteration_statement] = STATE(52),
    [sym_for_start] = STATE(7),
    [sym_for_start_start] = STATE(72),
    [sym_while_start] = STATE(7),
    [sym__jump_statement] = STATE(52),
    [sym_return_start] = STATE(73),
    [sym_declaration] = STATE(52),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(19),
    [anon_sym_LBRACK] = ACTIONS(21),
    [anon_sym_RBRACK] = ACTIONS(19),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(25),
    [sym_comment] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_command] = ACTIONS(31),
    [anon_sym_effect] = ACTIONS(31),
    [anon_sym_event] = ACTIONS(31),
    [anon_sym_float] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_itemproperty] = ACTIONS(31),
    [anon_sym_location] = ACTIONS(31),
    [anon_sym_object] = ACTIONS(31),
    [anon_sym_sqlquery] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_talent] = ACTIONS(31),
    [anon_sym_vector] = ACTIONS(31),
    [anon_sym_void] = ACTIONS(31),
    [anon_sym_struct] = ACTIONS(33),
    [anon_sym_SEMI] = ACTIONS(27),
    [anon_sym_case] = ACTIONS(35),
    [anon_sym_default] = ACTIONS(37),
    [anon_sym_LBRACE] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_while] = ACTIONS(47),
    [anon_sym_for] = ACTIONS(49),
    [sym_do_start] = ACTIONS(51),
    [anon_sym_continue] = ACTIONS(53),
    [anon_sym_break] = ACTIONS(53),
    [sym_hex] = ACTIONS(19),
    [sym_integer] = ACTIONS(21),
    [sym_float] = ACTIONS(19),
    [sym_string_const] = ACTIONS(19),
    [sym_return] = ACTIONS(55),
    [sym_plusplus] = ACTIONS(25),
    [sym_minusminus] = ACTIONS(25),
    [sym_object_self_const] = ACTIONS(21),
    [sym_object_invalid_const] = ACTIONS(21),
    [sym_true_const] = ACTIONS(21),
    [sym_false_const] = ACTIONS(21),
  },
  [7] = {
    [sym__primary_expression] = STATE(10),
    [sym__postfix_expression] = STATE(10),
    [sym__unary_expression] = STATE(41),
    [sym__multiplicative_expression] = STATE(66),
    [sym__additive_expression] = STATE(71),
    [sym__shift_expression] = STATE(87),
    [sym__relational_expression] = STATE(97),
    [sym__equality_expression] = STATE(109),
    [sym__and_expression] = STATE(113),
    [sym__exclusive_or_expression] = STATE(116),
    [sym__inclusive_or_expression] = STATE(121),
    [sym__logical_and_expression] = STATE(125),
    [sym__logical_or_expression] = STATE(129),
    [sym__conditional_expression] = STATE(55),
    [sym__assignment_expression] = STATE(55),
    [sym_expression] = STATE(169),
    [sym__qualified_type_specifier] = STATE(150),
    [sym_type_specifier] = STATE(150),
    [sym_statement] = STATE(45),
    [sym__non_blank_statement] = STATE(52),
    [sym_labelled_statement] = STATE(52),
    [sym_case_statement] = STATE(57),
    [sym_compound_statement] = STATE(52),
    [sym_expression_statement] = STATE(52),
    [sym_selection_statement] = STATE(52),
    [sym_if_else_start] = STATE(9),
    [sym_if_start] = STATE(8),
    [sym_switch_start] = STATE(6),
    [sym_iteration_statement] = STATE(52),
    [sym_for_start] = STATE(7),
    [sym_for_start_start] = STATE(72),
    [sym_while_start] = STATE(7),
    [sym__jump_statement] = STATE(52),
    [sym_return_start] = STATE(73),
    [sym_declaration] = STATE(52),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(19),
    [anon_sym_LBRACK] = ACTIONS(21),
    [anon_sym_RBRACK] = ACTIONS(19),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(25),
    [sym_comment] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_command] = ACTIONS(31),
    [anon_sym_effect] = ACTIONS(31),
    [anon_sym_event] = ACTIONS(31),
    [anon_sym_float] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_itemproperty] = ACTIONS(31),
    [anon_sym_location] = ACTIONS(31),
    [anon_sym_object] = ACTIONS(31),
    [anon_sym_sqlquery] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_talent] = ACTIONS(31),
    [anon_sym_vector] = ACTIONS(31),
    [anon_sym_void] = ACTIONS(31),
    [anon_sym_struct] = ACTIONS(33),
    [anon_sym_SEMI] = ACTIONS(27),
    [anon_sym_case] = ACTIONS(35),
    [anon_sym_default] = ACTIONS(37),
    [anon_sym_LBRACE] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_while] = ACTIONS(47),
    [anon_sym_for] = ACTIONS(49),
    [sym_do_start] = ACTIONS(51),
    [anon_sym_continue] = ACTIONS(53),
    [anon_sym_break] = ACTIONS(53),
    [sym_hex] = ACTIONS(19),
    [sym_integer] = ACTIONS(21),
    [sym_float] = ACTIONS(19),
    [sym_string_const] = ACTIONS(19),
    [sym_return] = ACTIONS(55),
    [sym_plusplus] = ACTIONS(25),
    [sym_minusminus] = ACTIONS(25),
    [sym_object_self_const] = ACTIONS(21),
    [sym_object_invalid_const] = ACTIONS(21),
    [sym_true_const] = ACTIONS(21),
    [sym_false_const] = ACTIONS(21),
  },
  [8] = {
    [sym__primary_expression] = STATE(10),
    [sym__postfix_expression] = STATE(10),
    [sym__unary_expression] = STATE(41),
    [sym__multiplicative_expression] = STATE(66),
    [sym__additive_expression] = STATE(71),
    [sym__shift_expression] = STATE(87),
    [sym__relational_expression] = STATE(97),
    [sym__equality_expression] = STATE(109),
    [sym__and_expression] = STATE(113),
    [sym__exclusive_or_expression] = STATE(116),
    [sym__inclusive_or_expression] = STATE(121),
    [sym__logical_and_expression] = STATE(125),
    [sym__logical_or_expression] = STATE(129),
    [sym__conditional_expression] = STATE(55),
    [sym__assignment_expression] = STATE(55),
    [sym_expression] = STATE(169),
    [sym__qualified_type_specifier] = STATE(150),
    [sym_type_specifier] = STATE(150),
    [sym_statement_blank_error] = STATE(46),
    [sym__non_blank_statement] = STATE(48),
    [sym_labelled_statement] = STATE(48),
    [sym_case_statement] = STATE(57),
    [sym_compound_statement] = STATE(48),
    [sym_expression_statement] = STATE(48),
    [sym_selection_statement] = STATE(48),
    [sym_if_else_start] = STATE(9),
    [sym_if_start] = STATE(8),
    [sym_switch_start] = STATE(6),
    [sym_iteration_statement] = STATE(48),
    [sym_for_start] = STATE(7),
    [sym_for_start_start] = STATE(72),
    [sym_while_start] = STATE(7),
    [sym__jump_statement] = STATE(48),
    [sym_return_start] = STATE(73),
    [sym_declaration] = STATE(48),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(19),
    [anon_sym_LBRACK] = ACTIONS(21),
    [anon_sym_RBRACK] = ACTIONS(19),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_command] = ACTIONS(31),
    [anon_sym_effect] = ACTIONS(31),
    [anon_sym_event] = ACTIONS(31),
    [anon_sym_float] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_itemproperty] = ACTIONS(31),
    [anon_sym_location] = ACTIONS(31),
    [anon_sym_object] = ACTIONS(31),
    [anon_sym_sqlquery] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_talent] = ACTIONS(31),
    [anon_sym_vector] = ACTIONS(31),
    [anon_sym_void] = ACTIONS(31),
    [anon_sym_struct] = ACTIONS(33),
    [anon_sym_SEMI] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(35),
    [anon_sym_default] = ACTIONS(37),
    [anon_sym_LBRACE] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_while] = ACTIONS(47),
    [anon_sym_for] = ACTIONS(49),
    [sym_do_start] = ACTIONS(51),
    [anon_sym_continue] = ACTIONS(53),
    [anon_sym_break] = ACTIONS(53),
    [sym_hex] = ACTIONS(19),
    [sym_integer] = ACTIONS(21),
    [sym_float] = ACTIONS(19),
    [sym_string_const] = ACTIONS(19),
    [sym_return] = ACTIONS(55),
    [sym_plusplus] = ACTIONS(25),
    [sym_minusminus] = ACTIONS(25),
    [sym_object_self_const] = ACTIONS(21),
    [sym_object_invalid_const] = ACTIONS(21),
    [sym_true_const] = ACTIONS(21),
    [sym_false_const] = ACTIONS(21),
  },
  [9] = {
    [sym__primary_expression] = STATE(10),
    [sym__postfix_expression] = STATE(10),
    [sym__unary_expression] = STATE(41),
    [sym__multiplicative_expression] = STATE(66),
    [sym__additive_expression] = STATE(71),
    [sym__shift_expression] = STATE(87),
    [sym__relational_expression] = STATE(97),
    [sym__equality_expression] = STATE(109),
    [sym__and_expression] = STATE(113),
    [sym__exclusive_or_expression] = STATE(116),
    [sym__inclusive_or_expression] = STATE(121),
    [sym__logical_and_expression] = STATE(125),
    [sym__logical_or_expression] = STATE(129),
    [sym__conditional_expression] = STATE(55),
    [sym__assignment_expression] = STATE(55),
    [sym_expression] = STATE(169),
    [sym__qualified_type_specifier] = STATE(150),
    [sym_type_specifier] = STATE(150),
    [sym_statement_blank_error] = STATE(47),
    [sym__non_blank_statement] = STATE(48),
    [sym_labelled_statement] = STATE(48),
    [sym_case_statement] = STATE(57),
    [sym_compound_statement] = STATE(48),
    [sym_expression_statement] = STATE(48),
    [sym_selection_statement] = STATE(48),
    [sym_if_else_start] = STATE(9),
    [sym_if_start] = STATE(8),
    [sym_switch_start] = STATE(6),
    [sym_iteration_statement] = STATE(48),
    [sym_for_start] = STATE(7),
    [sym_for_start_start] = STATE(72),
    [sym_while_start] = STATE(7),
    [sym__jump_statement] = STATE(48),
    [sym_return_start] = STATE(73),
    [sym_declaration] = STATE(48),
    [sym_identifier] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(19),
    [anon_sym_LBRACK] = ACTIONS(21),
    [anon_sym_RBRACK] = ACTIONS(19),
    [anon_sym_PLUS] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_command] = ACTIONS(31),
    [anon_sym_effect] = ACTIONS(31),
    [anon_sym_event] = ACTIONS(31),
    [anon_sym_float] = ACTIONS(31),
    [anon_sym_int] = ACTIONS(31),
    [anon_sym_itemproperty] = ACTIONS(31),
    [anon_sym_location] = ACTIONS(31),
    [anon_sym_object] = ACTIONS(31),
    [anon_sym_sqlquery] = ACTIONS(31),
    [anon_sym_string] = ACTIONS(31),
    [anon_sym_talent] = ACTIONS(31),
    [anon_sym_vector] = ACTIONS(31),
    [anon_sym_void] = ACTIONS(31),
    [anon_sym_struct] = ACTIONS(33),
    [anon_sym_SEMI] = ACTIONS(121),
    [anon_sym_case] = ACTIONS(35),
    [anon_sym_default] = ACTIONS(37),
    [anon_sym_LBRACE] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_while] = ACTIONS(47),
    [anon_sym_for] = ACTIONS(49),
    [sym_do_start] = ACTIONS(51),
    [anon_sym_continue] = ACTIONS(53),
    [anon_sym_break] = ACTIONS(53),
    [sym_hex] = ACTIONS(19),
    [sym_integer] = ACTIONS(21),
    [sym_float] = ACTIONS(19),
    [sym_string_const] = ACTIONS(19),
    [sym_return] = ACTIONS(55),
    [sym_plusplus] = ACTIONS(25),
    [sym_minusminus] = ACTIONS(25),
    [sym_object_self_const] = ACTIONS(21),
    [sym_object_invalid_const] = ACTIONS(21),
    [sym_true_const] = ACTIONS(21),
    [sym_false_const] = ACTIONS(21),
  },
  [10] = {
    [sym_identifier] = ACTIONS(123),
    [anon_sym_LPAREN] = ACTIONS(125),
    [anon_sym_RPAREN] = ACTIONS(125),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(123),
    [anon_sym_RBRACK] = ACTIONS(125),
    [anon_sym_DOT] = ACTIONS(127),
    [anon_sym_COMMA] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(123),
    [anon_sym_DASH] = ACTIONS(123),
    [anon_sym_TILDE] = ACTIONS(125),
    [anon_sym_BANG] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(123),
    [anon_sym_SLASH] = ACTIONS(123),
    [anon_sym_PERCENT] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(123),
    [anon_sym_GT] = ACTIONS(123),
    [anon_sym_AMP] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(123),
    [anon_sym_QMARK] = ACTIONS(125),
    [anon_sym_COLON] = ACTIONS(125),
    [sym_comment] = ACTIONS(125),
    [anon_sym_const] = ACTIONS(123),
    [anon_sym_command] = ACTIONS(123),
    [anon_sym_effect] = ACTIONS(123),
    [anon_sym_event] = ACTIONS(123),
    [anon_sym_float] = ACTIONS(123),
    [anon_sym_int] = ACTIONS(123),
    [anon_sym_itemproperty] = ACTIONS(123),
    [anon_sym_location] = ACTIONS(123),
    [anon_sym_object] = ACTIONS(123),
    [anon_sym_sqlquery] = ACTIONS(123),
    [anon_sym_string] = ACTIONS(123),
    [anon_sym_talent] = ACTIONS(123),
    [anon_sym_vector] = ACTIONS(123),
    [anon_sym_void] = ACTIONS(123),
    [anon_sym_struct] = ACTIONS(123),
    [anon_sym_SEMI] = ACTIONS(125),
    [anon_sym_case] = ACTIONS(123),
    [anon_sym_default] = ACTIONS(123),
    [anon_sym_LBRACE] = ACTIONS(125),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(123),
    [anon_sym_while] = ACTIONS(123),
    [anon_sym_for] = ACTIONS(123),
    [sym_do_start] = ACTIONS(123),
    [anon_sym_continue] = ACTIONS(123),
    [anon_sym_break] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(123),
    [sym_hex] = ACTIONS(125),
    [sym_integer] = ACTIONS(123),
    [sym_float] = ACTIONS(125),
    [sym_string_const] = ACTIONS(125),
    [sym_return] = ACTIONS(123),
    [sym_addeq] = ACTIONS(125),
    [sym_plusplus] = ACTIONS(129),
    [sym_subeq] = ACTIONS(125),
    [sym_minusminus] = ACTIONS(129),
    [sym_muleq] = ACTIONS(125),
    [sym_modeq] = ACTIONS(125),
    [sym_xoreq] = ACTIONS(125),
    [sym_andand] = ACTIONS(125),
    [sym_oreq] = ACTIONS(125),
    [sym_oror] = ACTIONS(125),
    [sym_noteq] = ACTIONS(125),
    [sym_eq] = ACTIONS(125),
    [sym_lteq] = ACTIONS(125),
    [sym_sleq] = ACTIONS(125),
    [sym_sl] = ACTIONS(123),
    [sym_gteq] = ACTIONS(125),
    [sym_sr] = ACTIONS(123),
    [sym_sreq] = ACTIONS(125),
    [sym_usreq] = ACTIONS(125),
    [sym_usr] = ACTIONS(123),
    [sym_object_self_const] = ACTIONS(123),
    [sym_object_invalid_const] = ACTIONS(123),
    [sym_true_const] = ACTIONS(123),
    [sym_false_const] = ACTIONS(123),
  },
  [11] = {
    [sym_identifier] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(133),
    [anon_sym_RPAREN] = ACTIONS(133),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_RBRACK] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(133),
    [anon_sym_COMMA] = ACTIONS(133),
    [anon_sym_PLUS] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(131),
    [anon_sym_TILDE] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(131),
    [anon_sym_STAR] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(131),
    [anon_sym_PERCENT] = ACTIONS(131),
    [anon_sym_LT] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(131),
    [anon_sym_AMP] = ACTIONS(131),
    [anon_sym_CARET] = ACTIONS(131),
    [anon_sym_PIPE] = ACTIONS(131),
    [anon_sym_QMARK] = ACTIONS(133),
    [anon_sym_COLON] = ACTIONS(133),
    [sym_comment] = ACTIONS(133),
    [anon_sym_const] = ACTIONS(131),
    [anon_sym_command] = ACTIONS(131),
    [anon_sym_effect] = ACTIONS(131),
    [anon_sym_event] = ACTIONS(131),
    [anon_sym_float] = ACTIONS(131),
    [anon_sym_int] = ACTIONS(131),
    [anon_sym_itemproperty] = ACTIONS(131),
    [anon_sym_location] = ACTIONS(131),
    [anon_sym_object] = ACTIONS(131),
    [anon_sym_sqlquery] = ACTIONS(131),
    [anon_sym_string] = ACTIONS(131),
    [anon_sym_talent] = ACTIONS(131),
    [anon_sym_vector] = ACTIONS(131),
    [anon_sym_void] = ACTIONS(131),
    [anon_sym_struct] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(133),
    [anon_sym_case] = ACTIONS(131),
    [anon_sym_default] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(133),
    [anon_sym_if] = ACTIONS(131),
    [anon_sym_switch] = ACTIONS(131),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(131),
    [sym_do_start] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(131),
    [anon_sym_break] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(131),
    [sym_hex] = ACTIONS(133),
    [sym_integer] = ACTIONS(131),
    [sym_float] = ACTIONS(133),
    [sym_string_const] = ACTIONS(133),
    [sym_return] = ACTIONS(131),
    [sym_addeq] = ACTIONS(133),
    [sym_plusplus] = ACTIONS(133),
    [sym_subeq] = ACTIONS(133),
    [sym_minusminus] = ACTIONS(133),
    [sym_muleq] = ACTIONS(133),
    [sym_modeq] = ACTIONS(133),
    [sym_xoreq] = ACTIONS(133),
    [sym_andand] = ACTIONS(133),
    [sym_oreq] = ACTIONS(133),
    [sym_oror] = ACTIONS(133),
    [sym_noteq] = ACTIONS(133),
    [sym_eq] = ACTIONS(133),
    [sym_lteq] = ACTIONS(133),
    [sym_sleq] = ACTIONS(133),
    [sym_sl] = ACTIONS(131),
    [sym_gteq] = ACTIONS(133),
    [sym_sr] = ACTIONS(131),
    [sym_sreq] = ACTIONS(133),
    [sym_usreq] = ACTIONS(133),
    [sym_usr] = ACTIONS(131),
    [sym_object_self_const] = ACTIONS(131),
    [sym_object_invalid_const] = ACTIONS(131),
    [sym_true_const] = ACTIONS(131),
    [sym_false_const] = ACTIONS(131),
  },
  [12] = {
    [sym_identifier] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(137),
    [anon_sym_RPAREN] = ACTIONS(139),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(139),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(139),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(139),
    [anon_sym_COLON] = ACTIONS(139),
    [sym_comment] = ACTIONS(139),
    [anon_sym_const] = ACTIONS(135),
    [anon_sym_command] = ACTIONS(135),
    [anon_sym_effect] = ACTIONS(135),
    [anon_sym_event] = ACTIONS(135),
    [anon_sym_float] = ACTIONS(135),
    [anon_sym_int] = ACTIONS(135),
    [anon_sym_itemproperty] = ACTIONS(135),
    [anon_sym_location] = ACTIONS(135),
    [anon_sym_object] = ACTIONS(135),
    [anon_sym_sqlquery] = ACTIONS(135),
    [anon_sym_string] = ACTIONS(135),
    [anon_sym_talent] = ACTIONS(135),
    [anon_sym_vector] = ACTIONS(135),
    [anon_sym_void] = ACTIONS(135),
    [anon_sym_struct] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(139),
    [anon_sym_case] = ACTIONS(135),
    [anon_sym_default] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_if] = ACTIONS(135),
    [anon_sym_switch] = ACTIONS(135),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_for] = ACTIONS(135),
    [sym_do_start] = ACTIONS(135),
    [anon_sym_continue] = ACTIONS(135),
    [anon_sym_break] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(135),
    [sym_hex] = ACTIONS(139),
    [sym_integer] = ACTIONS(135),
    [sym_float] = ACTIONS(139),
    [sym_string_const] = ACTIONS(139),
    [sym_return] = ACTIONS(135),
    [sym_addeq] = ACTIONS(139),
    [sym_plusplus] = ACTIONS(139),
    [sym_subeq] = ACTIONS(139),
    [sym_minusminus] = ACTIONS(139),
    [sym_muleq] = ACTIONS(139),
    [sym_modeq] = ACTIONS(139),
    [sym_xoreq] = ACTIONS(139),
    [sym_andand] = ACTIONS(139),
    [sym_oreq] = ACTIONS(139),
    [sym_oror] = ACTIONS(139),
    [sym_noteq] = ACTIONS(139),
    [sym_eq] = ACTIONS(139),
    [sym_lteq] = ACTIONS(139),
    [sym_sleq] = ACTIONS(139),
    [sym_sl] = ACTIONS(135),
    [sym_gteq] = ACTIONS(139),
    [sym_sr] = ACTIONS(135),
    [sym_sreq] = ACTIONS(139),
    [sym_usreq] = ACTIONS(139),
    [sym_usr] = ACTIONS(135),
    [sym_object_self_const] = ACTIONS(135),
    [sym_object_invalid_const] = ACTIONS(135),
    [sym_true_const] = ACTIONS(135),
    [sym_false_const] = ACTIONS(135),
  },
  [13] = {
    [sym_identifier] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(143),
    [anon_sym_RPAREN] = ACTIONS(143),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(143),
    [anon_sym_LBRACK] = ACTIONS(141),
    [anon_sym_RBRACK] = ACTIONS(143),
    [anon_sym_DOT] = ACTIONS(143),
    [anon_sym_COMMA] = ACTIONS(143),
    [anon_sym_PLUS] = ACTIONS(141),
    [anon_sym_DASH] = ACTIONS(141),
    [anon_sym_TILDE] = ACTIONS(143),
    [anon_sym_BANG] = ACTIONS(141),
    [anon_sym_STAR] = ACTIONS(141),
    [anon_sym_SLASH] = ACTIONS(141),
    [anon_sym_PERCENT] = ACTIONS(141),
    [anon_sym_LT] = ACTIONS(141),
    [anon_sym_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(141),
    [anon_sym_CARET] = ACTIONS(141),
    [anon_sym_PIPE] = ACTIONS(141),
    [anon_sym_QMARK] = ACTIONS(143),
    [anon_sym_COLON] = ACTIONS(143),
    [sym_comment] = ACTIONS(143),
    [anon_sym_const] = ACTIONS(141),
    [anon_sym_command] = ACTIONS(141),
    [anon_sym_effect] = ACTIONS(141),
    [anon_sym_event] = ACTIONS(141),
    [anon_sym_float] = ACTIONS(141),
    [anon_sym_int] = ACTIONS(141),
    [anon_sym_itemproperty] = ACTIONS(141),
    [anon_sym_location] = ACTIONS(141),
    [anon_sym_object] = ACTIONS(141),
    [anon_sym_sqlquery] = ACTIONS(141),
    [anon_sym_string] = ACTIONS(141),
    [anon_sym_talent] = ACTIONS(141),
    [anon_sym_vector] = ACTIONS(141),
    [anon_sym_void] = ACTIONS(141),
    [anon_sym_struct] = ACTIONS(141),
    [anon_sym_SEMI] = ACTIONS(143),
    [anon_sym_case] = ACTIONS(141),
    [anon_sym_default] = ACTIONS(141),
    [anon_sym_LBRACE] = ACTIONS(143),
    [anon_sym_if] = ACTIONS(141),
    [anon_sym_switch] = ACTIONS(141),
    [anon_sym_while] = ACTIONS(141),
    [anon_sym_for] = ACTIONS(141),
    [sym_do_start] = ACTIONS(141),
    [anon_sym_continue] = ACTIONS(141),
    [anon_sym_break] = ACTIONS(141),
    [anon_sym_EQ] = ACTIONS(141),
    [sym_hex] = ACTIONS(143),
    [sym_integer] = ACTIONS(141),
    [sym_float] = ACTIONS(143),
    [sym_string_const] = ACTIONS(143),
    [sym_return] = ACTIONS(141),
    [sym_addeq] = ACTIONS(143),
    [sym_plusplus] = ACTIONS(143),
    [sym_subeq] = ACTIONS(143),
    [sym_minusminus] = ACTIONS(143),
    [sym_muleq] = ACTIONS(143),
    [sym_modeq] = ACTIONS(143),
    [sym_xoreq] = ACTIONS(143),
    [sym_andand] = ACTIONS(143),
    [sym_oreq] = ACTIONS(143),
    [sym_oror] = ACTIONS(143),
    [sym_noteq] = ACTIONS(143),
    [sym_eq] = ACTIONS(143),
    [sym_lteq] = ACTIONS(143),
    [sym_sleq] = ACTIONS(143),
    [sym_sl] = ACTIONS(141),
    [sym_gteq] = ACTIONS(143),
    [sym_sr] = ACTIONS(141),
    [sym_sreq] = ACTIONS(143),
    [sym_usreq] = ACTIONS(143),
    [sym_usr] = ACTIONS(141),
    [sym_object_self_const] = ACTIONS(141),
    [sym_object_invalid_const] = ACTIONS(141),
    [sym_true_const] = ACTIONS(141),
    [sym_false_const] = ACTIONS(141),
  },
  [14] = {
    [sym_identifier] = ACTIONS(145),
    [anon_sym_LPAREN] = ACTIONS(147),
    [anon_sym_RPAREN] = ACTIONS(147),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(147),
    [anon_sym_LBRACK] = ACTIONS(145),
    [anon_sym_RBRACK] = ACTIONS(147),
    [anon_sym_DOT] = ACTIONS(147),
    [anon_sym_COMMA] = ACTIONS(147),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(147),
    [anon_sym_BANG] = ACTIONS(145),
    [anon_sym_STAR] = ACTIONS(145),
    [anon_sym_SLASH] = ACTIONS(145),
    [anon_sym_PERCENT] = ACTIONS(145),
    [anon_sym_LT] = ACTIONS(145),
    [anon_sym_GT] = ACTIONS(145),
    [anon_sym_AMP] = ACTIONS(145),
    [anon_sym_CARET] = ACTIONS(145),
    [anon_sym_PIPE] = ACTIONS(145),
    [anon_sym_QMARK] = ACTIONS(147),
    [anon_sym_COLON] = ACTIONS(147),
    [sym_comment] = ACTIONS(147),
    [anon_sym_const] = ACTIONS(145),
    [anon_sym_command] = ACTIONS(145),
    [anon_sym_effect] = ACTIONS(145),
    [anon_sym_event] = ACTIONS(145),
    [anon_sym_float] = ACTIONS(145),
    [anon_sym_int] = ACTIONS(145),
    [anon_sym_itemproperty] = ACTIONS(145),
    [anon_sym_location] = ACTIONS(145),
    [anon_sym_object] = ACTIONS(145),
    [anon_sym_sqlquery] = ACTIONS(145),
    [anon_sym_string] = ACTIONS(145),
    [anon_sym_talent] = ACTIONS(145),
    [anon_sym_vector] = ACTIONS(145),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_struct] = ACTIONS(145),
    [anon_sym_SEMI] = ACTIONS(147),
    [anon_sym_case] = ACTIONS(145),
    [anon_sym_default] = ACTIONS(145),
    [anon_sym_LBRACE] = ACTIONS(147),
    [anon_sym_if] = ACTIONS(145),
    [anon_sym_switch] = ACTIONS(145),
    [anon_sym_while] = ACTIONS(145),
    [anon_sym_for] = ACTIONS(145),
    [sym_do_start] = ACTIONS(145),
    [anon_sym_continue] = ACTIONS(145),
    [anon_sym_break] = ACTIONS(145),
    [anon_sym_EQ] = ACTIONS(145),
    [sym_hex] = ACTIONS(147),
    [sym_integer] = ACTIONS(145),
    [sym_float] = ACTIONS(147),
    [sym_string_const] = ACTIONS(147),
    [sym_return] = ACTIONS(145),
    [sym_addeq] = ACTIONS(147),
    [sym_plusplus] = ACTIONS(147),
    [sym_subeq] = ACTIONS(147),
    [sym_minusminus] = ACTIONS(147),
    [sym_muleq] = ACTIONS(147),
    [sym_modeq] = ACTIONS(147),
    [sym_xoreq] = ACTIONS(147),
    [sym_andand] = ACTIONS(147),
    [sym_oreq] = ACTIONS(147),
    [sym_oror] = ACTIONS(147),
    [sym_noteq] = ACTIONS(147),
    [sym_eq] = ACTIONS(147),
    [sym_lteq] = ACTIONS(147),
    [sym_sleq] = ACTIONS(147),
    [sym_sl] = ACTIONS(145),
    [sym_gteq] = ACTIONS(147),
    [sym_sr] = ACTIONS(145),
    [sym_sreq] = ACTIONS(147),
    [sym_usreq] = ACTIONS(147),
    [sym_usr] = ACTIONS(145),
    [sym_object_self_const] = ACTIONS(145),
    [sym_object_invalid_const] = ACTIONS(145),
    [sym_true_const] = ACTIONS(145),
    [sym_false_const] = ACTIONS(145),
  },
  [15] = {
    [sym_identifier] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(151),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_RBRACK] = ACTIONS(151),
    [anon_sym_DOT] = ACTIONS(151),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_PLUS] = ACTIONS(149),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(151),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_STAR] = ACTIONS(149),
    [anon_sym_SLASH] = ACTIONS(149),
    [anon_sym_PERCENT] = ACTIONS(149),
    [anon_sym_LT] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(149),
    [anon_sym_AMP] = ACTIONS(149),
    [anon_sym_CARET] = ACTIONS(149),
    [anon_sym_PIPE] = ACTIONS(149),
    [anon_sym_QMARK] = ACTIONS(151),
    [anon_sym_COLON] = ACTIONS(151),
    [sym_comment] = ACTIONS(151),
    [anon_sym_const] = ACTIONS(149),
    [anon_sym_command] = ACTIONS(149),
    [anon_sym_effect] = ACTIONS(149),
    [anon_sym_event] = ACTIONS(149),
    [anon_sym_float] = ACTIONS(149),
    [anon_sym_int] = ACTIONS(149),
    [anon_sym_itemproperty] = ACTIONS(149),
    [anon_sym_location] = ACTIONS(149),
    [anon_sym_object] = ACTIONS(149),
    [anon_sym_sqlquery] = ACTIONS(149),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_talent] = ACTIONS(149),
    [anon_sym_vector] = ACTIONS(149),
    [anon_sym_void] = ACTIONS(149),
    [anon_sym_struct] = ACTIONS(149),
    [anon_sym_SEMI] = ACTIONS(151),
    [anon_sym_case] = ACTIONS(149),
    [anon_sym_default] = ACTIONS(149),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_switch] = ACTIONS(149),
    [anon_sym_while] = ACTIONS(149),
    [anon_sym_for] = ACTIONS(149),
    [sym_do_start] = ACTIONS(149),
    [anon_sym_continue] = ACTIONS(149),
    [anon_sym_break] = ACTIONS(149),
    [anon_sym_EQ] = ACTIONS(149),
    [sym_hex] = ACTIONS(151),
    [sym_integer] = ACTIONS(149),
    [sym_float] = ACTIONS(151),
    [sym_string_const] = ACTIONS(151),
    [sym_return] = ACTIONS(149),
    [sym_addeq] = ACTIONS(151),
    [sym_plusplus] = ACTIONS(151),
    [sym_subeq] = ACTIONS(151),
    [sym_minusminus] = ACTIONS(151),
    [sym_muleq] = ACTIONS(151),
    [sym_modeq] = ACTIONS(151),
    [sym_xoreq] = ACTIONS(151),
    [sym_andand] = ACTIONS(151),
    [sym_oreq] = ACTIONS(151),
    [sym_oror] = ACTIONS(151),
    [sym_noteq] = ACTIONS(151),
    [sym_eq] = ACTIONS(151),
    [sym_lteq] = ACTIONS(151),
    [sym_sleq] = ACTIONS(151),
    [sym_sl] = ACTIONS(149),
    [sym_gteq] = ACTIONS(151),
    [sym_sr] = ACTIONS(149),
    [sym_sreq] = ACTIONS(151),
    [sym_usreq] = ACTIONS(151),
    [sym_usr] = ACTIONS(149),
    [sym_object_self_const] = ACTIONS(149),
    [sym_object_invalid_const] = ACTIONS(149),
    [sym_true_const] = ACTIONS(149),
    [sym_false_const] = ACTIONS(149),
  },
  [16] = {
    [sym_assignment_operator] = STATE(85),
    [sym_identifier] = ACTIONS(153),
    [anon_sym_LPAREN] = ACTIONS(155),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_RBRACK] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(153),
    [anon_sym_DASH] = ACTIONS(153),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(153),
    [anon_sym_STAR] = ACTIONS(153),
    [anon_sym_SLASH] = ACTIONS(153),
    [anon_sym_PERCENT] = ACTIONS(153),
    [anon_sym_LT] = ACTIONS(153),
    [anon_sym_GT] = ACTIONS(153),
    [anon_sym_AMP] = ACTIONS(153),
    [anon_sym_CARET] = ACTIONS(153),
    [anon_sym_PIPE] = ACTIONS(153),
    [anon_sym_QMARK] = ACTIONS(155),
    [sym_comment] = ACTIONS(155),
    [anon_sym_const] = ACTIONS(153),
    [anon_sym_command] = ACTIONS(153),
    [anon_sym_effect] = ACTIONS(153),
    [anon_sym_event] = ACTIONS(153),
    [anon_sym_float] = ACTIONS(153),
    [anon_sym_int] = ACTIONS(153),
    [anon_sym_itemproperty] = ACTIONS(153),
    [anon_sym_location] = ACTIONS(153),
    [anon_sym_object] = ACTIONS(153),
    [anon_sym_sqlquery] = ACTIONS(153),
    [anon_sym_string] = ACTIONS(153),
    [anon_sym_talent] = ACTIONS(153),
    [anon_sym_vector] = ACTIONS(153),
    [anon_sym_void] = ACTIONS(153),
    [anon_sym_struct] = ACTIONS(153),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_case] = ACTIONS(153),
    [anon_sym_default] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_switch] = ACTIONS(153),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_for] = ACTIONS(153),
    [sym_do_start] = ACTIONS(153),
    [anon_sym_continue] = ACTIONS(153),
    [anon_sym_break] = ACTIONS(153),
    [anon_sym_EQ] = ACTIONS(157),
    [sym_hex] = ACTIONS(155),
    [sym_integer] = ACTIONS(153),
    [sym_float] = ACTIONS(155),
    [sym_string_const] = ACTIONS(155),
    [sym_return] = ACTIONS(153),
    [sym_addeq] = ACTIONS(159),
    [sym_plusplus] = ACTIONS(155),
    [sym_subeq] = ACTIONS(159),
    [sym_minusminus] = ACTIONS(155),
    [sym_muleq] = ACTIONS(159),
    [sym_modeq] = ACTIONS(159),
    [sym_xoreq] = ACTIONS(159),
    [sym_andand] = ACTIONS(155),
    [sym_oreq] = ACTIONS(159),
    [sym_oror] = ACTIONS(155),
    [sym_noteq] = ACTIONS(155),
    [sym_eq] = ACTIONS(155),
    [sym_lteq] = ACTIONS(155),
    [sym_sleq] = ACTIONS(159),
    [sym_sl] = ACTIONS(153),
    [sym_gteq] = ACTIONS(155),
    [sym_sr] = ACTIONS(153),
    [sym_sreq] = ACTIONS(159),
    [sym_usreq] = ACTIONS(159),
    [sym_usr] = ACTIONS(153),
    [sym_object_self_const] = ACTIONS(153),
    [sym_object_invalid_const] = ACTIONS(153),
    [sym_true_const] = ACTIONS(153),
    [sym_false_const] = ACTIONS(153),
  },
  [17] = {
    [sym_identifier] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(163),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(161),
    [anon_sym_RBRACK] = ACTIONS(163),
    [anon_sym_PLUS] = ACTIONS(161),
    [anon_sym_DASH] = ACTIONS(161),
    [anon_sym_TILDE] = ACTIONS(163),
    [anon_sym_BANG] = ACTIONS(161),
    [anon_sym_STAR] = ACTIONS(161),
    [anon_sym_SLASH] = ACTIONS(161),
    [anon_sym_PERCENT] = ACTIONS(161),
    [anon_sym_LT] = ACTIONS(161),
    [anon_sym_GT] = ACTIONS(161),
    [anon_sym_AMP] = ACTIONS(161),
    [anon_sym_CARET] = ACTIONS(161),
    [anon_sym_PIPE] = ACTIONS(161),
    [anon_sym_QMARK] = ACTIONS(163),
    [sym_comment] = ACTIONS(163),
    [anon_sym_const] = ACTIONS(161),
    [anon_sym_command] = ACTIONS(161),
    [anon_sym_effect] = ACTIONS(161),
    [anon_sym_event] = ACTIONS(161),
    [anon_sym_float] = ACTIONS(161),
    [anon_sym_int] = ACTIONS(161),
    [anon_sym_itemproperty] = ACTIONS(161),
    [anon_sym_location] = ACTIONS(161),
    [anon_sym_object] = ACTIONS(161),
    [anon_sym_sqlquery] = ACTIONS(161),
    [anon_sym_string] = ACTIONS(161),
    [anon_sym_talent] = ACTIONS(161),
    [anon_sym_vector] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(161),
    [anon_sym_struct] = ACTIONS(161),
    [anon_sym_SEMI] = ACTIONS(163),
    [anon_sym_case] = ACTIONS(161),
    [anon_sym_default] = ACTIONS(161),
    [anon_sym_LBRACE] = ACTIONS(163),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_switch] = ACTIONS(161),
    [anon_sym_while] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(161),
    [sym_do_start] = ACTIONS(161),
    [anon_sym_continue] = ACTIONS(161),
    [anon_sym_break] = ACTIONS(161),
    [anon_sym_EQ] = ACTIONS(161),
    [sym_hex] = ACTIONS(163),
    [sym_integer] = ACTIONS(161),
    [sym_float] = ACTIONS(163),
    [sym_string_const] = ACTIONS(163),
    [sym_return] = ACTIONS(161),
    [sym_addeq] = ACTIONS(163),
    [sym_plusplus] = ACTIONS(163),
    [sym_subeq] = ACTIONS(163),
    [sym_minusminus] = ACTIONS(163),
    [sym_muleq] = ACTIONS(163),
    [sym_modeq] = ACTIONS(163),
    [sym_xoreq] = ACTIONS(163),
    [sym_andand] = ACTIONS(163),
    [sym_oreq] = ACTIONS(163),
    [sym_oror] = ACTIONS(163),
    [sym_noteq] = ACTIONS(163),
    [sym_eq] = ACTIONS(163),
    [sym_lteq] = ACTIONS(163),
    [sym_sleq] = ACTIONS(163),
    [sym_sl] = ACTIONS(161),
    [sym_gteq] = ACTIONS(163),
    [sym_sr] = ACTIONS(161),
    [sym_sreq] = ACTIONS(163),
    [sym_usreq] = ACTIONS(163),
    [sym_usr] = ACTIONS(161),
    [sym_object_self_const] = ACTIONS(161),
    [sym_object_invalid_const] = ACTIONS(161),
    [sym_true_const] = ACTIONS(161),
    [sym_false_const] = ACTIONS(161),
  },
  [18] = {
    [sym_identifier] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(167),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(167),
    [anon_sym_LBRACK] = ACTIONS(165),
    [anon_sym_RBRACK] = ACTIONS(167),
    [anon_sym_PLUS] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(165),
    [anon_sym_TILDE] = ACTIONS(167),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_SLASH] = ACTIONS(171),
    [anon_sym_PERCENT] = ACTIONS(169),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_AMP] = ACTIONS(165),
    [anon_sym_CARET] = ACTIONS(167),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_QMARK] = ACTIONS(167),
    [sym_comment] = ACTIONS(167),
    [anon_sym_const] = ACTIONS(165),
    [anon_sym_command] = ACTIONS(165),
    [anon_sym_effect] = ACTIONS(165),
    [anon_sym_event] = ACTIONS(165),
    [anon_sym_float] = ACTIONS(165),
    [anon_sym_int] = ACTIONS(165),
    [anon_sym_itemproperty] = ACTIONS(165),
    [anon_sym_location] = ACTIONS(165),
    [anon_sym_object] = ACTIONS(165),
    [anon_sym_sqlquery] = ACTIONS(165),
    [anon_sym_string] = ACTIONS(165),
    [anon_sym_talent] = ACTIONS(165),
    [anon_sym_vector] = ACTIONS(165),
    [anon_sym_void] = ACTIONS(165),
    [anon_sym_struct] = ACTIONS(165),
    [anon_sym_SEMI] = ACTIONS(167),
    [anon_sym_case] = ACTIONS(165),
    [anon_sym_default] = ACTIONS(165),
    [anon_sym_LBRACE] = ACTIONS(167),
    [anon_sym_if] = ACTIONS(165),
    [anon_sym_switch] = ACTIONS(165),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_for] = ACTIONS(165),
    [sym_do_start] = ACTIONS(165),
    [anon_sym_continue] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(165),
    [sym_hex] = ACTIONS(167),
    [sym_integer] = ACTIONS(165),
    [sym_float] = ACTIONS(167),
    [sym_string_const] = ACTIONS(167),
    [sym_return] = ACTIONS(165),
    [sym_plusplus] = ACTIONS(167),
    [sym_minusminus] = ACTIONS(167),
    [sym_andand] = ACTIONS(167),
    [sym_oror] = ACTIONS(167),
    [sym_noteq] = ACTIONS(167),
    [sym_eq] = ACTIONS(167),
    [sym_lteq] = ACTIONS(167),
    [sym_sl] = ACTIONS(167),
    [sym_gteq] = ACTIONS(167),
    [sym_sr] = ACTIONS(165),
    [sym_usr] = ACTIONS(167),
    [sym_object_self_const] = ACTIONS(165),
    [sym_object_invalid_const] = ACTIONS(165),
    [sym_true_const] = ACTIONS(165),
    [sym_false_const] = ACTIONS(165),
  },
  [19] = {
    [sym_identifier] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(175),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_RBRACK] = ACTIONS(175),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(175),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_STAR] = ACTIONS(175),
    [anon_sym_SLASH] = ACTIONS(173),
    [anon_sym_PERCENT] = ACTIONS(175),
    [anon_sym_LT] = ACTIONS(173),
    [anon_sym_GT] = ACTIONS(173),
    [anon_sym_AMP] = ACTIONS(173),
    [anon_sym_CARET] = ACTIONS(175),
    [anon_sym_PIPE] = ACTIONS(173),
    [anon_sym_QMARK] = ACTIONS(175),
    [sym_comment] = ACTIONS(175),
    [anon_sym_const] = ACTIONS(173),
    [anon_sym_command] = ACTIONS(173),
    [anon_sym_effect] = ACTIONS(173),
    [anon_sym_event] = ACTIONS(173),
    [anon_sym_float] = ACTIONS(173),
    [anon_sym_int] = ACTIONS(173),
    [anon_sym_itemproperty] = ACTIONS(173),
    [anon_sym_location] = ACTIONS(173),
    [anon_sym_object] = ACTIONS(173),
    [anon_sym_sqlquery] = ACTIONS(173),
    [anon_sym_string] = ACTIONS(173),
    [anon_sym_talent] = ACTIONS(173),
    [anon_sym_vector] = ACTIONS(173),
    [anon_sym_void] = ACTIONS(173),
    [anon_sym_struct] = ACTIONS(173),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_case] = ACTIONS(173),
    [anon_sym_default] = ACTIONS(173),
    [anon_sym_LBRACE] = ACTIONS(175),
    [anon_sym_if] = ACTIONS(173),
    [anon_sym_switch] = ACTIONS(173),
    [anon_sym_while] = ACTIONS(173),
    [anon_sym_for] = ACTIONS(173),
    [sym_do_start] = ACTIONS(173),
    [anon_sym_continue] = ACTIONS(173),
    [anon_sym_break] = ACTIONS(173),
    [sym_hex] = ACTIONS(175),
    [sym_integer] = ACTIONS(173),
    [sym_float] = ACTIONS(175),
    [sym_string_const] = ACTIONS(175),
    [sym_return] = ACTIONS(173),
    [sym_plusplus] = ACTIONS(175),
    [sym_minusminus] = ACTIONS(175),
    [sym_andand] = ACTIONS(175),
    [sym_oror] = ACTIONS(175),
    [sym_noteq] = ACTIONS(175),
    [sym_eq] = ACTIONS(175),
    [sym_lteq] = ACTIONS(175),
    [sym_sl] = ACTIONS(175),
    [sym_gteq] = ACTIONS(175),
    [sym_sr] = ACTIONS(173),
    [sym_usr] = ACTIONS(175),
    [sym_object_self_const] = ACTIONS(173),
    [sym_object_invalid_const] = ACTIONS(173),
    [sym_true_const] = ACTIONS(173),
    [sym_false_const] = ACTIONS(173),
  },
  [20] = {
    [sym_identifier] = ACTIONS(177),
    [anon_sym_LPAREN] = ACTIONS(179),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(179),
    [anon_sym_LBRACK] = ACTIONS(177),
    [anon_sym_RBRACK] = ACTIONS(179),
    [anon_sym_PLUS] = ACTIONS(177),
    [anon_sym_DASH] = ACTIONS(177),
    [anon_sym_TILDE] = ACTIONS(179),
    [anon_sym_BANG] = ACTIONS(177),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_SLASH] = ACTIONS(171),
    [anon_sym_PERCENT] = ACTIONS(169),
    [anon_sym_LT] = ACTIONS(177),
    [anon_sym_GT] = ACTIONS(177),
    [anon_sym_AMP] = ACTIONS(177),
    [anon_sym_CARET] = ACTIONS(179),
    [anon_sym_PIPE] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(179),
    [sym_comment] = ACTIONS(179),
    [anon_sym_const] = ACTIONS(177),
    [anon_sym_command] = ACTIONS(177),
    [anon_sym_effect] = ACTIONS(177),
    [anon_sym_event] = ACTIONS(177),
    [anon_sym_float] = ACTIONS(177),
    [anon_sym_int] = ACTIONS(177),
    [anon_sym_itemproperty] = ACTIONS(177),
    [anon_sym_location] = ACTIONS(177),
    [anon_sym_object] = ACTIONS(177),
    [anon_sym_sqlquery] = ACTIONS(177),
    [anon_sym_string] = ACTIONS(177),
    [anon_sym_talent] = ACTIONS(177),
    [anon_sym_vector] = ACTIONS(177),
    [anon_sym_void] = ACTIONS(177),
    [anon_sym_struct] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(179),
    [anon_sym_case] = ACTIONS(177),
    [anon_sym_default] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(179),
    [anon_sym_if] = ACTIONS(177),
    [anon_sym_switch] = ACTIONS(177),
    [anon_sym_while] = ACTIONS(177),
    [anon_sym_for] = ACTIONS(177),
    [sym_do_start] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(177),
    [anon_sym_break] = ACTIONS(177),
    [sym_hex] = ACTIONS(179),
    [sym_integer] = ACTIONS(177),
    [sym_float] = ACTIONS(179),
    [sym_string_const] = ACTIONS(179),
    [sym_return] = ACTIONS(177),
    [sym_plusplus] = ACTIONS(179),
    [sym_minusminus] = ACTIONS(179),
    [sym_andand] = ACTIONS(179),
    [sym_oror] = ACTIONS(179),
    [sym_noteq] = ACTIONS(179),
    [sym_eq] = ACTIONS(179),
    [sym_lteq] = ACTIONS(179),
    [sym_sl] = ACTIONS(179),
    [sym_gteq] = ACTIONS(179),
    [sym_sr] = ACTIONS(177),
    [sym_usr] = ACTIONS(179),
    [sym_object_self_const] = ACTIONS(177),
    [sym_object_invalid_const] = ACTIONS(177),
    [sym_true_const] = ACTIONS(177),
    [sym_false_const] = ACTIONS(177),
  },
};

static uint16_t ts_small_parse_table[] = {
  [0] = 15,
    STATE(16), 1,
      sym__unary_expression,
    STATE(20), 1,
      sym__multiplicative_expression,
    STATE(26), 1,
      sym__relational_expression,
    STATE(28), 1,
      sym__equality_expression,
    STATE(30), 1,
      sym__and_expression,
    STATE(33), 1,
      sym__exclusive_or_expression,
    STATE(36), 1,
      sym__inclusive_or_expression,
    STATE(43), 1,
      sym__logical_and_expression,
    STATE(51), 1,
      sym__logical_or_expression,
    STATE(60), 1,
      sym_expression,
    STATE(10), 2,
      sym__primary_expression,
      sym__postfix_expression,
    STATE(24), 2,
      sym__additive_expression,
      sym__shift_expression,
    STATE(55), 2,
      sym__conditional_expression,
      sym__assignment_expression,
    ACTIONS(183), 13,
      anon_sym_LPAREN,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_comment,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      sym_hex,
      sym_float,
      sym_string_const,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(181), 34,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_case,
      anon_sym_default,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_while,
      anon_sym_for,
      sym_do_start,
      anon_sym_continue,
      anon_sym_break,
      sym_identifier,
      sym_integer,
      sym_return,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [94] = 15,
    STATE(16), 1,
      sym__unary_expression,
    STATE(20), 1,
      sym__multiplicative_expression,
    STATE(26), 1,
      sym__relational_expression,
    STATE(28), 1,
      sym__equality_expression,
    STATE(30), 1,
      sym__and_expression,
    STATE(33), 1,
      sym__exclusive_or_expression,
    STATE(36), 1,
      sym__inclusive_or_expression,
    STATE(43), 1,
      sym__logical_and_expression,
    STATE(51), 1,
      sym__logical_or_expression,
    STATE(61), 1,
      sym_expression,
    STATE(10), 2,
      sym__primary_expression,
      sym__postfix_expression,
    STATE(24), 2,
      sym__additive_expression,
      sym__shift_expression,
    STATE(55), 2,
      sym__conditional_expression,
      sym__assignment_expression,
    ACTIONS(187), 13,
      anon_sym_LPAREN,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_comment,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      sym_hex,
      sym_float,
      sym_string_const,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(185), 34,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_case,
      anon_sym_default,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_while,
      anon_sym_for,
      sym_do_start,
      anon_sym_continue,
      anon_sym_break,
      sym_identifier,
      sym_integer,
      sym_return,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [188] = 2,
    ACTIONS(191), 22,
      anon_sym_LPAREN,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_CARET,
      anon_sym_QMARK,
      sym_comment,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      sym_hex,
      sym_float,
      sym_string_const,
      sym_plusplus,
      sym_minusminus,
      sym_andand,
      sym_oror,
      sym_noteq,
      sym_eq,
      sym_lteq,
      sym_sl,
      sym_gteq,
      sym_usr,
    ACTIONS(189), 40,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_case,
      anon_sym_default,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_while,
      anon_sym_for,
      sym_do_start,
      anon_sym_continue,
      anon_sym_break,
      sym_identifier,
      sym_integer,
      sym_return,
      sym_sr,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [255] = 4,
    ACTIONS(199), 1,
      sym_sr,
    ACTIONS(197), 2,
      sym_sl,
      sym_usr,
    ACTIONS(195), 20,
      anon_sym_LPAREN,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_CARET,
      anon_sym_QMARK,
      sym_comment,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      sym_hex,
      sym_float,
      sym_string_const,
      sym_plusplus,
      sym_minusminus,
      sym_andand,
      sym_oror,
      sym_noteq,
      sym_eq,
      sym_lteq,
      sym_gteq,
    ACTIONS(193), 39,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_case,
      anon_sym_default,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_while,
      anon_sym_for,
      sym_do_start,
      anon_sym_continue,
      anon_sym_break,
      sym_identifier,
      sym_integer,
      sym_return,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [326] = 4,
    ACTIONS(199), 1,
      sym_sr,
    ACTIONS(197), 2,
      sym_sl,
      sym_usr,
    ACTIONS(203), 20,
      anon_sym_LPAREN,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_CARET,
      anon_sym_QMARK,
      sym_comment,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      sym_hex,
      sym_float,
      sym_string_const,
      sym_plusplus,
      sym_minusminus,
      sym_andand,
      sym_oror,
      sym_noteq,
      sym_eq,
      sym_lteq,
      sym_gteq,
    ACTIONS(201), 39,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_case,
      anon_sym_default,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_while,
      anon_sym_for,
      sym_do_start,
      anon_sym_continue,
      anon_sym_break,
      sym_identifier,
      sym_integer,
      sym_return,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [397] = 4,
    ACTIONS(209), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(211), 2,
      sym_lteq,
      sym_gteq,
    ACTIONS(207), 18,
      anon_sym_LPAREN,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_CARET,
      anon_sym_QMARK,
      sym_comment,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      sym_hex,
      sym_float,
      sym_string_const,
      sym_plusplus,
      sym_minusminus,
      sym_andand,
      sym_oror,
      sym_noteq,
      sym_eq,
    ACTIONS(205), 37,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_case,
      anon_sym_default,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_while,
      anon_sym_for,
      sym_do_start,
      anon_sym_continue,
      anon_sym_break,
      sym_identifier,
      sym_integer,
      sym_return,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [465] = 4,
    ACTIONS(209), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(211), 2,
      sym_lteq,
      sym_gteq,
    ACTIONS(215), 18,
      anon_sym_LPAREN,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_CARET,
      anon_sym_QMARK,
      sym_comment,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      sym_hex,
      sym_float,
      sym_string_const,
      sym_plusplus,
      sym_minusminus,
      sym_andand,
      sym_oror,
      sym_noteq,
      sym_eq,
    ACTIONS(213), 37,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_case,
      anon_sym_default,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_while,
      anon_sym_for,
      sym_do_start,
      anon_sym_continue,
      anon_sym_break,
      sym_identifier,
      sym_integer,
      sym_return,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [533] = 3,
    ACTIONS(221), 2,
      sym_noteq,
      sym_eq,
    ACTIONS(219), 16,
      anon_sym_LPAREN,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_CARET,
      anon_sym_QMARK,
      sym_comment,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      sym_hex,
      sym_float,
      sym_string_const,
      sym_plusplus,
      sym_minusminus,
      sym_andand,
      sym_oror,
    ACTIONS(217), 37,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_case,
      anon_sym_default,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_while,
      anon_sym_for,
      sym_do_start,
      anon_sym_continue,
      anon_sym_break,
      sym_identifier,
      sym_integer,
      sym_return,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [595] = 3,
    ACTIONS(221), 2,
      sym_noteq,
      sym_eq,
    ACTIONS(225), 16,
      anon_sym_LPAREN,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_CARET,
      anon_sym_QMARK,
      sym_comment,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      sym_hex,
      sym_float,
      sym_string_const,
      sym_plusplus,
      sym_minusminus,
      sym_andand,
      sym_oror,
    ACTIONS(223), 37,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_case,
      anon_sym_default,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_while,
      anon_sym_for,
      sym_do_start,
      anon_sym_continue,
      anon_sym_break,
      sym_identifier,
      sym_integer,
      sym_return,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [657] = 3,
    ACTIONS(231), 1,
      anon_sym_AMP,
    ACTIONS(229), 17,
      anon_sym_LPAREN,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_QMARK,
      sym_comment,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      sym_hex,
      sym_float,
      sym_string_const,
      sym_plusplus,
      sym_minusminus,
      sym_andand,
      sym_oror,
    ACTIONS(227), 35,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_case,
      anon_sym_default,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_while,
      anon_sym_for,
      sym_do_start,
      anon_sym_continue,
      anon_sym_break,
      sym_identifier,
      sym_integer,
      sym_return,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [717] = 3,
    ACTIONS(231), 1,
      anon_sym_AMP,
    ACTIONS(235), 17,
      anon_sym_LPAREN,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_QMARK,
      sym_comment,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      sym_hex,
      sym_float,
      sym_string_const,
      sym_plusplus,
      sym_minusminus,
      sym_andand,
      sym_oror,
    ACTIONS(233), 35,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_case,
      anon_sym_default,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_while,
      anon_sym_for,
      sym_do_start,
      anon_sym_continue,
      anon_sym_break,
      sym_identifier,
      sym_integer,
      sym_return,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [777] = 3,
    ACTIONS(241), 1,
      anon_sym_CARET,
    ACTIONS(239), 16,
      anon_sym_LPAREN,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_QMARK,
      sym_comment,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      sym_hex,
      sym_float,
      sym_string_const,
      sym_plusplus,
      sym_minusminus,
      sym_andand,
      sym_oror,
    ACTIONS(237), 35,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_case,
      anon_sym_default,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_while,
      anon_sym_for,
      sym_do_start,
      anon_sym_continue,
      anon_sym_break,
      sym_identifier,
      sym_integer,
      sym_return,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [836] = 3,
    ACTIONS(241), 1,
      anon_sym_CARET,
    ACTIONS(245), 16,
      anon_sym_LPAREN,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_QMARK,
      sym_comment,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      sym_hex,
      sym_float,
      sym_string_const,
      sym_plusplus,
      sym_minusminus,
      sym_andand,
      sym_oror,
    ACTIONS(243), 35,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_case,
      anon_sym_default,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_while,
      anon_sym_for,
      sym_do_start,
      anon_sym_continue,
      anon_sym_break,
      sym_identifier,
      sym_integer,
      sym_return,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [895] = 2,
    ACTIONS(247), 16,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_comment,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_hex,
      sym_float,
      sym_string_const,
      sym_plusplus,
      sym_minusminus,
      sym_pre_include,
    ACTIONS(249), 35,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_case,
      anon_sym_default,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_while,
      anon_sym_for,
      sym_do_start,
      anon_sym_continue,
      anon_sym_break,
      sym_identifier,
      sym_integer,
      sym_return,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [951] = 2,
    ACTIONS(251), 16,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_comment,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_hex,
      sym_float,
      sym_string_const,
      sym_plusplus,
      sym_minusminus,
      sym_pre_include,
    ACTIONS(253), 35,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_case,
      anon_sym_default,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_while,
      anon_sym_for,
      sym_do_start,
      anon_sym_continue,
      anon_sym_break,
      sym_identifier,
      sym_integer,
      sym_return,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [1007] = 3,
    ACTIONS(259), 1,
      anon_sym_PIPE,
    ACTIONS(257), 16,
      anon_sym_LPAREN,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_QMARK,
      sym_comment,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      sym_hex,
      sym_float,
      sym_string_const,
      sym_plusplus,
      sym_minusminus,
      sym_andand,
      sym_oror,
    ACTIONS(255), 34,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_case,
      anon_sym_default,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_while,
      anon_sym_for,
      sym_do_start,
      anon_sym_continue,
      anon_sym_break,
      sym_identifier,
      sym_integer,
      sym_return,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [1065] = 3,
    ACTIONS(259), 1,
      anon_sym_PIPE,
    ACTIONS(263), 16,
      anon_sym_LPAREN,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_QMARK,
      sym_comment,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      sym_hex,
      sym_float,
      sym_string_const,
      sym_plusplus,
      sym_minusminus,
      sym_andand,
      sym_oror,
    ACTIONS(261), 34,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_case,
      anon_sym_default,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_while,
      anon_sym_for,
      sym_do_start,
      anon_sym_continue,
      anon_sym_break,
      sym_identifier,
      sym_integer,
      sym_return,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [1123] = 2,
    ACTIONS(265), 16,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_comment,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_hex,
      sym_float,
      sym_string_const,
      sym_plusplus,
      sym_minusminus,
      sym_pre_include,
    ACTIONS(267), 35,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_case,
      anon_sym_default,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_while,
      anon_sym_for,
      sym_do_start,
      anon_sym_continue,
      anon_sym_break,
      sym_identifier,
      sym_integer,
      sym_return,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [1179] = 2,
    ACTIONS(271), 16,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_comment,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      sym_hex,
      sym_float,
      sym_string_const,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(269), 34,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_case,
      anon_sym_default,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_while,
      anon_sym_for,
      sym_do_start,
      anon_sym_continue,
      anon_sym_break,
      sym_identifier,
      sym_integer,
      sym_return,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [1234] = 2,
    ACTIONS(275), 16,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_comment,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      sym_hex,
      sym_float,
      sym_string_const,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(273), 34,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_case,
      anon_sym_default,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_while,
      anon_sym_for,
      sym_do_start,
      anon_sym_continue,
      anon_sym_break,
      sym_identifier,
      sym_integer,
      sym_return,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [1289] = 5,
    ACTIONS(157), 1,
      anon_sym_EQ,
    STATE(90), 1,
      sym_assignment_operator,
    ACTIONS(159), 9,
      sym_addeq,
      sym_subeq,
      sym_muleq,
      sym_modeq,
      sym_xoreq,
      sym_oreq,
      sym_sleq,
      sym_sreq,
      sym_usreq,
    ACTIONS(153), 12,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      sym_sl,
      sym_sr,
      sym_usr,
    ACTIONS(155), 27,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_SEMI,
      sym_andand,
      sym_oror,
      sym_noteq,
      sym_eq,
      sym_lteq,
      sym_gteq,
  [1350] = 3,
    ACTIONS(281), 1,
      sym_andand,
    ACTIONS(279), 15,
      anon_sym_LPAREN,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_QMARK,
      sym_comment,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      sym_hex,
      sym_float,
      sym_string_const,
      sym_plusplus,
      sym_minusminus,
      sym_oror,
    ACTIONS(277), 34,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_case,
      anon_sym_default,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_while,
      anon_sym_for,
      sym_do_start,
      anon_sym_continue,
      anon_sym_break,
      sym_identifier,
      sym_integer,
      sym_return,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [1407] = 3,
    ACTIONS(281), 1,
      sym_andand,
    ACTIONS(285), 15,
      anon_sym_LPAREN,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_QMARK,
      sym_comment,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      sym_hex,
      sym_float,
      sym_string_const,
      sym_plusplus,
      sym_minusminus,
      sym_oror,
    ACTIONS(283), 34,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_case,
      anon_sym_default,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_while,
      anon_sym_for,
      sym_do_start,
      anon_sym_continue,
      anon_sym_break,
      sym_identifier,
      sym_integer,
      sym_return,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [1464] = 2,
    ACTIONS(289), 14,
      anon_sym_LPAREN,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_comment,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_hex,
      sym_float,
      sym_string_const,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(287), 35,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_case,
      anon_sym_default,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_while,
      anon_sym_for,
      sym_do_start,
      anon_sym_continue,
      anon_sym_break,
      sym_identifier,
      sym_integer,
      sym_return,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [1518] = 2,
    ACTIONS(293), 14,
      anon_sym_LPAREN,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_comment,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_hex,
      sym_float,
      sym_string_const,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(291), 35,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_case,
      anon_sym_default,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_while,
      anon_sym_for,
      sym_do_start,
      anon_sym_continue,
      anon_sym_break,
      sym_identifier,
      sym_integer,
      sym_return,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [1572] = 3,
    ACTIONS(299), 1,
      anon_sym_else,
    ACTIONS(297), 14,
      anon_sym_LPAREN,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_comment,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_hex,
      sym_float,
      sym_string_const,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(295), 34,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_case,
      anon_sym_default,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_while,
      anon_sym_for,
      sym_do_start,
      anon_sym_continue,
      anon_sym_break,
      sym_identifier,
      sym_integer,
      sym_return,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [1628] = 2,
    ACTIONS(297), 14,
      anon_sym_LPAREN,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_comment,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_hex,
      sym_float,
      sym_string_const,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(295), 35,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_case,
      anon_sym_default,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_while,
      anon_sym_for,
      sym_do_start,
      anon_sym_continue,
      anon_sym_break,
      sym_identifier,
      sym_integer,
      sym_return,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [1682] = 2,
    ACTIONS(303), 14,
      anon_sym_LPAREN,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_comment,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_hex,
      sym_float,
      sym_string_const,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(301), 35,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_case,
      anon_sym_default,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_while,
      anon_sym_for,
      sym_do_start,
      anon_sym_continue,
      anon_sym_break,
      sym_identifier,
      sym_integer,
      sym_return,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [1736] = 2,
    ACTIONS(307), 14,
      anon_sym_LPAREN,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_comment,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_hex,
      sym_float,
      sym_string_const,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(305), 35,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_case,
      anon_sym_default,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_while,
      anon_sym_for,
      sym_do_start,
      anon_sym_continue,
      anon_sym_break,
      sym_identifier,
      sym_integer,
      sym_return,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [1790] = 2,
    ACTIONS(311), 14,
      anon_sym_LPAREN,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_comment,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_hex,
      sym_float,
      sym_string_const,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(309), 35,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_case,
      anon_sym_default,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_while,
      anon_sym_for,
      sym_do_start,
      anon_sym_continue,
      anon_sym_break,
      sym_identifier,
      sym_integer,
      sym_return,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [1844] = 4,
    ACTIONS(317), 1,
      anon_sym_QMARK,
    ACTIONS(319), 1,
      sym_oror,
    ACTIONS(315), 13,
      anon_sym_LPAREN,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_comment,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      sym_hex,
      sym_float,
      sym_string_const,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(313), 34,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_case,
      anon_sym_default,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_while,
      anon_sym_for,
      sym_do_start,
      anon_sym_continue,
      anon_sym_break,
      sym_identifier,
      sym_integer,
      sym_return,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [1902] = 2,
    ACTIONS(323), 14,
      anon_sym_LPAREN,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_comment,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_hex,
      sym_float,
      sym_string_const,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(321), 35,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_case,
      anon_sym_default,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_while,
      anon_sym_for,
      sym_do_start,
      anon_sym_continue,
      anon_sym_break,
      sym_identifier,
      sym_integer,
      sym_return,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [1956] = 2,
    ACTIONS(327), 14,
      anon_sym_LPAREN,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_comment,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_hex,
      sym_float,
      sym_string_const,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(325), 35,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_case,
      anon_sym_default,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_while,
      anon_sym_for,
      sym_do_start,
      anon_sym_continue,
      anon_sym_break,
      sym_identifier,
      sym_integer,
      sym_return,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [2010] = 2,
    ACTIONS(161), 13,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_EQ,
      sym_sl,
      sym_sr,
      sym_usr,
    ACTIONS(163), 36,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_SEMI,
      sym_addeq,
      sym_subeq,
      sym_muleq,
      sym_modeq,
      sym_xoreq,
      sym_andand,
      sym_oreq,
      sym_oror,
      sym_noteq,
      sym_eq,
      sym_lteq,
      sym_sleq,
      sym_gteq,
      sym_sreq,
      sym_usreq,
  [2064] = 2,
    ACTIONS(331), 15,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_comment,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      sym_hex,
      sym_float,
      sym_string_const,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(329), 34,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_case,
      anon_sym_default,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_while,
      anon_sym_for,
      sym_do_start,
      anon_sym_continue,
      anon_sym_break,
      sym_identifier,
      sym_integer,
      sym_return,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [2118] = 2,
    ACTIONS(335), 14,
      anon_sym_LPAREN,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_comment,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_hex,
      sym_float,
      sym_string_const,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(333), 35,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_case,
      anon_sym_default,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_while,
      anon_sym_for,
      sym_do_start,
      anon_sym_continue,
      anon_sym_break,
      sym_identifier,
      sym_integer,
      sym_return,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [2172] = 2,
    ACTIONS(339), 14,
      anon_sym_LPAREN,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_comment,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_hex,
      sym_float,
      sym_string_const,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(337), 35,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_case,
      anon_sym_default,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_while,
      anon_sym_for,
      sym_do_start,
      anon_sym_continue,
      anon_sym_break,
      sym_identifier,
      sym_integer,
      sym_return,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [2226] = 2,
    ACTIONS(343), 14,
      anon_sym_LPAREN,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_comment,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_hex,
      sym_float,
      sym_string_const,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(341), 35,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_case,
      anon_sym_default,
      anon_sym_else,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_while,
      anon_sym_for,
      sym_do_start,
      anon_sym_continue,
      anon_sym_break,
      sym_identifier,
      sym_integer,
      sym_return,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [2280] = 2,
    ACTIONS(347), 13,
      anon_sym_LPAREN,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_comment,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      sym_hex,
      sym_float,
      sym_string_const,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(345), 34,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_case,
      anon_sym_default,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_while,
      anon_sym_for,
      sym_do_start,
      anon_sym_continue,
      anon_sym_break,
      sym_identifier,
      sym_integer,
      sym_return,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [2332] = 2,
    ACTIONS(351), 13,
      anon_sym_LPAREN,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_comment,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      sym_hex,
      sym_float,
      sym_string_const,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(349), 34,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_case,
      anon_sym_default,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_while,
      anon_sym_for,
      sym_do_start,
      anon_sym_continue,
      anon_sym_break,
      sym_identifier,
      sym_integer,
      sym_return,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [2384] = 2,
    ACTIONS(183), 13,
      anon_sym_LPAREN,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_comment,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      sym_hex,
      sym_float,
      sym_string_const,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(181), 34,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_case,
      anon_sym_default,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_while,
      anon_sym_for,
      sym_do_start,
      anon_sym_continue,
      anon_sym_break,
      sym_identifier,
      sym_integer,
      sym_return,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [2436] = 2,
    ACTIONS(187), 13,
      anon_sym_LPAREN,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_comment,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      sym_hex,
      sym_float,
      sym_string_const,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(185), 34,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_case,
      anon_sym_default,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_while,
      anon_sym_for,
      sym_do_start,
      anon_sym_continue,
      anon_sym_break,
      sym_identifier,
      sym_integer,
      sym_return,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [2488] = 2,
    ACTIONS(355), 13,
      anon_sym_LPAREN,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_comment,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      sym_hex,
      sym_float,
      sym_string_const,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(353), 34,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_case,
      anon_sym_default,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_while,
      anon_sym_for,
      sym_do_start,
      anon_sym_continue,
      anon_sym_break,
      sym_identifier,
      sym_integer,
      sym_return,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [2540] = 2,
    ACTIONS(359), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      sym_hex,
      sym_float,
      sym_string_const,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(357), 34,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_case,
      anon_sym_default,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_while,
      anon_sym_for,
      sym_do_start,
      anon_sym_continue,
      anon_sym_break,
      sym_identifier,
      sym_integer,
      sym_return,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [2591] = 2,
    ACTIONS(363), 12,
      anon_sym_LPAREN,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      sym_hex,
      sym_float,
      sym_string_const,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(361), 34,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_case,
      anon_sym_default,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_while,
      anon_sym_for,
      sym_do_start,
      anon_sym_continue,
      anon_sym_break,
      sym_identifier,
      sym_integer,
      sym_return,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [2642] = 3,
    ACTIONS(365), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(177), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      sym_sr,
    ACTIONS(179), 31,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_SEMI,
      sym_andand,
      sym_oror,
      sym_noteq,
      sym_eq,
      sym_lteq,
      sym_sl,
      sym_gteq,
      sym_usr,
  [2688] = 2,
    ACTIONS(173), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      sym_sr,
    ACTIONS(175), 34,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_SEMI,
      sym_andand,
      sym_oror,
      sym_noteq,
      sym_eq,
      sym_lteq,
      sym_sl,
      sym_gteq,
      sym_usr,
  [2732] = 3,
    ACTIONS(365), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(165), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      sym_sr,
    ACTIONS(167), 31,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_SEMI,
      sym_andand,
      sym_oror,
      sym_noteq,
      sym_eq,
      sym_lteq,
      sym_sl,
      sym_gteq,
      sym_usr,
  [2778] = 21,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(367), 1,
      anon_sym_RPAREN,
    STATE(41), 1,
      sym__unary_expression,
    STATE(66), 1,
      sym__multiplicative_expression,
    STATE(71), 1,
      sym__additive_expression,
    STATE(87), 1,
      sym__shift_expression,
    STATE(97), 1,
      sym__relational_expression,
    STATE(109), 1,
      sym__equality_expression,
    STATE(113), 1,
      sym__and_expression,
    STATE(116), 1,
      sym__exclusive_or_expression,
    STATE(121), 1,
      sym__inclusive_or_expression,
    STATE(125), 1,
      sym__logical_and_expression,
    STATE(129), 1,
      sym__logical_or_expression,
    STATE(165), 1,
      sym_argument_expression_list,
    ACTIONS(23), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(10), 2,
      sym__primary_expression,
      sym__postfix_expression,
    STATE(166), 2,
      sym__conditional_expression,
      sym__assignment_expression,
    ACTIONS(25), 4,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(19), 5,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      sym_hex,
      sym_float,
      sym_string_const,
    ACTIONS(21), 6,
      anon_sym_LBRACK,
      sym_integer,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [2857] = 21,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(369), 1,
      anon_sym_SEMI,
    STATE(41), 1,
      sym__unary_expression,
    STATE(66), 1,
      sym__multiplicative_expression,
    STATE(71), 1,
      sym__additive_expression,
    STATE(87), 1,
      sym__shift_expression,
    STATE(97), 1,
      sym__relational_expression,
    STATE(109), 1,
      sym__equality_expression,
    STATE(113), 1,
      sym__and_expression,
    STATE(116), 1,
      sym__exclusive_or_expression,
    STATE(121), 1,
      sym__inclusive_or_expression,
    STATE(125), 1,
      sym__logical_and_expression,
    STATE(129), 1,
      sym__logical_or_expression,
    STATE(171), 1,
      sym_expression,
    ACTIONS(23), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(10), 2,
      sym__primary_expression,
      sym__postfix_expression,
    STATE(55), 2,
      sym__conditional_expression,
      sym__assignment_expression,
    ACTIONS(25), 4,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(19), 5,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      sym_hex,
      sym_float,
      sym_string_const,
    ACTIONS(21), 6,
      anon_sym_LBRACK,
      sym_integer,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [2936] = 3,
    ACTIONS(373), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(375), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      sym_sr,
    ACTIONS(371), 29,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_SEMI,
      sym_andand,
      sym_oror,
      sym_noteq,
      sym_eq,
      sym_lteq,
      sym_sl,
      sym_gteq,
      sym_usr,
  [2979] = 21,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(377), 1,
      anon_sym_SEMI,
    STATE(41), 1,
      sym__unary_expression,
    STATE(66), 1,
      sym__multiplicative_expression,
    STATE(71), 1,
      sym__additive_expression,
    STATE(87), 1,
      sym__shift_expression,
    STATE(97), 1,
      sym__relational_expression,
    STATE(109), 1,
      sym__equality_expression,
    STATE(113), 1,
      sym__and_expression,
    STATE(116), 1,
      sym__exclusive_or_expression,
    STATE(121), 1,
      sym__inclusive_or_expression,
    STATE(125), 1,
      sym__logical_and_expression,
    STATE(129), 1,
      sym__logical_or_expression,
    STATE(188), 1,
      sym_expression,
    ACTIONS(23), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(10), 2,
      sym__primary_expression,
      sym__postfix_expression,
    STATE(55), 2,
      sym__conditional_expression,
      sym__assignment_expression,
    ACTIONS(25), 4,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(19), 5,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      sym_hex,
      sym_float,
      sym_string_const,
    ACTIONS(21), 6,
      anon_sym_LBRACK,
      sym_integer,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [3058] = 21,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(379), 1,
      anon_sym_SEMI,
    STATE(41), 1,
      sym__unary_expression,
    STATE(66), 1,
      sym__multiplicative_expression,
    STATE(71), 1,
      sym__additive_expression,
    STATE(87), 1,
      sym__shift_expression,
    STATE(97), 1,
      sym__relational_expression,
    STATE(109), 1,
      sym__equality_expression,
    STATE(113), 1,
      sym__and_expression,
    STATE(116), 1,
      sym__exclusive_or_expression,
    STATE(121), 1,
      sym__inclusive_or_expression,
    STATE(125), 1,
      sym__logical_and_expression,
    STATE(129), 1,
      sym__logical_or_expression,
    STATE(168), 1,
      sym_expression,
    ACTIONS(23), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(10), 2,
      sym__primary_expression,
      sym__postfix_expression,
    STATE(55), 2,
      sym__conditional_expression,
      sym__assignment_expression,
    ACTIONS(25), 4,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(19), 5,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      sym_hex,
      sym_float,
      sym_string_const,
    ACTIONS(21), 6,
      anon_sym_LBRACK,
      sym_integer,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [3137] = 21,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(381), 1,
      anon_sym_SEMI,
    STATE(41), 1,
      sym__unary_expression,
    STATE(66), 1,
      sym__multiplicative_expression,
    STATE(71), 1,
      sym__additive_expression,
    STATE(87), 1,
      sym__shift_expression,
    STATE(97), 1,
      sym__relational_expression,
    STATE(109), 1,
      sym__equality_expression,
    STATE(113), 1,
      sym__and_expression,
    STATE(116), 1,
      sym__exclusive_or_expression,
    STATE(121), 1,
      sym__inclusive_or_expression,
    STATE(125), 1,
      sym__logical_and_expression,
    STATE(129), 1,
      sym__logical_or_expression,
    STATE(196), 1,
      sym_expression,
    ACTIONS(23), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(10), 2,
      sym__primary_expression,
      sym__postfix_expression,
    STATE(55), 2,
      sym__conditional_expression,
      sym__assignment_expression,
    ACTIONS(25), 4,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(19), 5,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      sym_hex,
      sym_float,
      sym_string_const,
    ACTIONS(21), 6,
      anon_sym_LBRACK,
      sym_integer,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [3216] = 20,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(383), 1,
      anon_sym_RPAREN,
    STATE(16), 1,
      sym__unary_expression,
    STATE(20), 1,
      sym__multiplicative_expression,
    STATE(26), 1,
      sym__relational_expression,
    STATE(28), 1,
      sym__equality_expression,
    STATE(30), 1,
      sym__and_expression,
    STATE(33), 1,
      sym__exclusive_or_expression,
    STATE(36), 1,
      sym__inclusive_or_expression,
    STATE(43), 1,
      sym__logical_and_expression,
    STATE(51), 1,
      sym__logical_or_expression,
    STATE(62), 1,
      sym_expression,
    ACTIONS(385), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(10), 2,
      sym__primary_expression,
      sym__postfix_expression,
    STATE(24), 2,
      sym__additive_expression,
      sym__shift_expression,
    STATE(55), 2,
      sym__conditional_expression,
      sym__assignment_expression,
    ACTIONS(387), 4,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(19), 5,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      sym_hex,
      sym_float,
      sym_string_const,
    ACTIONS(21), 6,
      anon_sym_LBRACK,
      sym_integer,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [3293] = 3,
    ACTIONS(373), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(189), 5,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      sym_sr,
    ACTIONS(191), 29,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_SEMI,
      sym_andand,
      sym_oror,
      sym_noteq,
      sym_eq,
      sym_lteq,
      sym_sl,
      sym_gteq,
      sym_usr,
  [3336] = 20,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    STATE(41), 1,
      sym__unary_expression,
    STATE(66), 1,
      sym__multiplicative_expression,
    STATE(71), 1,
      sym__additive_expression,
    STATE(87), 1,
      sym__shift_expression,
    STATE(97), 1,
      sym__relational_expression,
    STATE(109), 1,
      sym__equality_expression,
    STATE(113), 1,
      sym__and_expression,
    STATE(116), 1,
      sym__exclusive_or_expression,
    STATE(121), 1,
      sym__inclusive_or_expression,
    STATE(125), 1,
      sym__logical_and_expression,
    STATE(129), 1,
      sym__logical_or_expression,
    STATE(190), 1,
      sym_expression,
    ACTIONS(23), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(10), 2,
      sym__primary_expression,
      sym__postfix_expression,
    STATE(55), 2,
      sym__conditional_expression,
      sym__assignment_expression,
    ACTIONS(25), 4,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(19), 5,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      sym_hex,
      sym_float,
      sym_string_const,
    ACTIONS(21), 6,
      anon_sym_LBRACK,
      sym_integer,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [3412] = 20,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    STATE(41), 1,
      sym__unary_expression,
    STATE(66), 1,
      sym__multiplicative_expression,
    STATE(71), 1,
      sym__additive_expression,
    STATE(87), 1,
      sym__shift_expression,
    STATE(97), 1,
      sym__relational_expression,
    STATE(109), 1,
      sym__equality_expression,
    STATE(113), 1,
      sym__and_expression,
    STATE(116), 1,
      sym__exclusive_or_expression,
    STATE(121), 1,
      sym__inclusive_or_expression,
    STATE(125), 1,
      sym__logical_and_expression,
    STATE(129), 1,
      sym__logical_or_expression,
    STATE(175), 1,
      sym_expression,
    ACTIONS(23), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(10), 2,
      sym__primary_expression,
      sym__postfix_expression,
    STATE(55), 2,
      sym__conditional_expression,
      sym__assignment_expression,
    ACTIONS(25), 4,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(19), 5,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      sym_hex,
      sym_float,
      sym_string_const,
    ACTIONS(21), 6,
      anon_sym_LBRACK,
      sym_integer,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [3488] = 20,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    STATE(41), 1,
      sym__unary_expression,
    STATE(66), 1,
      sym__multiplicative_expression,
    STATE(71), 1,
      sym__additive_expression,
    STATE(87), 1,
      sym__shift_expression,
    STATE(97), 1,
      sym__relational_expression,
    STATE(109), 1,
      sym__equality_expression,
    STATE(113), 1,
      sym__and_expression,
    STATE(116), 1,
      sym__exclusive_or_expression,
    STATE(121), 1,
      sym__inclusive_or_expression,
    STATE(125), 1,
      sym__logical_and_expression,
    STATE(129), 1,
      sym__logical_or_expression,
    STATE(202), 1,
      sym_expression,
    ACTIONS(23), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(10), 2,
      sym__primary_expression,
      sym__postfix_expression,
    STATE(55), 2,
      sym__conditional_expression,
      sym__assignment_expression,
    ACTIONS(25), 4,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(19), 5,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      sym_hex,
      sym_float,
      sym_string_const,
    ACTIONS(21), 6,
      anon_sym_LBRACK,
      sym_integer,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [3564] = 20,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    STATE(41), 1,
      sym__unary_expression,
    STATE(66), 1,
      sym__multiplicative_expression,
    STATE(71), 1,
      sym__additive_expression,
    STATE(87), 1,
      sym__shift_expression,
    STATE(97), 1,
      sym__relational_expression,
    STATE(109), 1,
      sym__equality_expression,
    STATE(113), 1,
      sym__and_expression,
    STATE(116), 1,
      sym__exclusive_or_expression,
    STATE(121), 1,
      sym__inclusive_or_expression,
    STATE(125), 1,
      sym__logical_and_expression,
    STATE(129), 1,
      sym__logical_or_expression,
    STATE(179), 1,
      sym_expression,
    ACTIONS(23), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(10), 2,
      sym__primary_expression,
      sym__postfix_expression,
    STATE(55), 2,
      sym__conditional_expression,
      sym__assignment_expression,
    ACTIONS(25), 4,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(19), 5,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      sym_hex,
      sym_float,
      sym_string_const,
    ACTIONS(21), 6,
      anon_sym_LBRACK,
      sym_integer,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [3640] = 20,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    STATE(41), 1,
      sym__unary_expression,
    STATE(66), 1,
      sym__multiplicative_expression,
    STATE(71), 1,
      sym__additive_expression,
    STATE(87), 1,
      sym__shift_expression,
    STATE(97), 1,
      sym__relational_expression,
    STATE(109), 1,
      sym__equality_expression,
    STATE(113), 1,
      sym__and_expression,
    STATE(116), 1,
      sym__exclusive_or_expression,
    STATE(121), 1,
      sym__inclusive_or_expression,
    STATE(125), 1,
      sym__logical_and_expression,
    STATE(129), 1,
      sym__logical_or_expression,
    STATE(197), 1,
      sym_expression,
    ACTIONS(23), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(10), 2,
      sym__primary_expression,
      sym__postfix_expression,
    STATE(55), 2,
      sym__conditional_expression,
      sym__assignment_expression,
    ACTIONS(25), 4,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(19), 5,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      sym_hex,
      sym_float,
      sym_string_const,
    ACTIONS(21), 6,
      anon_sym_LBRACK,
      sym_integer,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [3716] = 20,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    STATE(41), 1,
      sym__unary_expression,
    STATE(66), 1,
      sym__multiplicative_expression,
    STATE(71), 1,
      sym__additive_expression,
    STATE(87), 1,
      sym__shift_expression,
    STATE(97), 1,
      sym__relational_expression,
    STATE(109), 1,
      sym__equality_expression,
    STATE(113), 1,
      sym__and_expression,
    STATE(116), 1,
      sym__exclusive_or_expression,
    STATE(121), 1,
      sym__inclusive_or_expression,
    STATE(125), 1,
      sym__logical_and_expression,
    STATE(129), 1,
      sym__logical_or_expression,
    STATE(181), 1,
      sym_expression,
    ACTIONS(23), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(10), 2,
      sym__primary_expression,
      sym__postfix_expression,
    STATE(55), 2,
      sym__conditional_expression,
      sym__assignment_expression,
    ACTIONS(25), 4,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(19), 5,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      sym_hex,
      sym_float,
      sym_string_const,
    ACTIONS(21), 6,
      anon_sym_LBRACK,
      sym_integer,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [3792] = 20,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    STATE(41), 1,
      sym__unary_expression,
    STATE(66), 1,
      sym__multiplicative_expression,
    STATE(71), 1,
      sym__additive_expression,
    STATE(87), 1,
      sym__shift_expression,
    STATE(97), 1,
      sym__relational_expression,
    STATE(109), 1,
      sym__equality_expression,
    STATE(113), 1,
      sym__and_expression,
    STATE(116), 1,
      sym__exclusive_or_expression,
    STATE(121), 1,
      sym__inclusive_or_expression,
    STATE(125), 1,
      sym__logical_and_expression,
    STATE(129), 1,
      sym__logical_or_expression,
    STATE(167), 1,
      sym_expression,
    ACTIONS(23), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(10), 2,
      sym__primary_expression,
      sym__postfix_expression,
    STATE(55), 2,
      sym__conditional_expression,
      sym__assignment_expression,
    ACTIONS(25), 4,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(19), 5,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      sym_hex,
      sym_float,
      sym_string_const,
    ACTIONS(21), 6,
      anon_sym_LBRACK,
      sym_integer,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [3868] = 19,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    STATE(41), 1,
      sym__unary_expression,
    STATE(66), 1,
      sym__multiplicative_expression,
    STATE(71), 1,
      sym__additive_expression,
    STATE(87), 1,
      sym__shift_expression,
    STATE(97), 1,
      sym__relational_expression,
    STATE(109), 1,
      sym__equality_expression,
    STATE(113), 1,
      sym__and_expression,
    STATE(116), 1,
      sym__exclusive_or_expression,
    STATE(121), 1,
      sym__inclusive_or_expression,
    STATE(125), 1,
      sym__logical_and_expression,
    STATE(129), 1,
      sym__logical_or_expression,
    ACTIONS(23), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(10), 2,
      sym__primary_expression,
      sym__postfix_expression,
    STATE(157), 2,
      sym__conditional_expression,
      sym__assignment_expression,
    ACTIONS(25), 4,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(19), 5,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      sym_hex,
      sym_float,
      sym_string_const,
    ACTIONS(21), 6,
      anon_sym_LBRACK,
      sym_integer,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [3941] = 18,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    STATE(16), 1,
      sym__unary_expression,
    STATE(20), 1,
      sym__multiplicative_expression,
    STATE(26), 1,
      sym__relational_expression,
    STATE(28), 1,
      sym__equality_expression,
    STATE(30), 1,
      sym__and_expression,
    STATE(33), 1,
      sym__exclusive_or_expression,
    STATE(36), 1,
      sym__inclusive_or_expression,
    STATE(43), 1,
      sym__logical_and_expression,
    STATE(51), 1,
      sym__logical_or_expression,
    ACTIONS(385), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(10), 2,
      sym__primary_expression,
      sym__postfix_expression,
    STATE(24), 2,
      sym__additive_expression,
      sym__shift_expression,
    STATE(40), 2,
      sym__conditional_expression,
      sym__assignment_expression,
    ACTIONS(387), 4,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(19), 5,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      sym_hex,
      sym_float,
      sym_string_const,
    ACTIONS(21), 6,
      anon_sym_LBRACK,
      sym_integer,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [4012] = 19,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    STATE(71), 1,
      sym__additive_expression,
    STATE(87), 1,
      sym__shift_expression,
    STATE(97), 1,
      sym__relational_expression,
    STATE(109), 1,
      sym__equality_expression,
    STATE(113), 1,
      sym__and_expression,
    STATE(116), 1,
      sym__exclusive_or_expression,
    STATE(121), 1,
      sym__inclusive_or_expression,
    STATE(125), 1,
      sym__logical_and_expression,
    STATE(129), 1,
      sym__logical_or_expression,
    STATE(194), 1,
      sym_constant_expression,
    STATE(195), 1,
      sym__conditional_expression,
    ACTIONS(23), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(10), 2,
      sym__primary_expression,
      sym__postfix_expression,
    STATE(66), 2,
      sym__unary_expression,
      sym__multiplicative_expression,
    ACTIONS(25), 4,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(19), 5,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      sym_hex,
      sym_float,
      sym_string_const,
    ACTIONS(21), 6,
      anon_sym_LBRACK,
      sym_integer,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [4085] = 4,
    ACTIONS(391), 1,
      sym_sr,
    ACTIONS(389), 2,
      sym_sl,
      sym_usr,
    ACTIONS(193), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(195), 27,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_SEMI,
      sym_andand,
      sym_oror,
      sym_noteq,
      sym_eq,
      sym_lteq,
      sym_gteq,
  [4128] = 19,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    STATE(41), 1,
      sym__unary_expression,
    STATE(66), 1,
      sym__multiplicative_expression,
    STATE(71), 1,
      sym__additive_expression,
    STATE(87), 1,
      sym__shift_expression,
    STATE(97), 1,
      sym__relational_expression,
    STATE(109), 1,
      sym__equality_expression,
    STATE(113), 1,
      sym__and_expression,
    STATE(116), 1,
      sym__exclusive_or_expression,
    STATE(121), 1,
      sym__inclusive_or_expression,
    STATE(125), 1,
      sym__logical_and_expression,
    STATE(129), 1,
      sym__logical_or_expression,
    ACTIONS(23), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(10), 2,
      sym__primary_expression,
      sym__postfix_expression,
    STATE(163), 2,
      sym__conditional_expression,
      sym__assignment_expression,
    ACTIONS(25), 4,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(19), 5,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      sym_hex,
      sym_float,
      sym_string_const,
    ACTIONS(21), 6,
      anon_sym_LBRACK,
      sym_integer,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [4201] = 19,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    STATE(41), 1,
      sym__unary_expression,
    STATE(66), 1,
      sym__multiplicative_expression,
    STATE(71), 1,
      sym__additive_expression,
    STATE(87), 1,
      sym__shift_expression,
    STATE(97), 1,
      sym__relational_expression,
    STATE(109), 1,
      sym__equality_expression,
    STATE(113), 1,
      sym__and_expression,
    STATE(116), 1,
      sym__exclusive_or_expression,
    STATE(121), 1,
      sym__inclusive_or_expression,
    STATE(125), 1,
      sym__logical_and_expression,
    STATE(129), 1,
      sym__logical_or_expression,
    ACTIONS(23), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(10), 2,
      sym__primary_expression,
      sym__postfix_expression,
    STATE(144), 2,
      sym__conditional_expression,
      sym__assignment_expression,
    ACTIONS(25), 4,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(19), 5,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      sym_hex,
      sym_float,
      sym_string_const,
    ACTIONS(21), 6,
      anon_sym_LBRACK,
      sym_integer,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [4274] = 19,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    STATE(41), 1,
      sym__unary_expression,
    STATE(66), 1,
      sym__multiplicative_expression,
    STATE(71), 1,
      sym__additive_expression,
    STATE(87), 1,
      sym__shift_expression,
    STATE(97), 1,
      sym__relational_expression,
    STATE(109), 1,
      sym__equality_expression,
    STATE(113), 1,
      sym__and_expression,
    STATE(116), 1,
      sym__exclusive_or_expression,
    STATE(121), 1,
      sym__inclusive_or_expression,
    STATE(125), 1,
      sym__logical_and_expression,
    STATE(129), 1,
      sym__logical_or_expression,
    ACTIONS(23), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(10), 2,
      sym__primary_expression,
      sym__postfix_expression,
    STATE(40), 2,
      sym__conditional_expression,
      sym__assignment_expression,
    ACTIONS(25), 4,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(19), 5,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      sym_hex,
      sym_float,
      sym_string_const,
    ACTIONS(21), 6,
      anon_sym_LBRACK,
      sym_integer,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [4347] = 4,
    ACTIONS(391), 1,
      sym_sr,
    ACTIONS(389), 2,
      sym_sl,
      sym_usr,
    ACTIONS(201), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(203), 27,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_SEMI,
      sym_andand,
      sym_oror,
      sym_noteq,
      sym_eq,
      sym_lteq,
      sym_gteq,
  [4390] = 17,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    STATE(26), 1,
      sym__relational_expression,
    STATE(28), 1,
      sym__equality_expression,
    STATE(30), 1,
      sym__and_expression,
    STATE(33), 1,
      sym__exclusive_or_expression,
    STATE(36), 1,
      sym__inclusive_or_expression,
    STATE(39), 1,
      sym__conditional_expression,
    STATE(43), 1,
      sym__logical_and_expression,
    STATE(51), 1,
      sym__logical_or_expression,
    ACTIONS(385), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(10), 2,
      sym__primary_expression,
      sym__postfix_expression,
    STATE(20), 2,
      sym__unary_expression,
      sym__multiplicative_expression,
    STATE(24), 2,
      sym__additive_expression,
      sym__shift_expression,
    ACTIONS(387), 4,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(19), 5,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      sym_hex,
      sym_float,
      sym_string_const,
    ACTIONS(21), 6,
      anon_sym_LBRACK,
      sym_integer,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [4458] = 18,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    STATE(39), 1,
      sym__conditional_expression,
    STATE(71), 1,
      sym__additive_expression,
    STATE(87), 1,
      sym__shift_expression,
    STATE(97), 1,
      sym__relational_expression,
    STATE(109), 1,
      sym__equality_expression,
    STATE(113), 1,
      sym__and_expression,
    STATE(116), 1,
      sym__exclusive_or_expression,
    STATE(121), 1,
      sym__inclusive_or_expression,
    STATE(125), 1,
      sym__logical_and_expression,
    STATE(129), 1,
      sym__logical_or_expression,
    ACTIONS(23), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(10), 2,
      sym__primary_expression,
      sym__postfix_expression,
    STATE(66), 2,
      sym__unary_expression,
      sym__multiplicative_expression,
    ACTIONS(25), 4,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(19), 5,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      sym_hex,
      sym_float,
      sym_string_const,
    ACTIONS(21), 6,
      anon_sym_LBRACK,
      sym_integer,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [4528] = 4,
    ACTIONS(213), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(393), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(395), 2,
      sym_lteq,
      sym_gteq,
    ACTIONS(215), 25,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_SEMI,
      sym_andand,
      sym_oror,
      sym_noteq,
      sym_eq,
  [4568] = 16,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    STATE(71), 1,
      sym__additive_expression,
    STATE(87), 1,
      sym__shift_expression,
    STATE(97), 1,
      sym__relational_expression,
    STATE(109), 1,
      sym__equality_expression,
    STATE(113), 1,
      sym__and_expression,
    STATE(116), 1,
      sym__exclusive_or_expression,
    STATE(121), 1,
      sym__inclusive_or_expression,
    STATE(126), 1,
      sym__logical_and_expression,
    ACTIONS(23), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(10), 2,
      sym__primary_expression,
      sym__postfix_expression,
    STATE(66), 2,
      sym__unary_expression,
      sym__multiplicative_expression,
    ACTIONS(25), 4,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(19), 5,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      sym_hex,
      sym_float,
      sym_string_const,
    ACTIONS(21), 6,
      anon_sym_LBRACK,
      sym_integer,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [4632] = 15,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    STATE(26), 1,
      sym__relational_expression,
    STATE(28), 1,
      sym__equality_expression,
    STATE(30), 1,
      sym__and_expression,
    STATE(33), 1,
      sym__exclusive_or_expression,
    STATE(36), 1,
      sym__inclusive_or_expression,
    STATE(42), 1,
      sym__logical_and_expression,
    ACTIONS(385), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(10), 2,
      sym__primary_expression,
      sym__postfix_expression,
    STATE(20), 2,
      sym__unary_expression,
      sym__multiplicative_expression,
    STATE(24), 2,
      sym__additive_expression,
      sym__shift_expression,
    ACTIONS(387), 4,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(19), 5,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      sym_hex,
      sym_float,
      sym_string_const,
    ACTIONS(21), 6,
      anon_sym_LBRACK,
      sym_integer,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [4694] = 4,
    ACTIONS(205), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(393), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(395), 2,
      sym_lteq,
      sym_gteq,
    ACTIONS(207), 25,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_SEMI,
      sym_andand,
      sym_oror,
      sym_noteq,
      sym_eq,
  [4734] = 15,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    STATE(71), 1,
      sym__additive_expression,
    STATE(87), 1,
      sym__shift_expression,
    STATE(97), 1,
      sym__relational_expression,
    STATE(109), 1,
      sym__equality_expression,
    STATE(113), 1,
      sym__and_expression,
    STATE(116), 1,
      sym__exclusive_or_expression,
    STATE(120), 1,
      sym__inclusive_or_expression,
    ACTIONS(23), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(10), 2,
      sym__primary_expression,
      sym__postfix_expression,
    STATE(66), 2,
      sym__unary_expression,
      sym__multiplicative_expression,
    ACTIONS(25), 4,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(19), 5,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      sym_hex,
      sym_float,
      sym_string_const,
    ACTIONS(21), 6,
      anon_sym_LBRACK,
      sym_integer,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [4795] = 14,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    STATE(26), 1,
      sym__relational_expression,
    STATE(28), 1,
      sym__equality_expression,
    STATE(30), 1,
      sym__and_expression,
    STATE(33), 1,
      sym__exclusive_or_expression,
    STATE(37), 1,
      sym__inclusive_or_expression,
    ACTIONS(385), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(10), 2,
      sym__primary_expression,
      sym__postfix_expression,
    STATE(20), 2,
      sym__unary_expression,
      sym__multiplicative_expression,
    STATE(24), 2,
      sym__additive_expression,
      sym__shift_expression,
    ACTIONS(387), 4,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(19), 5,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      sym_hex,
      sym_float,
      sym_string_const,
    ACTIONS(21), 6,
      anon_sym_LBRACK,
      sym_integer,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [4854] = 13,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    STATE(26), 1,
      sym__relational_expression,
    STATE(28), 1,
      sym__equality_expression,
    STATE(30), 1,
      sym__and_expression,
    STATE(32), 1,
      sym__exclusive_or_expression,
    ACTIONS(385), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(10), 2,
      sym__primary_expression,
      sym__postfix_expression,
    STATE(20), 2,
      sym__unary_expression,
      sym__multiplicative_expression,
    STATE(24), 2,
      sym__additive_expression,
      sym__shift_expression,
    ACTIONS(387), 4,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(19), 5,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      sym_hex,
      sym_float,
      sym_string_const,
    ACTIONS(21), 6,
      anon_sym_LBRACK,
      sym_integer,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [4910] = 14,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    STATE(71), 1,
      sym__additive_expression,
    STATE(87), 1,
      sym__shift_expression,
    STATE(97), 1,
      sym__relational_expression,
    STATE(109), 1,
      sym__equality_expression,
    STATE(113), 1,
      sym__and_expression,
    STATE(117), 1,
      sym__exclusive_or_expression,
    ACTIONS(23), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(10), 2,
      sym__primary_expression,
      sym__postfix_expression,
    STATE(66), 2,
      sym__unary_expression,
      sym__multiplicative_expression,
    ACTIONS(25), 4,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(19), 5,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      sym_hex,
      sym_float,
      sym_string_const,
    ACTIONS(21), 6,
      anon_sym_LBRACK,
      sym_integer,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [4968] = 10,
    ACTIONS(7), 1,
      anon_sym_const,
    ACTIONS(11), 1,
      anon_sym_struct,
    ACTIONS(13), 1,
      sym_pre_include,
    ACTIONS(397), 1,
      ts_builtin_sym_end,
    ACTIONS(399), 1,
      sym_comment,
    STATE(138), 1,
      sym__preprocessor_include,
    STATE(158), 1,
      sym_function_declarator,
    STATE(151), 2,
      sym__qualified_type_specifier,
      sym_type_specifier,
    STATE(103), 6,
      sym__external_declaration,
      sym_declaration,
      sym_function_definition,
      sym_struct_definition,
      sym_preprocessor_directive,
      aux_sym_source_file_repeat1,
    ACTIONS(9), 13,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
  [5017] = 10,
    ACTIONS(401), 1,
      ts_builtin_sym_end,
    ACTIONS(403), 1,
      sym_comment,
    ACTIONS(406), 1,
      anon_sym_const,
    ACTIONS(412), 1,
      anon_sym_struct,
    ACTIONS(415), 1,
      sym_pre_include,
    STATE(138), 1,
      sym__preprocessor_include,
    STATE(158), 1,
      sym_function_declarator,
    STATE(151), 2,
      sym__qualified_type_specifier,
      sym_type_specifier,
    STATE(103), 6,
      sym__external_declaration,
      sym_declaration,
      sym_function_definition,
      sym_struct_definition,
      sym_preprocessor_directive,
      aux_sym_source_file_repeat1,
    ACTIONS(409), 13,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
  [5066] = 12,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    STATE(26), 1,
      sym__relational_expression,
    STATE(28), 1,
      sym__equality_expression,
    STATE(31), 1,
      sym__and_expression,
    ACTIONS(385), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(10), 2,
      sym__primary_expression,
      sym__postfix_expression,
    STATE(20), 2,
      sym__unary_expression,
      sym__multiplicative_expression,
    STATE(24), 2,
      sym__additive_expression,
      sym__shift_expression,
    ACTIONS(387), 4,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(19), 5,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      sym_hex,
      sym_float,
      sym_string_const,
    ACTIONS(21), 6,
      anon_sym_LBRACK,
      sym_integer,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [5119] = 13,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    STATE(71), 1,
      sym__additive_expression,
    STATE(87), 1,
      sym__shift_expression,
    STATE(97), 1,
      sym__relational_expression,
    STATE(109), 1,
      sym__equality_expression,
    STATE(112), 1,
      sym__and_expression,
    ACTIONS(23), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(10), 2,
      sym__primary_expression,
      sym__postfix_expression,
    STATE(66), 2,
      sym__unary_expression,
      sym__multiplicative_expression,
    ACTIONS(25), 4,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(19), 5,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      sym_hex,
      sym_float,
      sym_string_const,
    ACTIONS(21), 6,
      anon_sym_LBRACK,
      sym_integer,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [5174] = 3,
    ACTIONS(223), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(418), 2,
      sym_noteq,
      sym_eq,
    ACTIONS(225), 23,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_SEMI,
      sym_andand,
      sym_oror,
  [5208] = 11,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    STATE(26), 1,
      sym__relational_expression,
    STATE(29), 1,
      sym__equality_expression,
    ACTIONS(385), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(10), 2,
      sym__primary_expression,
      sym__postfix_expression,
    STATE(20), 2,
      sym__unary_expression,
      sym__multiplicative_expression,
    STATE(24), 2,
      sym__additive_expression,
      sym__shift_expression,
    ACTIONS(387), 4,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(19), 5,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      sym_hex,
      sym_float,
      sym_string_const,
    ACTIONS(21), 6,
      anon_sym_LBRACK,
      sym_integer,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [5258] = 12,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    STATE(71), 1,
      sym__additive_expression,
    STATE(87), 1,
      sym__shift_expression,
    STATE(97), 1,
      sym__relational_expression,
    STATE(106), 1,
      sym__equality_expression,
    ACTIONS(23), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(10), 2,
      sym__primary_expression,
      sym__postfix_expression,
    STATE(66), 2,
      sym__unary_expression,
      sym__multiplicative_expression,
    ACTIONS(25), 4,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(19), 5,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      sym_hex,
      sym_float,
      sym_string_const,
    ACTIONS(21), 6,
      anon_sym_LBRACK,
      sym_integer,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [5310] = 3,
    ACTIONS(217), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(418), 2,
      sym_noteq,
      sym_eq,
    ACTIONS(219), 23,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_SEMI,
      sym_andand,
      sym_oror,
  [5344] = 10,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    STATE(27), 1,
      sym__relational_expression,
    ACTIONS(385), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(10), 2,
      sym__primary_expression,
      sym__postfix_expression,
    STATE(20), 2,
      sym__unary_expression,
      sym__multiplicative_expression,
    STATE(24), 2,
      sym__additive_expression,
      sym__shift_expression,
    ACTIONS(387), 4,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(19), 5,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      sym_hex,
      sym_float,
      sym_string_const,
    ACTIONS(21), 6,
      anon_sym_LBRACK,
      sym_integer,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [5391] = 11,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    STATE(71), 1,
      sym__additive_expression,
    STATE(87), 1,
      sym__shift_expression,
    STATE(94), 1,
      sym__relational_expression,
    ACTIONS(23), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(10), 2,
      sym__primary_expression,
      sym__postfix_expression,
    STATE(66), 2,
      sym__unary_expression,
      sym__multiplicative_expression,
    ACTIONS(25), 4,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(19), 5,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      sym_hex,
      sym_float,
      sym_string_const,
    ACTIONS(21), 6,
      anon_sym_LBRACK,
      sym_integer,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [5440] = 3,
    ACTIONS(233), 1,
      anon_sym_PIPE,
    ACTIONS(420), 1,
      anon_sym_AMP,
    ACTIONS(235), 23,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_SEMI,
      sym_andand,
      sym_oror,
  [5472] = 3,
    ACTIONS(227), 1,
      anon_sym_PIPE,
    ACTIONS(420), 1,
      anon_sym_AMP,
    ACTIONS(229), 23,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_SEMI,
      sym_andand,
      sym_oror,
  [5504] = 10,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    STATE(71), 1,
      sym__additive_expression,
    STATE(91), 1,
      sym__shift_expression,
    ACTIONS(23), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(10), 2,
      sym__primary_expression,
      sym__postfix_expression,
    STATE(66), 2,
      sym__unary_expression,
      sym__multiplicative_expression,
    ACTIONS(25), 4,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(19), 5,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      sym_hex,
      sym_float,
      sym_string_const,
    ACTIONS(21), 6,
      anon_sym_LBRACK,
      sym_integer,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [5550] = 9,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(385), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(10), 2,
      sym__primary_expression,
      sym__postfix_expression,
    STATE(20), 2,
      sym__unary_expression,
      sym__multiplicative_expression,
    STATE(25), 2,
      sym__additive_expression,
      sym__shift_expression,
    ACTIONS(387), 4,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(19), 5,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      sym_hex,
      sym_float,
      sym_string_const,
    ACTIONS(21), 6,
      anon_sym_LBRACK,
      sym_integer,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [5594] = 3,
    ACTIONS(243), 1,
      anon_sym_PIPE,
    ACTIONS(422), 1,
      anon_sym_CARET,
    ACTIONS(245), 22,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_SEMI,
      sym_andand,
      sym_oror,
  [5625] = 3,
    ACTIONS(237), 1,
      anon_sym_PIPE,
    ACTIONS(422), 1,
      anon_sym_CARET,
    ACTIONS(239), 22,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_SEMI,
      sym_andand,
      sym_oror,
  [5656] = 9,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    STATE(76), 1,
      sym__additive_expression,
    ACTIONS(23), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(10), 2,
      sym__primary_expression,
      sym__postfix_expression,
    STATE(66), 2,
      sym__unary_expression,
      sym__multiplicative_expression,
    ACTIONS(25), 4,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(19), 5,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      sym_hex,
      sym_float,
      sym_string_const,
    ACTIONS(21), 6,
      anon_sym_LBRACK,
      sym_integer,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [5699] = 9,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    STATE(23), 1,
      sym__additive_expression,
    ACTIONS(385), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(10), 2,
      sym__primary_expression,
      sym__postfix_expression,
    STATE(20), 2,
      sym__unary_expression,
      sym__multiplicative_expression,
    ACTIONS(387), 4,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(19), 5,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      sym_hex,
      sym_float,
      sym_string_const,
    ACTIONS(21), 6,
      anon_sym_LBRACK,
      sym_integer,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [5742] = 2,
    ACTIONS(424), 1,
      anon_sym_PIPE,
    ACTIONS(263), 22,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_SEMI,
      sym_andand,
      sym_oror,
  [5770] = 2,
    ACTIONS(424), 1,
      anon_sym_PIPE,
    ACTIONS(257), 22,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_SEMI,
      sym_andand,
      sym_oror,
  [5798] = 8,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    ACTIONS(23), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(10), 2,
      sym__primary_expression,
      sym__postfix_expression,
    STATE(68), 2,
      sym__unary_expression,
      sym__multiplicative_expression,
    ACTIONS(25), 4,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(19), 5,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      sym_hex,
      sym_float,
      sym_string_const,
    ACTIONS(21), 6,
      anon_sym_LBRACK,
      sym_integer,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [5838] = 8,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    STATE(17), 1,
      sym__unary_expression,
    ACTIONS(385), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(10), 2,
      sym__primary_expression,
      sym__postfix_expression,
    ACTIONS(387), 4,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(19), 5,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      sym_hex,
      sym_float,
      sym_string_const,
    ACTIONS(21), 6,
      anon_sym_LBRACK,
      sym_integer,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [5877] = 8,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    STATE(54), 1,
      sym__unary_expression,
    ACTIONS(23), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(10), 2,
      sym__primary_expression,
      sym__postfix_expression,
    ACTIONS(25), 4,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(19), 5,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      sym_hex,
      sym_float,
      sym_string_const,
    ACTIONS(21), 6,
      anon_sym_LBRACK,
      sym_integer,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [5916] = 2,
    ACTIONS(426), 1,
      sym_andand,
    ACTIONS(285), 21,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_SEMI,
      sym_oror,
  [5943] = 2,
    ACTIONS(426), 1,
      sym_andand,
    ACTIONS(279), 21,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_SEMI,
      sym_oror,
  [5970] = 8,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    STATE(67), 1,
      sym__unary_expression,
    ACTIONS(23), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(10), 2,
      sym__primary_expression,
      sym__postfix_expression,
    ACTIONS(25), 4,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(19), 5,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      sym_hex,
      sym_float,
      sym_string_const,
    ACTIONS(21), 6,
      anon_sym_LBRACK,
      sym_integer,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [6009] = 8,
    ACTIONS(15), 1,
      sym_identifier,
    ACTIONS(17), 1,
      anon_sym_LPAREN,
    STATE(19), 1,
      sym__unary_expression,
    ACTIONS(385), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(10), 2,
      sym__primary_expression,
      sym__postfix_expression,
    ACTIONS(387), 4,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_plusplus,
      sym_minusminus,
    ACTIONS(19), 5,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      sym_hex,
      sym_float,
      sym_string_const,
    ACTIONS(21), 6,
      anon_sym_LBRACK,
      sym_integer,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
  [6048] = 3,
    ACTIONS(428), 1,
      anon_sym_QMARK,
    ACTIONS(430), 1,
      sym_oror,
    ACTIONS(315), 19,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_SEMI,
  [6076] = 8,
    ACTIONS(7), 1,
      anon_sym_const,
    ACTIONS(432), 1,
      anon_sym_RPAREN,
    ACTIONS(434), 1,
      anon_sym_struct,
    STATE(133), 1,
      aux_sym_function_parameter_list_repeat1,
    STATE(143), 1,
      sym__function_parameter_declaration,
    STATE(173), 1,
      sym_function_parameter_list,
    STATE(172), 2,
      sym__qualified_type_specifier,
      sym_type_specifier,
    ACTIONS(9), 13,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
  [6114] = 2,
    ACTIONS(436), 9,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_identifier,
      sym_integer,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
    ACTIONS(438), 11,
      anon_sym_LPAREN,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_SEMI,
      sym_hex,
      sym_float,
      sym_string_const,
      sym_plusplus,
      sym_minusminus,
  [6139] = 7,
    ACTIONS(440), 1,
      anon_sym_RPAREN,
    ACTIONS(442), 1,
      anon_sym_const,
    ACTIONS(448), 1,
      anon_sym_struct,
    STATE(132), 1,
      aux_sym_function_parameter_list_repeat1,
    STATE(143), 1,
      sym__function_parameter_declaration,
    STATE(172), 2,
      sym__qualified_type_specifier,
      sym_type_specifier,
    ACTIONS(445), 13,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
  [6174] = 7,
    ACTIONS(7), 1,
      anon_sym_const,
    ACTIONS(434), 1,
      anon_sym_struct,
    ACTIONS(451), 1,
      anon_sym_RPAREN,
    STATE(132), 1,
      aux_sym_function_parameter_list_repeat1,
    STATE(143), 1,
      sym__function_parameter_declaration,
    STATE(172), 2,
      sym__qualified_type_specifier,
      sym_type_specifier,
    ACTIONS(9), 13,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
  [6209] = 2,
    ACTIONS(453), 9,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_identifier,
      sym_integer,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
    ACTIONS(455), 11,
      anon_sym_LPAREN,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_SEMI,
      sym_hex,
      sym_float,
      sym_string_const,
      sym_plusplus,
      sym_minusminus,
  [6234] = 2,
    ACTIONS(457), 9,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_identifier,
      sym_integer,
      sym_object_self_const,
      sym_object_invalid_const,
      sym_true_const,
      sym_false_const,
    ACTIONS(459), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK_RBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_BANG,
      sym_hex,
      sym_float,
      sym_string_const,
      sym_plusplus,
      sym_minusminus,
  [6258] = 6,
    ACTIONS(7), 1,
      anon_sym_const,
    ACTIONS(434), 1,
      anon_sym_struct,
    STATE(137), 1,
      sym_struct_declaration_list,
    STATE(148), 1,
      sym_struct_declaration,
    STATE(161), 2,
      sym__qualified_type_specifier,
      sym_type_specifier,
    ACTIONS(9), 13,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
  [6290] = 6,
    ACTIONS(7), 1,
      anon_sym_const,
    ACTIONS(434), 1,
      anon_sym_struct,
    ACTIONS(461), 1,
      anon_sym_RBRACE,
    STATE(146), 1,
      sym_struct_declaration,
    STATE(161), 2,
      sym__qualified_type_specifier,
      sym_type_specifier,
    ACTIONS(9), 13,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
  [6322] = 1,
    ACTIONS(463), 18,
      ts_builtin_sym_end,
      sym_comment,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      sym_pre_include,
  [6343] = 1,
    ACTIONS(465), 18,
      ts_builtin_sym_end,
      sym_comment,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      sym_pre_include,
  [6364] = 1,
    ACTIONS(467), 18,
      ts_builtin_sym_end,
      sym_comment,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      sym_pre_include,
  [6385] = 2,
    ACTIONS(471), 1,
      anon_sym_EQ,
    ACTIONS(469), 17,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
  [6408] = 1,
    ACTIONS(473), 18,
      ts_builtin_sym_end,
      sym_comment,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      sym_pre_include,
  [6429] = 2,
    ACTIONS(477), 1,
      anon_sym_COMMA,
    ACTIONS(475), 16,
      anon_sym_RPAREN,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
  [6451] = 1,
    ACTIONS(479), 17,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
  [6471] = 1,
    ACTIONS(440), 16,
      anon_sym_RPAREN,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
  [6490] = 1,
    ACTIONS(481), 16,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_RBRACE,
  [6509] = 1,
    ACTIONS(483), 16,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_RBRACE,
  [6528] = 1,
    ACTIONS(485), 16,
      anon_sym_const,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
      anon_sym_struct,
      anon_sym_RBRACE,
  [6547] = 3,
    ACTIONS(434), 1,
      anon_sym_struct,
    STATE(191), 1,
      sym_type_specifier,
    ACTIONS(9), 13,
      anon_sym_command,
      anon_sym_effect,
      anon_sym_event,
      anon_sym_float,
      anon_sym_int,
      anon_sym_itemproperty,
      anon_sym_location,
      anon_sym_object,
      anon_sym_sqlquery,
      anon_sym_string,
      anon_sym_talent,
      anon_sym_vector,
      anon_sym_void,
  [6569] = 3,
    ACTIONS(487), 1,
      sym_identifier,
    STATE(154), 1,
      sym__init_declarator_identifier,
    STATE(162), 2,
      sym__init_declarator_list,
      sym__init_declarator,
  [6580] = 3,
    ACTIONS(489), 1,
      sym_identifier,
    STATE(154), 1,
      sym__init_declarator_identifier,
    STATE(162), 2,
      sym__init_declarator_list,
      sym__init_declarator,
  [6591] = 2,
    ACTIONS(491), 1,
      anon_sym_LPAREN,
    ACTIONS(493), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
  [6600] = 3,
    ACTIONS(487), 1,
      sym_identifier,
    STATE(154), 1,
      sym__init_declarator_identifier,
    STATE(156), 1,
      sym__init_declarator,
  [6610] = 2,
    ACTIONS(497), 1,
      anon_sym_EQ,
    ACTIONS(495), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [6618] = 2,
    ACTIONS(499), 1,
      anon_sym_COMMA,
    ACTIONS(501), 1,
      anon_sym_SEMI,
  [6625] = 1,
    ACTIONS(503), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [6630] = 1,
    ACTIONS(505), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [6635] = 2,
    ACTIONS(39), 1,
      anon_sym_LBRACE,
    STATE(139), 1,
      sym_compound_statement,
  [6642] = 2,
    ACTIONS(507), 1,
      sym_identifier,
    ACTIONS(509), 1,
      anon_sym_LBRACE,
  [6649] = 1,
    ACTIONS(511), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [6654] = 2,
    ACTIONS(513), 1,
      sym_identifier,
    STATE(155), 1,
      sym_struct_declarator_list,
  [6661] = 2,
    ACTIONS(515), 1,
      anon_sym_COMMA,
    ACTIONS(517), 1,
      anon_sym_SEMI,
  [6668] = 1,
    ACTIONS(519), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [6673] = 1,
    ACTIONS(521), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [6678] = 2,
    ACTIONS(523), 1,
      anon_sym_RPAREN,
    ACTIONS(525), 1,
      anon_sym_COMMA,
  [6685] = 1,
    ACTIONS(527), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [6690] = 1,
    ACTIONS(529), 1,
      anon_sym_RPAREN,
  [6694] = 1,
    ACTIONS(531), 1,
      anon_sym_SEMI,
  [6698] = 1,
    ACTIONS(533), 1,
      anon_sym_SEMI,
  [6702] = 1,
    ACTIONS(535), 1,
      anon_sym_LBRACE,
  [6706] = 1,
    ACTIONS(381), 1,
      anon_sym_SEMI,
  [6710] = 1,
    ACTIONS(537), 1,
      sym_identifier,
  [6714] = 1,
    ACTIONS(539), 1,
      anon_sym_RPAREN,
  [6718] = 1,
    ACTIONS(507), 1,
      sym_identifier,
  [6722] = 1,
    ACTIONS(541), 1,
      anon_sym_COLON,
  [6726] = 1,
    ACTIONS(543), 1,
      anon_sym_LPAREN,
  [6730] = 1,
    ACTIONS(545), 1,
      anon_sym_LPAREN,
  [6734] = 1,
    ACTIONS(547), 1,
      anon_sym_LPAREN,
  [6738] = 1,
    ACTIONS(549), 1,
      anon_sym_RPAREN,
  [6742] = 1,
    ACTIONS(551), 1,
      anon_sym_LPAREN,
  [6746] = 1,
    ACTIONS(553), 1,
      anon_sym_RPAREN,
  [6750] = 1,
    ACTIONS(379), 1,
      anon_sym_SEMI,
  [6754] = 1,
    ACTIONS(555), 1,
      anon_sym_LBRACE,
  [6758] = 1,
    ACTIONS(557), 1,
      anon_sym_SEMI,
  [6762] = 1,
    ACTIONS(559), 1,
      anon_sym_RBRACE,
  [6766] = 1,
    ACTIONS(561), 1,
      sym_identifier,
  [6770] = 1,
    ACTIONS(563), 1,
      anon_sym_COLON,
  [6774] = 1,
    ACTIONS(565), 1,
      anon_sym_SEMI,
  [6778] = 1,
    ACTIONS(367), 1,
      sym_identifier,
  [6782] = 1,
    ACTIONS(567), 1,
      anon_sym_RPAREN,
  [6786] = 1,
    ACTIONS(569), 1,
      sym_identifier,
  [6790] = 1,
    ACTIONS(571), 1,
      sym_identifier,
  [6794] = 1,
    ACTIONS(573), 1,
      anon_sym_while,
  [6798] = 1,
    ACTIONS(575), 1,
      anon_sym_COLON,
  [6802] = 1,
    ACTIONS(577), 1,
      anon_sym_COLON,
  [6806] = 1,
    ACTIONS(579), 1,
      anon_sym_SEMI,
  [6810] = 1,
    ACTIONS(581), 1,
      anon_sym_RPAREN,
  [6814] = 1,
    ACTIONS(583), 1,
      ts_builtin_sym_end,
  [6818] = 1,
    ACTIONS(585), 1,
      sym_string_const,
  [6822] = 1,
    ACTIONS(587), 1,
      sym_identifier,
  [6826] = 1,
    ACTIONS(589), 1,
      sym_identifier,
  [6830] = 1,
    ACTIONS(591), 1,
      anon_sym_COLON,
  [6834] = 1,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
};

static uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(21)] = 0,
  [SMALL_STATE(22)] = 94,
  [SMALL_STATE(23)] = 188,
  [SMALL_STATE(24)] = 255,
  [SMALL_STATE(25)] = 326,
  [SMALL_STATE(26)] = 397,
  [SMALL_STATE(27)] = 465,
  [SMALL_STATE(28)] = 533,
  [SMALL_STATE(29)] = 595,
  [SMALL_STATE(30)] = 657,
  [SMALL_STATE(31)] = 717,
  [SMALL_STATE(32)] = 777,
  [SMALL_STATE(33)] = 836,
  [SMALL_STATE(34)] = 895,
  [SMALL_STATE(35)] = 951,
  [SMALL_STATE(36)] = 1007,
  [SMALL_STATE(37)] = 1065,
  [SMALL_STATE(38)] = 1123,
  [SMALL_STATE(39)] = 1179,
  [SMALL_STATE(40)] = 1234,
  [SMALL_STATE(41)] = 1289,
  [SMALL_STATE(42)] = 1350,
  [SMALL_STATE(43)] = 1407,
  [SMALL_STATE(44)] = 1464,
  [SMALL_STATE(45)] = 1518,
  [SMALL_STATE(46)] = 1572,
  [SMALL_STATE(47)] = 1628,
  [SMALL_STATE(48)] = 1682,
  [SMALL_STATE(49)] = 1736,
  [SMALL_STATE(50)] = 1790,
  [SMALL_STATE(51)] = 1844,
  [SMALL_STATE(52)] = 1902,
  [SMALL_STATE(53)] = 1956,
  [SMALL_STATE(54)] = 2010,
  [SMALL_STATE(55)] = 2064,
  [SMALL_STATE(56)] = 2118,
  [SMALL_STATE(57)] = 2172,
  [SMALL_STATE(58)] = 2226,
  [SMALL_STATE(59)] = 2280,
  [SMALL_STATE(60)] = 2332,
  [SMALL_STATE(61)] = 2384,
  [SMALL_STATE(62)] = 2436,
  [SMALL_STATE(63)] = 2488,
  [SMALL_STATE(64)] = 2540,
  [SMALL_STATE(65)] = 2591,
  [SMALL_STATE(66)] = 2642,
  [SMALL_STATE(67)] = 2688,
  [SMALL_STATE(68)] = 2732,
  [SMALL_STATE(69)] = 2778,
  [SMALL_STATE(70)] = 2857,
  [SMALL_STATE(71)] = 2936,
  [SMALL_STATE(72)] = 2979,
  [SMALL_STATE(73)] = 3058,
  [SMALL_STATE(74)] = 3137,
  [SMALL_STATE(75)] = 3216,
  [SMALL_STATE(76)] = 3293,
  [SMALL_STATE(77)] = 3336,
  [SMALL_STATE(78)] = 3412,
  [SMALL_STATE(79)] = 3488,
  [SMALL_STATE(80)] = 3564,
  [SMALL_STATE(81)] = 3640,
  [SMALL_STATE(82)] = 3716,
  [SMALL_STATE(83)] = 3792,
  [SMALL_STATE(84)] = 3868,
  [SMALL_STATE(85)] = 3941,
  [SMALL_STATE(86)] = 4012,
  [SMALL_STATE(87)] = 4085,
  [SMALL_STATE(88)] = 4128,
  [SMALL_STATE(89)] = 4201,
  [SMALL_STATE(90)] = 4274,
  [SMALL_STATE(91)] = 4347,
  [SMALL_STATE(92)] = 4390,
  [SMALL_STATE(93)] = 4458,
  [SMALL_STATE(94)] = 4528,
  [SMALL_STATE(95)] = 4568,
  [SMALL_STATE(96)] = 4632,
  [SMALL_STATE(97)] = 4694,
  [SMALL_STATE(98)] = 4734,
  [SMALL_STATE(99)] = 4795,
  [SMALL_STATE(100)] = 4854,
  [SMALL_STATE(101)] = 4910,
  [SMALL_STATE(102)] = 4968,
  [SMALL_STATE(103)] = 5017,
  [SMALL_STATE(104)] = 5066,
  [SMALL_STATE(105)] = 5119,
  [SMALL_STATE(106)] = 5174,
  [SMALL_STATE(107)] = 5208,
  [SMALL_STATE(108)] = 5258,
  [SMALL_STATE(109)] = 5310,
  [SMALL_STATE(110)] = 5344,
  [SMALL_STATE(111)] = 5391,
  [SMALL_STATE(112)] = 5440,
  [SMALL_STATE(113)] = 5472,
  [SMALL_STATE(114)] = 5504,
  [SMALL_STATE(115)] = 5550,
  [SMALL_STATE(116)] = 5594,
  [SMALL_STATE(117)] = 5625,
  [SMALL_STATE(118)] = 5656,
  [SMALL_STATE(119)] = 5699,
  [SMALL_STATE(120)] = 5742,
  [SMALL_STATE(121)] = 5770,
  [SMALL_STATE(122)] = 5798,
  [SMALL_STATE(123)] = 5838,
  [SMALL_STATE(124)] = 5877,
  [SMALL_STATE(125)] = 5916,
  [SMALL_STATE(126)] = 5943,
  [SMALL_STATE(127)] = 5970,
  [SMALL_STATE(128)] = 6009,
  [SMALL_STATE(129)] = 6048,
  [SMALL_STATE(130)] = 6076,
  [SMALL_STATE(131)] = 6114,
  [SMALL_STATE(132)] = 6139,
  [SMALL_STATE(133)] = 6174,
  [SMALL_STATE(134)] = 6209,
  [SMALL_STATE(135)] = 6234,
  [SMALL_STATE(136)] = 6258,
  [SMALL_STATE(137)] = 6290,
  [SMALL_STATE(138)] = 6322,
  [SMALL_STATE(139)] = 6343,
  [SMALL_STATE(140)] = 6364,
  [SMALL_STATE(141)] = 6385,
  [SMALL_STATE(142)] = 6408,
  [SMALL_STATE(143)] = 6429,
  [SMALL_STATE(144)] = 6451,
  [SMALL_STATE(145)] = 6471,
  [SMALL_STATE(146)] = 6490,
  [SMALL_STATE(147)] = 6509,
  [SMALL_STATE(148)] = 6528,
  [SMALL_STATE(149)] = 6547,
  [SMALL_STATE(150)] = 6569,
  [SMALL_STATE(151)] = 6580,
  [SMALL_STATE(152)] = 6591,
  [SMALL_STATE(153)] = 6600,
  [SMALL_STATE(154)] = 6610,
  [SMALL_STATE(155)] = 6618,
  [SMALL_STATE(156)] = 6625,
  [SMALL_STATE(157)] = 6630,
  [SMALL_STATE(158)] = 6635,
  [SMALL_STATE(159)] = 6642,
  [SMALL_STATE(160)] = 6649,
  [SMALL_STATE(161)] = 6654,
  [SMALL_STATE(162)] = 6661,
  [SMALL_STATE(163)] = 6668,
  [SMALL_STATE(164)] = 6673,
  [SMALL_STATE(165)] = 6678,
  [SMALL_STATE(166)] = 6685,
  [SMALL_STATE(167)] = 6690,
  [SMALL_STATE(168)] = 6694,
  [SMALL_STATE(169)] = 6698,
  [SMALL_STATE(170)] = 6702,
  [SMALL_STATE(171)] = 6706,
  [SMALL_STATE(172)] = 6710,
  [SMALL_STATE(173)] = 6714,
  [SMALL_STATE(174)] = 6718,
  [SMALL_STATE(175)] = 6722,
  [SMALL_STATE(176)] = 6726,
  [SMALL_STATE(177)] = 6730,
  [SMALL_STATE(178)] = 6734,
  [SMALL_STATE(179)] = 6738,
  [SMALL_STATE(180)] = 6742,
  [SMALL_STATE(181)] = 6746,
  [SMALL_STATE(182)] = 6750,
  [SMALL_STATE(183)] = 6754,
  [SMALL_STATE(184)] = 6758,
  [SMALL_STATE(185)] = 6762,
  [SMALL_STATE(186)] = 6766,
  [SMALL_STATE(187)] = 6770,
  [SMALL_STATE(188)] = 6774,
  [SMALL_STATE(189)] = 6778,
  [SMALL_STATE(190)] = 6782,
  [SMALL_STATE(191)] = 6786,
  [SMALL_STATE(192)] = 6790,
  [SMALL_STATE(193)] = 6794,
  [SMALL_STATE(194)] = 6798,
  [SMALL_STATE(195)] = 6802,
  [SMALL_STATE(196)] = 6806,
  [SMALL_STATE(197)] = 6810,
  [SMALL_STATE(198)] = 6814,
  [SMALL_STATE(199)] = 6818,
  [SMALL_STATE(200)] = 6822,
  [SMALL_STATE(201)] = 6826,
  [SMALL_STATE(202)] = 6830,
  [SMALL_STATE(203)] = 6834,
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0),
  [5] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(124),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(149),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(201),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(192),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(187),
  [39] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(203),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(180),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(176),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(177),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(182),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(131),
  [57] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_list, 1),
  [59] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(12),
  [62] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(81),
  [65] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(10),
  [68] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(10),
  [71] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(124),
  [74] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(124),
  [77] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(52),
  [80] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(149),
  [83] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(201),
  [86] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(192),
  [89] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(86),
  [92] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(187),
  [95] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(2),
  [98] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_statement_list_repeat1, 2),
  [100] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(203),
  [103] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(180),
  [106] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(176),
  [109] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(177),
  [112] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(5),
  [115] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(182),
  [118] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_list_repeat1, 2), SHIFT_REPEAT(131),
  [121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [123] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unary_expression, 1),
  [125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unary_expression, 1),
  [127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [131] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__postfix_expression, 2),
  [133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__postfix_expression, 2),
  [135] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_expression, 1),
  [137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_expression, 1),
  [141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_expression, 3),
  [143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_expression, 3),
  [145] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__postfix_expression, 3),
  [147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__postfix_expression, 3),
  [149] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__postfix_expression, 4),
  [151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__postfix_expression, 4),
  [153] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__multiplicative_expression, 1),
  [155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__multiplicative_expression, 1),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(135),
  [159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [161] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unary_expression, 2),
  [163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unary_expression, 2),
  [165] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__additive_expression, 3),
  [167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__additive_expression, 3),
  [169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(128),
  [173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__multiplicative_expression, 3),
  [175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__multiplicative_expression, 3),
  [177] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__additive_expression, 1),
  [179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__additive_expression, 1),
  [181] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_start, 5),
  [183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_start, 5),
  [185] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_start, 4),
  [187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_start, 4),
  [189] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__shift_expression, 3),
  [191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__shift_expression, 3),
  [193] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__relational_expression, 1),
  [195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__relational_expression, 1),
  [197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(119),
  [201] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__relational_expression, 3),
  [203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__relational_expression, 3),
  [205] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__equality_expression, 1),
  [207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__equality_expression, 1),
  [209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(115),
  [211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [213] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__equality_expression, 3),
  [215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__equality_expression, 3),
  [217] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__and_expression, 1),
  [219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__and_expression, 1),
  [221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [223] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__and_expression, 3),
  [225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__and_expression, 3),
  [227] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exclusive_or_expression, 1),
  [229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exclusive_or_expression, 1),
  [231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(107),
  [233] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exclusive_or_expression, 3),
  [235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exclusive_or_expression, 3),
  [237] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__inclusive_or_expression, 3),
  [239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inclusive_or_expression, 3),
  [241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [243] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__inclusive_or_expression, 1),
  [245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inclusive_or_expression, 1),
  [247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 3),
  [249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 3),
  [251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 2),
  [253] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 2),
  [255] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__logical_and_expression, 1),
  [257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__logical_and_expression, 1),
  [259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(100),
  [261] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__logical_and_expression, 3),
  [263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__logical_and_expression, 3),
  [265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 3),
  [267] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 3),
  [269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__conditional_expression, 5),
  [271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__conditional_expression, 5),
  [273] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__assignment_expression, 3),
  [275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assignment_expression, 3),
  [277] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__logical_or_expression, 3),
  [279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__logical_or_expression, 3),
  [281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__logical_or_expression, 1),
  [285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__logical_or_expression, 1),
  [287] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__jump_statement, 3),
  [289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__jump_statement, 3),
  [291] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iteration_statement, 2),
  [293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iteration_statement, 2),
  [295] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_selection_statement, 2),
  [297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_selection_statement, 2),
  [299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(65),
  [301] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_blank_error, 1),
  [303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_blank_error, 1),
  [305] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 3),
  [307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 3),
  [309] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2),
  [311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2),
  [313] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__conditional_expression, 1),
  [315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__conditional_expression, 1),
  [317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [321] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement, 1),
  [323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1),
  [325] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 2),
  [327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 2),
  [329] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1),
  [331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1),
  [333] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iteration_statement, 6),
  [335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iteration_statement, 6),
  [337] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labelled_statement, 1),
  [339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labelled_statement, 1),
  [341] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__jump_statement, 2),
  [343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__jump_statement, 2),
  [345] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_start, 4),
  [347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_start, 4),
  [349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_start, 6),
  [351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_start, 6),
  [353] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_start, 4),
  [355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_start, 4),
  [357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_start, 4),
  [359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_start, 4),
  [361] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_else_start, 3),
  [363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_else_start, 3),
  [365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__shift_expression, 1),
  [373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [375] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__shift_expression, 1),
  [377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(123),
  [387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(118),
  [393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(114),
  [395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [397] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1),
  [399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [401] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2),
  [403] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(103),
  [406] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(149),
  [409] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(201),
  [412] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(200),
  [415] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(199),
  [418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(108),
  [422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(101),
  [426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [436] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_start, 1),
  [438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_start, 1),
  [440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_parameter_list_repeat1, 2),
  [442] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_parameter_list_repeat1, 2), SHIFT_REPEAT(149),
  [445] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_parameter_list_repeat1, 2), SHIFT_REPEAT(201),
  [448] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_parameter_list_repeat1, 2), SHIFT_REPEAT(192),
  [451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_parameter_list, 1),
  [453] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_start_start, 2),
  [455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_start_start, 2),
  [457] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_operator, 1),
  [459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_operator, 1),
  [461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preprocessor_directive, 1),
  [465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 2),
  [467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__preprocessor_include, 2),
  [469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_parameter_declaration, 2),
  [471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_definition, 6),
  [475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_parameter_list_repeat1, 1),
  [477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_parameter_declaration, 4),
  [481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration_list, 2),
  [483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 3),
  [485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration_list, 1),
  [487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__init_declarator_identifier, 1),
  [495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__init_declarator, 1),
  [497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__init_declarator_list, 3),
  [505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__init_declarator, 3),
  [507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_specifier, 2),
  [509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declarator_list, 3),
  [513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_expression_list, 3),
  [521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declarator_list, 1),
  [523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_expression_list, 1),
  [529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declarator, 4),
  [537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declarator, 5),
  [557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qualified_type_specifier, 2),
  [571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_expression, 1),
  [579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [583] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_specifier, 1),
  [591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_nwscript(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .symbol_names = ts_symbol_names,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const uint16_t *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .field_count = FIELD_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .small_parse_table = (const uint16_t *)ts_small_parse_table,
    .small_parse_table_map = (const uint32_t *)ts_small_parse_table_map,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .state_count = STATE_COUNT,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
